/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*  gݍ݂ŌfI													*/
/*  炭E̎݁BȁH											*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"		/*̊֐̊OQƂAɋLqǉ܂B*/
#include	"comm.h"
#include	"ntp.h"

/********************************************************************/
/*	bZ[W̕ۑ̈ƁA݁AǍCfbNXƁAbZ[W	*/
/*	ԍ															*/
/********************************************************************/
#define		RECORD_SZ	32
#define		MESSAGE_SZ	162
#define		MSG_FIELD_SZ	(MESSAGE_SZ + sizeof("<P>No.12345678 from 123.456.789.012 2004/12/31 23:59:59\r\n<br>Message:\r\n"))

static struct
{
	char			msg[ MSG_FIELD_SZ ];
	long			number;
	unsigned long	dip;
} WebMsg[RECORD_SZ];

static	int		w_index = 0;
static	int		r_index = 0;
static	long	count = 0;

/********************************************************************/
/*	IPAhX̉H                                                */
/*	IP𐮌`Ĉꌩł͔ʂłȂlɂB            */
/*	ӁĨZLeB͊Sł͖B                          */
/*	ƌA\[XJĂ鎞_ŃZLeB͖낤B    */
/*	aVȃASYWB                                      */
/********************************************************************/
extern char	BuildNumber[];

unsigned char *RandomIPAddress( unsigned char ip[] )
{
	char	buf[11];

	buf[ sizeof(buf) - 1 ] = '\0';

	memcpy( buf, &BuildNumber[0], 10 );
	(*(long *)ip) = (*(long *)ip) ^ atol( buf );

	memcpy( buf, &BuildNumber[1], 10 );
	(*(long *)ip) = (*(long *)ip) ^ atol( buf );

	memcpy( buf, &BuildNumber[2], 10 );
	(*(long *)ip) = (*(long *)ip) ^ atol( buf );

	memcpy( buf, &BuildNumber[4], 10 );
	(*(long *)ip) = (*(long *)ip) ^ atol( buf );

	return ip;
}

/********************************************************************/
/*	CGIs:Ȍo												*/
/********************************************************************/
static int MessageDisplay( TcpAddressAndPortInformation *info )
{
	int		i;

	/*烁bZ[W̓ǂݏoBtɓǂݏosB*/
	i = w_index;
	while( i != r_index )
	{
		if( --i < 0 ) i = RECORD_SZ - 1;	/*t񂵂̏z*/
		/*bZ[W̕\*/
		if( TCPwrite( info, WebMsg[i].msg, strlen( WebMsg[i].msg ) ) < EOF )
		{
			TCPForceCloseState( info );	/*I*/
			return EOF;
		}
	}
	return 0;
}

/********************************************************************/
/*	tH[\s:												*/
/********************************************************************/
static int FormDisplay( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	int		ret;
	static const char PageTop[] =
	{
		"<center>"
		"<h3>Navajo Web Board!</h3><br>"
		"</center>\r\n"
	};

	static const char FormTop[] =
	{
		"<center>"
		"<form method=\"GET\" action=\"bbs.cgi\">\r\n"
		"Please Input your message but less than 160 characters.<br>\r\n"
		"<input type=\"text\" size=\"160\" name=\"string\"><br>\r\n"
		"<input type=\"submit\" value=\"Read or Write Message\">"
		"<input type=\"reset\" value=\"Clear Message\">\r\n"
		"</form>"
		"</center>\r\n"
	};

	/*BBSy[Wgbv\*/
	if( TCPwrite( info, (void *)PageTop, sizeof(PageTop) - 1 ) < EOF )
	{
		TCPForceCloseState( info );
		return EOF;
	}

	/*BBS̋L̈ɑ΂r*/
	wai_sem( SEMID_BBS );
	/*烁bZ[W̓ǂݏoBtɓǂݏosB*/
	ret = MessageDisplay( info );
	/*BBS̋L̈ɑ΂r̉*/
	sig_sem( SEMID_BBS );
	if( ret == EOF ) return ret;

	/*BBS݃tH[\*/
	if( TCPwrite( info, (void *)FormTop, sizeof(FormTop) - 1 ) < EOF )
	{
		TCPForceCloseState( info );
		return EOF;
	}

	/*ɏIB*/
	return 0;
}

/********************************************************************/
/*	CGIs:Web Board												*/
/*	http://192.168.100.200:8080/bbs.cgi?string={͂ǂȁH	*/
/********************************************************************/
static int CGIbbs( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	int		i;
	char	*ptr,*buf;
	unsigned char	your_ip[4];
#ifdef __SNTP_USE__	/*[JłAC^[lbgłǂ̂ŁANTPT[o[ɐڑł鎞B*/
	char	date_str[ (((sizeof("2004/12/31 23:59:59\r") - 1) / 4) + 1) * 4 ];
#endif	/*__SNTP_USE__*/
	static const char HtmlHead[] =
	{
		"<html lang=\"ja\"><head>\r\n"
		"<meta HTTP-EQUIV=\"Content-type\" CONTENT=\"text/html; charset=Shift_JIS\">\r\n"
		"<title>The Embedded Protocol Engine Navajo Micom BBS.</title></head>\r\n"
		"<body bgcolor=\"#ccffcc\">\r\n"
		"<img src=\"http://hamayan.ddo.jp/~hamayan/so-net/image/access112.img\" width=\"1\" height=\"1\">\r\n"
		"<center><h3>The Embedded Protocol Engine</h3>\r\n"
		"<h1><font color=\"#00cc00\">Navajo</font><font size=\"1\">ver." NAVAJO_VERSION "</font></h1></center>\r\n"
		"<center><img src=\"./image/navajo.png\" alt=\"Navajo DEMO\"></center>\r\n"
	};

	static const char HtmlPostForm[] =
	{
		"<center><a href=\"./index.html\"><font size=\"+1\">Back</font></a></center>\r\n"
		"Project HOS URL:<a href=\"https://sourceforge.jp/projects/hos/\">https://sourceforge.jp/projects/hos/</a><br>\r\n"
		"NAVAJO URL:<a href=\"http://www003.upp.so-net.ne.jp/hamayan/\">http://www003.upp.so-net.ne.jp/hamayan/</a><br>\r\n"
		"<font size=\"-1\">designed by hamayan</font><br>\r\n"
		"</body></html>\r\n\r\n"
	};

	/*^*/
	if( TCPwrite( info, (void *)HtmlHead, sizeof(HtmlHead) - 1 ) < EOF ) return EOF;

	/*P = ȍ~̕擾B*/
	ptr = strchr( argv[RQUEST_URL], '=' );
	ptr++;

	/*BBS̋L̈ɑ΂r*/
	wai_sem( SEMID_BBS );
	/*ȍ~ɕΒPɎQƂƂ݂ȂAւ̕ۑ͍sȂB*/
	if( *ptr != '\0' )
	{
		/*Ԗڂ̃bZ[WL^B*/
		WebMsg[ w_index ].number = ++count;
		/*IPAhXL^Bɓ̃AhXtB^[}ƗǂB*/
		WebMsg[ w_index ].dip = *((unsigned long *)&info->dip[0]);

		/*QbyteR[hBinaryɕϊsȂ烁ɕۑB*/
		buf = (char *)GetMemBlock( MSG_FIELD_SZ );	/*L؂o*/

		/*IPAhXBB*/
		IP_COPY( your_ip, info->dip );
		/*ȒPIPAhXBB*/
		RandomIPAddress( your_ip );
		for( i = 0; i < sizeof(your_ip); i++ ) your_ip[i] = your_ip[i] / 4 + '0';

#ifdef __SNTP_USE__	/*[JłAC^[lbgłǂ̂ŁANTPT[o[ɐڑł鎞B*/
		/*bZ[W̍쐬*/
		sprintf
		(
			WebMsg[w_index].msg, "<P>No.%ld from %c%c%c%c %s\n<br>Message:%s\r\n",
			count,
			your_ip[0], your_ip[1], your_ip[2], your_ip[3],
			Str2DateTime( SecsFrom1900(), date_str ),
			WebDecode2Binary( buf, ptr, MESSAGE_SZ )
		);
#else	/*NTPT[o[ɂڑłȂB*/
		/*bZ[W̍쐬*/
		sprintf
		(
			WebMsg[w_index].msg, "<P>No.%ld from %c%c%c%c \n<br>Message:%s\r\n",
			count,
			your_ip[0], your_ip[1], your_ip[2], your_ip[3],
			WebDecode2Binary( buf, ptr, MESSAGE_SZ )
		);
#endif	/*__SNTP_USE__*/

		RelMemBlock( (VP)buf );	/*L̕ԋp*/

		/*CfbNX̍XV*/
		if( ++w_index == RECORD_SZ ) w_index = 0;	/*̗̈ֈړ*/
		if( w_index == r_index ) r_index++;		/*ǂݍ݈ʒui߂B*/
		if( r_index == RECORD_SZ ) r_index = 0;	/*̗̈ֈړ*/
	}
	/*BBS̋L̈ɑ΂r̉*/
	sig_sem( SEMID_BBS );

	/*tH[\*/
	if( FormDisplay( info, argc, argv ) == EOF ) return EOF;

	/*^*/
	if( TCPwrite( info, (void *)HtmlPostForm, sizeof(HtmlPostForm) - 1 ) < EOF ) return EOF;

	return 0;
}

const FILE_PROPERTIES bbs_cgi =
{
	"bbs.cgi",
	"2004/ 7/15 23:29:00",
	CGIbbs,
	(void *)0,
	"designed by hamayan.",
	(void *)0,
	0,
};

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/* ------------------------------------------------------------------------ */
