/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*  cmr`R[h擾AvP[VłB					*/
/*  tɂ͑ΉĂ܂B											*/
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"

/********************************************************************/
/*	tH[\s:												*/
/********************************************************************/
static int FormDisplay( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	static const char FormTop[] =
	{
		"<center>"
		"<form method=\"GET\" action=\"dns.cgi\">Write Query Domain Name.<br>\r\n"
		"<input type=\"text\" size=\"64\" name=\"string\"><br>"
		"<input type=\"submit\">"
		"<input type=\"reset\">"
		"</form>"
		"</center>\r\n"
		"<center><a href=\"./index.html\"><font size=\"+1\">Back</font></a></center><br>\r\n"
	};

	/*DNS݃tH[\*/
	if( TCPwrite( info, (void *)FormTop, sizeof(FormTop) - 1 ) < EOF )
	{
		TCPForceCloseState( info );
		return EOF;
	}
	return 0;
}

/********************************************************************/
/*	CGIs:DNS`R[h擾									*/
/*	http://192.168.100.200:8080/dns.cgi?string=hamayan.ddo.jp		*/
/********************************************************************/
int getaddrbydns( char *dname , unsigned char addr[], int handle);

int CGIdns( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	char	*ptr;
	unsigned char addr[4];
	int		i,ret;
	VP		status,result;
	MESSAGE_LIST list[5];		/*I[HTTPbZ[W̔z*/

	static const char HtmlHead[] =
	{
		"<html lang=\"ja\"><head>\r\n"
		"<meta HTTP-EQUIV=\"Content-type\" CONTENT=\"text/html; charset=Shift_JIS\">\r\n"
		"<title>The Embedded Protocol Engine Navajo Domain Name Query.</title></head>\r\n"
		"<body bgcolor=\"#ccffcc\">\r\n"
		"<img src=\"http://hamayan.ddo.jp/~hamayan/so-net/image/access112.img\" width=\"1\" height=\"1\">\r\n"
		"<center><h3>The Embedded Protocol Engine</h3>\r\n"
		"<h1><font color=\"#00cc00\">Navajo</font><font size=\"1\">ver." NAVAJO_VERSION "</font></h1></center>\r\n"
		"<center><img src=\"./image/navajo.png\" alt=\"Navajo DEMO\"></center>\r\n"
	};

	static const char ResultMsg[] =
	{
		"<center>"
		"<h3><font color=\"#0000cc\">"
		"Query Result is"
		"</font></h3>"
		"</center>"
	};

	static const char TableTop[] =
	{
		"<center>"
		"<table border=\"1\">"
		"<tr><td>\r\n"
	};

	static const char TableBottom[] =
	{
		"</td></tr>"
		"</table>"
		"</center>\r\n"
	};

	char	*errs[] =
	{
		"too long domainname.",
		"bad id of respond packet.",
		"bad answer.",
		"UDP packet send failure.",
		"fail to make UDP socket.",
	};

	/*^*/
	if( TCPwrite( info, (void *)HtmlHead, sizeof(HtmlHead) - 1 ) < EOF ) return EOF;

	/*L̊l*/
	status = GetMemBlock( 128 );
	result = GetMemBlock( 128 );

	/*̌ʂ߂*/
	ptr = strchr( argv[RQUEST_URL], '=' );	/*P = ȍ~̕擾B*/
	ptr++;
	*((char *)status) = '\0';
	if ( ( ret = getaddrbydns( ptr, addr, 1)) < 0)
	{
		/* ڂ͗LAR[hLbVĂȂΎs */
		if ( ( ret = getaddrbydns( ptr, addr, 1)) < 0)
		{
			sprintf( (char *)status, "<font color=\"#cc0000\">%s", errs[-1-ret] );
			strcat( (char *)status, "<br>\r\n" );
			strcat( (char *)status, "lookup failure.</font><br>\r\n" );
		}
	}

	/*sĂ鎞̓AhX͕\ȂB*/
	if( ret >= 0 )
		sprintf( (char *)result, "<font color=\"#0000cc\">%u.%u.%u.%u</font><br>\r\n", addr[0],addr[1],addr[2],addr[3] );
	else
		*((char *)result) = '\0';

	/*bZ[WXg̐B*/
	list[0].msg = (char *)ResultMsg;
	list[0].size = sizeof(ResultMsg) - 1;
	list[1].msg = (char *)TableTop;
	list[1].size = sizeof(TableTop) - 1;
	list[2].msg = (char *)status;
	list[2].size = strlen((char *)status);
	list[3].msg = (char *)result;
	list[3].size = strlen((char *)result);
	list[4].msg = (char *)TableBottom;
	list[4].size = sizeof(TableBottom) - 1;

	/*bZ[W̏o*/
	for( i = 0; i < sizeof(list) / sizeof(list[0]); i++ )
	{
		if( TCPwrite( info, (void *)list[i].msg, list[i].size ) < EOF ) break;	/*MG[́A[vIB*/
	}

	/*L̕ԋp*/
	RelMemBlock( status );
	RelMemBlock( result );

	if( i != ( sizeof(list) / sizeof(list[0]) ) ) return EOF;	/*Mso*/

	/*DNS݃tH[\*/
	return FormDisplay( info, argc, argv );
}

const FILE_PROPERTIES dns_cgi =
{
	"dns.cgi",
	"2004/ 7/12 23:07:00",
	CGIdns,
	(void *)0,
	"designed by hamayan.",
	(void *)0,
	0,
};

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
