/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*  ʏAWEBT[o[Ȃ畽sT[o[ŃNGXg󂯕t܂A		*/
/*  vÓAT[o[ŎsĂ܂BTCPZbVɁAʂ	*/
/*  NGXg󂯂ꍇ̏Ă܂̂ŁAxɂPNGXg	*/
/*  œĉB													*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"

int EEP_Puts( unsigned char add, char *s );

/********************************************************************/
/*	tH[\s:												*/
/********************************************************************/
static int FormDisplay( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
#define	FORMTOP1	"<center>" \
					"<form method=\"GET\" action=\"eeprom.cgi\">"

#define	FORMTOP2	"<br>\r\n" \
					"<input type=\"text\" size=\"128\" name=\"string\"><br>" \
					"<input type=\"submit\">" \
					"<input type=\"reset\">" \
					"</form>" \
					"</center>\r\n"

	int		i;
	static const MESSAGE_LIST list[] =
	{
		{ FORMTOP1, sizeof(FORMTOP1) - 1},
		{ FORMTOP2,	sizeof(FORMTOP2) - 1},
	};

	/*EEPROM݃tH[\*/
	for( i = 0; i < sizeof(list) / sizeof(list[0]); i++ )
	{
		if( TCPwrite( info, (void *)list[i].msg, list[i].size ) < EOF ) break;	/*MG[́A[vIB*/
	}

	if( i == ( sizeof(list) / sizeof(list[0]) ) ) return 0;	/*I*/
	else return EOF;	/*ُI*/
}

/********************************************************************/
/*	CGIs:URL EEPROM												*/
/********************************************************************/
int UrlEeprom( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	/*^*/
	if( NavajoPreForm( info, argc, argv ) == EOF ) return EOF;
	/*EEPROM݃tH[\*/
	if( FormDisplay( info, argc, argv ) == EOF ) return EOF;
	/*y[Wgbvւ̃N̕\*/
	if( NavajoPageTopLink( info, argc, argv ) == EOF ) return EOF;
	/*^*/
	return NavajoPostForm( info, argc, argv );
}

/********************************************************************/
/*	CGIs:EEPROM													*/
/*	http://192.168.100.200:8080/eeprom.cgi?string=abcdefg			*/
/********************************************************************/
int CGIeeprom( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	char	*ptr,*str;
	char	*rbuf = (char *)GetMemBlock( 128 );
	int		OnOff;
	static const char EEPROMWriteOK[] = "<center><h2>Write OK</h2></center><br>\r\n";
	static const char EEPROMWriteNG[] = "<center><h2>Write NG</h2></center><br>\r\n";

	/*^*/
	if( NavajoPreForm( info, argc, argv ) == EOF ) return EOF;

	/*P = ȍ~̕擾B*/
	ptr = strchr( argv[RQUEST_URL], '=' );
	ptr++;

	/*̐`FbN*/
	if( strncmp(ptr, "ifconfig", sizeof("ifconfig") -1 ) == 0 )
	{
		str = ptr;
		while( *str != '\0' ) *str++ = (*str == '+') ? ' ' : *str;	/*+Xy[Xɕϊ*/
		EEP_Puts( (unsigned char)0, ptr );	/*E2PROM֏*/
		EEP_Gets( 0, rbuf );
		if( strcmp( ptr, rbuf ) == 0 )
		{
			if( TCPwrite( info, (void *)EEPROMWriteOK, sizeof(EEPROMWriteOK) - 1 ) < EOF ) TCPForceCloseState( info );
		}
		else
		{
			if( TCPwrite( info, (void *)EEPROMWriteNG, sizeof(EEPROMWriteNG) - 1 ) < EOF ) TCPForceCloseState( info );
		}
	}

	RelMemBlock( (VP)rbuf );

	/*EEPROM݃tH[\*/
	if( FormDisplay( info, argc, argv ) == EOF ) return EOF;
	/*y[Wgbvւ̃N̕\*/
	if( NavajoPageTopLink( info, argc, argv ) == EOF ) return EOF;
	/*^*/
	return NavajoPostForm( info, argc, argv );
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
