/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*  ʏAWEBT[o[Ȃ畽sT[o[ŃNGXg󂯕t܂A		*/
/*  vÓAT[o[ŎsĂ܂BTCPZbVɁAʂ	*/
/*  NGXg󂯂ꍇ̏Ă܂̂ŁAxɂPNGXg	*/
/*  œĉB													*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"
#include	"comm.h"

static const char HtmlPreForm[] =
{
	"<center><h3>The Embedded Protocol Engine</h3>\r\n"
	"<h1><font color=\"#00cc00\">Navajo</font><font size=\"1\">ver." NAVAJO_VERSION "</font></h1></center>\r\n"
};

static const char HtmlForm[] =
{
	"<center>"
	"<form method=\"GET\" action=\"memdump.cgi\">Write Dump Address. But Only use Hexadecimal.<br>\r\n"
	"<input type=\"text\" size=\"32\" name=\"string\"><br>"
	"<input type=\"submit\">"
	"<input type=\"reset\">"
	"</form>"
	"</center>\r\n"
	"<center><a href=\"./index.html\"><font size=\"+1\">Back</font></a></center>\r\n"
};

static const char HtmlPostForm[] =
{
	"Project HOS URL:<a href=\"https://sourceforge.jp/projects/hos/\">https://sourceforge.jp/projects/hos/</a><br>\r\n"
	"NAVAJO URL:<a href=\"http://www003.upp.so-net.ne.jp/hamayan/\">http://www003.upp.so-net.ne.jp/hamayan/</a><br>\r\n"
	"<font size=\"-1\">designed by hamayan</font><br>\r\n"
	"</body></html>\r\n\r\n"
};

static void *ASCII2Address( char *source, void *adr );
static void *MakeDumpList( char *dest, char *adr, int web );

/********************************************************************/
/*	CGIs:Memory Dump												*/
/*	http://192.168.100.200:8080/memdump.cgi?string=ffff00			*/
/********************************************************************/
static int CGIdump( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	char	*ptr;
	int		i;
	VP		adr,blk,next_blk;
	MESSAGE_LIST list[ 4 ];		/*HTTPbZ[W̔z*/

	static const char TableTop[] =
	{
		"<center>"
		"<table border=\"1\">"
		"<tr><td>\r\n"
	};

	static const char TableBottom[] =
	{
		"</td></tr>"
		"</table>"
		"</center>\r\n"
	};

	static const char UrlBase[] = "<a href=\"./memdump.cgi?string=";
	static const char UrlPrev[] = "\">Prev</a>";
	static const char UrlNext[] = "\">Next</a>";

	/*^*/
	if( TCPwrite( info, (void *)HtmlPreForm, sizeof(HtmlPreForm) - 1 ) < EOF ) return EOF;

	/*LDUMPXgp̃̊lƁALINKp̃̊lB*/
    get_mpf( MPID_TUTORIAL2, &blk );
	next_blk = GetMemBlock( 128 );

	/*DUMP LIST̐*/
	ptr = strchr( argv[RQUEST_URL], '=' );	/*P = ȍ~̕擾B*/
	ptr++;
	adr = ASCII2Address( ptr, (void *)0 );	/*ASCIIAhXϊsB*/
	adr = MakeDumpList( (char *)blk, adr, 1 );

	/*PrevANext̕\*/
	ptr = (char *)next_blk;
	strcpy( ptr, "<center>" );
	strcat( ptr, UrlBase );
	ptr = strchr( ptr, '\0' );
	sprintf( ptr, "%08lX", (unsigned long)((char *)adr - 0x200) );
	strcat( ptr, UrlPrev );
	strcat( ptr, "&nbsp;" );
	strcat( ptr, UrlBase );
	ptr = strchr( ptr, '\0' );
	sprintf( ptr, "%08lX", (unsigned long)adr );
	strcat( ptr, UrlNext );
	strcat( ptr, "</center><br>\r\n" );

	/*bZ[WXg̐B*/
	list[0].msg = (char *)TableTop;
	list[0].size = sizeof(TableTop) - 1;
	list[1].msg = (char *)blk;
	list[1].size = strlen((char *)blk);
	list[2].msg = (char *)TableBottom;
	list[2].size = sizeof(TableBottom) - 1;
	list[3].msg = (char *)next_blk;
	list[3].size = strlen((char *)next_blk);

	/*bZ[W̏o*/
	for( i = 0; i < sizeof(list) / sizeof(list[0]); i++ )
	{
		if( TCPwrite( info, (void *)list[i].msg, list[i].size ) < EOF ) break;	/*MG[́A[vIB*/
	}

	/*L̊J*/
    rel_mpf( MPID_TUTORIAL2, blk );
	RelMemBlock( next_blk );

	if( i != ( sizeof(list) / sizeof(list[0]) ) ) return EOF;	/*Mso*/

	/*݃tH[\*/
	if( TCPwrite( info, (void *)HtmlForm, sizeof(HtmlForm) - 1 ) < EOF ) return EOF;
	/*^*/
	if( TCPwrite( info, (void *)HtmlPostForm, sizeof(HtmlPostForm) - 1 ) < EOF ) return EOF;

	return 0;
}

const FILE_PROPERTIES memdump_cgi =
{
	"memdump.cgi",
	"2004/ 7/ 7 23:29:00",
	CGIdump,
	(void *)0,
	"designed by hamayan",
	(void *)0,
	1373,
};

/********************************************************************/
/*	CUIs:Memory Dump												*/
/*	̊֐̓Gggł͖B								*/
/********************************************************************/
void CUIdump( int argc, char *argv[], int handle )
{
	static VP	adr = (VP)0;	/*l*/
	VP		blk;

	/*p[^[̐AAAhXw肩𔻒fB*/
	if( argc == 1 ){}
	else if( argc == 2 )
	{
		/*ASCIIAhXϊsB*/
		adr = ASCII2Address( argv[1], (void *)0 );
	}
	else return;

	/*L̎؂o*/
    get_mpf( MPID_TUTORIAL2, &blk );
	/*DUMP LIST̐*/
	adr = MakeDumpList( (char *)blk, adr, 0 );
	/*DUMP LIST̕\*/
	SCI_Puts( handle, (const char *)blk );
	/*L̕ԋp*/
	RelMemBlock( blk );
}

/********************************************************************/
/*	ASCII|AhXϊ											*/
/********************************************************************/
static void *ASCII2Address( char *source, void *adr )
{
	int		i;

	/*ASCIIAhXϊsB*/
	for( i = 0; i < 32; i += 4 )
	{
		if( isdigit( *source ) || (*source >= 'A' && *source <= 'F') || (*source >= 'a' && *source <= 'f') )
		{
			adr = (VP)(((unsigned long)adr) << 4);
			adr = ( isdigit(*source) ) ? (VP)((char *)adr + (*source - '0')) : (VP)((char *)adr + ((*source | 0x20) - 'a' + 10));
		}
		else break;
		source++;
	}

	return adr;
}

/********************************************************************/
/*	Dump List̐													*/
/*	dest͕̊i[AadrDUMPJnAhXAweb	*/
/*	HTTPpbZ[W𐶐鎞0ȊO̐B			*/
/********************************************************************/
static void *MakeDumpList( char *dest, char *adr, int web )
{
	int		i,j;
	char	*ptr;

	/*DUMP̕\*/
	for( i = 0, ptr = dest; i < 256; i += 16 )
	{
		/*AhX*/
		sprintf( ptr, "%08lX:", (unsigned long)adr );
		/*DUMPf[^*/
		for( j = 0; j < 16; j++ )
		{
			if( j == 8 ) strcat( ptr, ( web ) ? "&nbsp;" : " " );
			ptr = strchr( ptr, '\0' );
			sprintf( ptr, "%02X,", *((unsigned char *)adr + j) );
		}
		strcat( ptr, ( web ) ? "&nbsp;" : " " );
		/*LN^\*/
		for( j = 0; j < 16; j++ )
		{
			if( j == 8 ) strcat( ptr, ( web ) ? "&nbsp;" : " " );
			ptr = strchr( ptr, '\0' );
			sprintf( ptr, "%c", ( isprint(*((char *)adr + j)) ) ? *((char *)adr + j) : '.' );
		}
		/*s*/
		strcat( ptr, ( web ) ? "<br>\r\n" : "\r\n" );
		ptr = strchr( ptr, '\0' );
		/*̕\AhX߂B*/
		adr = (VP)((char *)adr + 16);
	}

	return adr;
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
