/* ------------------------------------------------------------------------ */
/*  SYSLOGM                                                              */
/*                                                                          */
/*                                  Copyright (C) 2004- by hamayan          */
/*                                  webmaster@hamayan.zive.net              */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"udp.h"
#include	"util.h"
#include	"syslog.h"
#include	"rtl8019.h"			/*RTL8019ASŗL̒`*/

unsigned short Cntr2Read( volatile union RTL8019AS *eth );

/********************************************************************/
/*	UDPpTv												*/
/*	loǵAOi[\́Bhandle͕Wo͂̃nh	*/
/*	߂ĺAM̃G[R[hA܂萬ꍇ0ԂA	*/
/*	s͕̒lԂB										*/
/*	S̒1024bytez鎞́AEOFԂB						*/
/********************************************************************/
int syslog( const SYSLOG_MSG *log )
{
	int		length,retcode;
	void	*buf;
	UdpAddressAndPortInformation info;		/*UDPڑ*/

	/*MbZ[W̗eʂvZB*/
	length = (sizeof("<123>") - 1) + 1 + 1 + (sizeof("[123]:") - 1) + 1;
		/*PRI +  +  + vZXID(^XNID)ƃVXe^C}[ + NULL*/
	length += strlen( log->DateTime );	/*tA̒߂B*/
	length += strlen( log->HostName );	/*HOST NAME܂IPAhX̒߂B*/
	length += strlen( log->msg );		/*bZ[W̒߂B*/
	if( length > 1024 ) return EOF;

	/*obt@̈̎؂o*/
	buf = GetMemBlock( length );
	/*SYSLOGbZ[W̐*/
	sprintf
	(
		buf,
		"<%u>%s %s [%d]:%s",
		(log->facility << 3) | log->severity,	/*facilityseverity*/
		log->DateTime,		/*tƎ*/
		log->HostName,		/*zXgIPAhX*/
		log->tid,			/*^XNID*/
		log->msg			/*ObZ[W*/
	);

	/*\Pbg̐*/
	if( (retcode = UDPsocket( &info )) == 0 )
	{
		/*IPAhXA|[gԍ̐ݒ*/
		IP_COPY( info.dip, log->dip );	/*IPAhX̎w*/
		info.dport = ( log->dport == 0 ) ? SYSLOG : log->dport;	/*|[gԍ*/
		info.sport = SYSLOG;	/*|[gԍ*/
		info.DataSz = strlen( buf );	/*Mf[^*/
		info.data = buf;
		/*bind*/
		UDPbind( &info );
		/*M*/
		if( (retcode = UDPsendto( &info )) == 0 )
		{
			/*M*/
			info.tmout = 1000;	/*MɁAICMP̎MM\B̑҂Ԃ́AICMP󂯓鎞*/
			retcode = UDPrecvfrom( &info );
			if( retcode == UDP_TIMEOUT ) retcode = 0;	/*^CAEǵAAėȂ̂ŁAƌB*/
		}
		/*\Pbg̃N[Y*/
		UDPclose( &info );
	}

	RelMemBlock( buf );
	return retcode;
}

extern const VP   mknl_idl_stk;		/* idle stack */
extern const SIZE mknl_idl_stksz;	/* idle stack size */
extern const VP kernel_int_sp;		/* interrupt stack pointer */
extern VP kernel_heap_mem[];		/* kernel heap */
extern const T_KERNEL_TCB_ROM kernel_tcb_rom[];	/* task control block for rom area */

typedef struct
{
	short	tid;			/*^XNID*/
	short	id;				/*ubNID*/
	VP		blk;			/*AhX*/
} MemControlBlock;

extern MemControlBlock	mcb[];		/*݂opv[̊Ǘ̈*/
extern int	MemControlBlock_Num;	/*Ǘ̈̃e[u*/

/********************************************************************/
/*	SYSTEMXe[^XO											*/
/*	ғԁAIDLEX^bNA݃X^bN̏óACNTR2WX^	*/
/*	ǂݏoB														*/
/*	߂lɂ͐ɏI0Aُ̎EOFԂB				*/
/********************************************************************/
static int SystemLogForTimer( unsigned char severity, int handle )
{
	int		i,ercd,length;
	char	*msg;
	SYSLOG_MSG	log;
	SYSTIM	systime;
	static const char date[] = "";
	static const char host[] = "NAVAJO";

	/*SYSLOGbZ[W̐*/
	msg = (char *)GetMemBlock( 128 );
	/*VXe^C}[l̎擾*/
	get_tim( &systime );
	sprintf( msg, "TIMER %u:%lu ", systime.utime, systime.ltime );
	/*IDLE STACǨ*/
	for( i = 0; i < mknl_idl_stksz; i++ ) if( ((char *)mknl_idl_stk)[ i ] != 0 ) break;
	length = strlen(msg);
	sprintf( msg + length, "Id:%d/%ld", i, mknl_idl_stksz );
	/*INT STACǨ*/
	for( i = 0; i < 512; i++ ) if( ((char *)kernel_int_sp - 512)[ i ] != 0 ) break;
	length = strlen(msg);
	sprintf( msg + length, " In:%d/512", i );
	/*CNTR2̌*/
	length = strlen(msg);
	sprintf( msg + length, " Cntr2:%04x", Cntr2Read( (volatile union RTL8019AS *)ETH0_START_ADDRESS ) );

	log.facility = USER_LEVEL_MESSAGES;
	log.severity = severity;
	log.dport = 0;				/*|[gԍ*/
	get_tid( &log.tid );		/*^XNID*/
	log.dip = SYSLOGServer;		/*IPAhX*/
	log.DateTime = date;		/*tA̐擪AhX*/
	log.HostName = host;		/*zXg܂́AIPAhX*/
	log.msg = msg;				/*bZ[W*/

	ercd = syslog( &log );

	RelMemBlock( (VP)msg );
	return ercd;
}

/********************************************************************/
/*	SYSTEMXe[^XO											*/
/*	^XNX^bN̏óB											*/
/*	߂lɂ͐ɏI0Aُ̎EOFԂB				*/
/********************************************************************/
static int SystemLogForTaskStack( unsigned char severity, int handle )
{
	int		i,ercd,length,task;
	char	*msg;
	SYSLOG_MSG	log;
	static const char date[] = "";
	static const char host[] = "NAVAJO";

	/*SYSLOGbZ[W̐*/
	msg = (char *)GetMemBlock( 640 );
	strcpy( msg, "TASK STACK" );

	/*TASK STACǨ*/
	for( task = 0; task < TMAX_TSKID; task++ )
	{
		for( i = 0; i < kernel_tcb_rom[ task ].stksz; i++ ) if( ((char *)kernel_tcb_rom[ task ].stk)[ i ] != 0 ) break;
		length = strlen(msg);
		sprintf( msg + length, " T%d:%d/%ld", task + 1, i, kernel_tcb_rom[ task ].stksz );
	}

	log.facility = USER_LEVEL_MESSAGES;
	log.severity = severity;
	log.dport = 0;				/*|[gԍ*/
	get_tid( &log.tid );		/*^XNID*/
	log.dip = SYSLOGServer;		/*IPAhX*/
	log.DateTime = date;		/*tA̐擪AhX*/
	log.HostName = host;		/*zXg܂́AIPAhX*/
	log.msg = msg;				/*bZ[W*/

	ercd = syslog( &log );

	RelMemBlock( (VP)msg );
	return ercd;
}

/********************************************************************/
/*	SYSTEMXe[^XO											*/
/*	Lv[̏óB										*/
/*	߂lɂ͐ɏI0Aُ̎EOFԂB				*/
/********************************************************************/
static int SystemLogForSharedMPF( unsigned char severity, int handle )
{
	int		i,ercd,length;
	char	*msg;
	SYSLOG_MSG	log;
	static const char date[] = "";
	static const char host[] = "NAVAJO";

	/*SYSLOGbZ[W̐*/
	msg = (char *)GetMemBlock( 640 );
	strcpy( msg, "MEMORY POOL" );

	/*v[Ǘ̈̌*/
	for( i = 0; i < MemControlBlock_Num; i++ )
	{
		if( mcb[i].blk != (VP)0 )
		{
			length = strlen(msg);
			sprintf( msg + length, " T=%d", mcb[i].tid );
		}
	}

	log.facility = USER_LEVEL_MESSAGES;
	log.severity = severity;
	log.dport = 0;				/*|[gԍ*/
	get_tid( &log.tid );		/*^XNID*/
	log.dip = SYSLOGServer;		/*IPAhX*/
	log.DateTime = date;		/*tA̐擪AhX*/
	log.HostName = host;		/*zXg܂́AIPAhX*/
	log.msg = msg;				/*bZ[W*/

	ercd = syslog( &log );

	RelMemBlock( (VP)msg );
	return ercd;
}

/********************************************************************/
/*	SYSTEMXe[^XO											*/
/*	[{bNXp󋵂̏óB									*/
/*	߂lɂ͐ɏI0Aُ̎EOFԂB				*/
/********************************************************************/
char * ReportMailBox( char *dest );

static int SystemLogForMailBox( unsigned char severity, int handle )
{
	int		ercd;
	char	*msg;
	SYSLOG_MSG	log;
	static const char date[] = "";
	static const char host[] = "NAVAJO";

	/*SYSLOGbZ[W̐*/
	msg = (char *)GetMemBlock( 640 );
	ReportMailBox( msg );

	log.facility = USER_LEVEL_MESSAGES;
	log.severity = severity;
	log.dport = 0;				/*|[gԍ*/
	get_tid( &log.tid );		/*^XNID*/
	log.dip = SYSLOGServer;		/*IPAhX*/
	log.DateTime = date;		/*tA̐擪AhX*/
	log.HostName = host;		/*zXg܂́AIPAhX*/
	log.msg = msg;				/*bZ[W*/

	ercd = syslog( &log );

	RelMemBlock( (VP)msg );
	return ercd;
}

/********************************************************************/
/*	SYSTEMXe[^XO											*/
/*	X^bN̎gp󋵂Av[̎gp󋵂SYSLOGɓ]B*/
/*	SYSLOGT[o[͕W̃T[o[gpB							*/
/*	߂ĺA0As畉̒lԂB					*/
/*																	*/
/*	X^bN̈́A0NAĂƏɑz肵Ă	*/
/********************************************************************/
void SystemLog( int argc, char *argv[], int handle )
{
	/*syslogT[o[ݒ肳Ă鎞̂݁AbZ[W̑MsB*/
	if( SYSLOGServer[3] & ~SubNetMask[3] )
	{
		if( SystemLogForTimer( DEBUG, handle ) == 0 )
			if( SystemLogForTaskStack( DEBUG, handle ) == 0 )
				if( SystemLogForSharedMPF( DEBUG, handle ) == 0 )
					SystemLogForMailBox( DEBUG, handle );
	}
}

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 2004- by hamayan          */
/*                                  webmaster@hamayan.zive.net              */
/* ------------------------------------------------------------------------ */
