/********************************************************************/
/*	e^XNʂŎgpVXe֐								*/
/*                          Copyright (C) 1998-2002 by Project HOS  */
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#define		__SYSTEM_CFG__
#include	"nava_cfg.h"
#include	"comm.h"
#include	"system.h"

#define     _VALIABLE_MEM_BLK_USE_  /*Œ蒷ubNHEAPƂĎg*/

void ITRON4_Error_Msg( ER ercd );

/********************************************************/
/*	ǗubN									*/
/*	ubN̐擪AhXŊǗsׂ̃e[	*/
/*	u												*/
/********************************************************/
typedef struct
{
	short	tid;			/*^XNID*/
	short	id;				/*ubNID*/
	VP		blk;			/*AhX*/
} MemControlBlock;

#define	REQUIRE_BLOCKS	(VERY_SMALL_BLOCKS + SMALL_BLOCKS + MIDDLE_BLOCKS + LARGE_BLOCKS \
						+ ETH0_VERY_SMALL_BLOCKS + ETH0_SMALL_BLOCKS + ETH0_MIDDLE_BLOCKS + ETH0_LARGE_BLOCKS)
MemControlBlock		mcb[REQUIRE_BLOCKS];
int	MemControlBlock_Num = REQUIRE_BLOCKS;

/********************************************************/
/*	[{bNX݂̑o						*/
/********************************************************/
typedef struct
{
	short	valid;
	ID		mbxid;
} MBX_LEASE_TABLE;

#ifdef 	MID_VARIABLE_START	/*ÓIɃIuWFNg𐶐ꍇ*/

#define	__STATIC_MAIL_BOX_USING__
static MBX_LEASE_TABLE	MBXTable[ MBX_NUMBER ];

#else	/*IɃIuWFNg𐶐ꍇɂ́ALɂ*/

#define	__DYNAMIC_MAIL_BOX_USING__

#endif

/********************************************************/
/*	[{bNX̎gp󋵂񍐂B				*/
/********************************************************/
char * ReportMailBox( char *dest )
{
	int		i;
	char	*str = dest;

	strcpy( str, "MAIL BOX " );
	for( i = 0; i < MBX_NUMBER; i++ )
	{
		sprintf( strchr( str, '\0' ), "%d:%d,", MBXTable[i].valid, MBXTable[i].mbxid );
	}

	return dest;
}

/********************************************************/
/*	[{bNXǗubN̏					*/
/********************************************************/
ER InitMBXControlBlock( void )
{
#ifdef	__STATIC_MAIL_BOX_USING__
	int		i;

	/*[{bNXǗubN̏*/
	for( i = 0; i <= (MID_VARIABLE_END - MID_VARIABLE_START); i++ )
	{
		MBXTable[i].valid = FALSE;	/*gpƂ*/
		MBXTable[i].mbxid = i + MID_VARIABLE_START;	/*[{bNX̔ԍ̐UPn܂̂ŁFÓIɃ[{bNX𐶐ꍇɂL*/
	}
#endif
#ifdef	__DYNAMIC_MAIL_BOX_USING__
#endif
	return E_OK;
}

/********************************************************/
/*	[{bNX̃[X								*/
/*	[{bNX̂͗LȂ̂ŁAZ}gĊǗ	*/
/*	sBZ}̓^CAEg݂S		*/
/********************************************************/
ID MBXLease( void )
{
#ifdef	__STATIC_MAIL_BOX_USING__
	MBX_LEASE_TABLE		*mlt = MBXTable;
	ER	ercd;

	/*[{bNX݂o̊ǗZ}gčs*/
	ercd = twai_sem( SEMID_MBX, 1000 );
	if( ercd == E_OK )
	{
		dis_dsp();
		/*݂o󋵂̌*/
		while( mlt < &MBXTable[ MBX_NUMBER ] )
		{
			if( mlt->valid == FALSE )
			{
				mlt->valid = TRUE;
				ena_dsp();
				return mlt->mbxid;
			}
			mlt++;
		}
		ena_dsp();
		sig_sem( SEMID_MBX );
	}

	return EOF;
#endif

#ifdef	__DYNAMIC_MAIL_BOX_USING__
	T_CMBX		pk_cmbx = {TA_TFIFO | TA_MFIFO};
	ER_ID		mbxid;

	wai_sem( SEMID_MBX );
	mbxid = acre_mbx( &pk_cmbx );
	if( mbxid < 0 )
	{
		sig_sem( SEMID_MBX );
		ITRON4_Error_Msg( (ER)mbxid );
		return EOF;
	}
	return mbxid;
#endif
}

/********************************************************/
/*	[{bNX̕ԋp								*/
/*	펞0ԂAsIDAYR[h	*/
/*	ȂAEOFԂB								*/
/********************************************************/
int MBXRelease( ID mid )
{
#ifdef	__STATIC_MAIL_BOX_USING__
	MBX_LEASE_TABLE		*mlt = MBXTable;

	/*sȃ[{bNXID̃`FbN*/
	if( mid < 1 || mid > TMAX_MBXID ) return EOF;

	/*݂o󋵂̌*/
	while( mlt < &MBXTable[ MBX_NUMBER ] )
	{
		if( mlt->mbxid == mid )
		{
			mlt->valid = FALSE;
			/*[{bNX݂o̊ǗZ}gčs*/
			sig_sem( SEMID_MBX );
			return 0;
		}
		mlt++;
	}
	DebugPrint( "MBXRelease Error\r\n" );
	return EOF;
#endif

#ifdef	__DYNAMIC_MAIL_BOX_USING__

	del_mbx( mid );
	sig_sem( SEMID_MBX );
	return 0;
#endif
}

/********************************************************/
/*	ǗubN̏							*/
/********************************************************/
void InitMemControlBlock( void )
{
	MemControlBlock	*mcb_ptr = &mcb[ 0 ];
	/*ǗubN̏*/
	while( mcb_ptr < &mcb[REQUIRE_BLOCKS] ) mcb_ptr++->blk = (VP)NADR;
}

/********************************************************/
/*	ubNǗ̈DUMP						*/
/*	[U[C^tF[XĂ΂					*/
/********************************************************/
void DumpMemControlArea( int argc, char *argv[], int handle )
{
	int		index;
	char	buf[ 80 ];

	for( index = 0; index < REQUIRE_BLOCKS; index++ )
	{
		if(index & 1)
			sprintf( buf, "TID=%2d:MID=%2d:ADDR=%08lX\r\n",mcb[ index ].tid, mcb[ index ].id, (unsigned long)mcb[ index ].blk);
		else
			sprintf( buf, "TID=%2d:MID=%2d:ADDR=%08lX ,",mcb[ index ].tid, mcb[ index ].id, (unsigned long)mcb[ index ].blk );

		SCI_Puts( handle, buf );
	}
}

/********************************************************/
/*	ubNAhX烁ubNǗ̈	*/
/*	CfbNXԂB								*/
/*	Yԍ݂Ȃ́A-1ԂB				*/
/********************************************************/
#if defined(_VALIABLE_MEM_BLK_USE_)
static int ResMemControlAreaIndexNumber( MemControlBlock tbl[], VP blk )
{
	int		ret = 0;
	MemControlBlock *mcb_tbl = tbl;

	dis_dsp();
	while( mcb_tbl < &tbl[ REQUIRE_BLOCKS ] )
	{
		if( mcb_tbl->blk == blk )
		{
			mcb_tbl->blk = (VP)NADR;		/*e[ůJ*/
			if( rel_mpf( mcb_tbl->id, blk ) != E_OK ) ret = EOF;

			break;
		}
		mcb_tbl++;
	}
	ena_dsp();
	return ret;
}
#else  /*_VALIABLE_MEM_BLK_USE_*/
static int ResMemControlAreaIndexNumber( MemControlBlock tbl[], VP blk )
{
	int		ret = 0;
	MemControlBlock *mcb_tbl = tbl;
	MemControlBlock *limit = &tbl[ REQUIRE_BLOCKS ];

	dis_dsp();
	while( mcb_tbl < limit )
	{
		if( mcb_tbl->blk == blk )
		{
			mcb_tbl->blk = (VP)NADR;		/*e[ůJ*/
			if( rel_mpf( mcb_tbl->id, blk ) != E_OK ) ret = EOF;

			break;
		}
		mcb_tbl++;
	}
	ena_dsp();
	return ret;
}
#endif  /*_VALIABLE_MEM_BLK_USE_*/

/********************************************************/
/*	ubN̊J								*/
/*	blk͊YAhX								*/
/*	ԈAhXnEOFԂB				*/
/********************************************************/
int RelMemBlock( VP blk )
{
#if defined(_VALIABLE_MEM_BLK_USE_)
	return ResMemControlAreaIndexNumber( mcb, blk );
#else  /*_VALIABLE_MEM_BLK_USE_*/
  rel_mpf( MPID_IO_LARGE, blk );
#endif  /*_VALIABLE_MEM_BLK_USE_*/
}

/********************************************************/
/*	ubNo^e[ǔ					*/
/*	ɓo^ł΂OԂA-1ԂB	*/
/********************************************************/
#if defined(_VALIABLE_MEM_BLK_USE_)
static int GetMemoryBlockTableNumber( MemControlBlock tbl[], VP blk, ID mid )
{
	ID		p_tskid;
	MemControlBlock *mcb_tbl,*limit;

	/*󂫗̈̌*/
	mcb_tbl = tbl;
	limit = &tbl[ REQUIRE_BLOCKS ];
	dis_dsp();
	while( mcb_tbl < limit )
	{
		if( mcb_tbl->blk == (VP)NADR )
		{
			mcb_tbl->blk = blk;
			ena_dsp();
			get_tid( &p_tskid );
			mcb_tbl->tid = p_tskid;
			mcb_tbl->id = mid;
			return 0;
		}
		mcb_tbl++;
	}
	ena_dsp();
	return EOF;
}
#endif  /*_VALIABLE_MEM_BLK_USE_*/

/********************************************************/
/*	zID̒Av[lłID{	*/
/*	Ԃlɂ́Alł炻IDAI܂ŗ	*/
/*	EOF													*/
/********************************************************/
#if defined(_VALIABLE_MEM_BLK_USE_)
static ID GetMemBlockSub( ID *level, int nest, VP *blk )
{
	do
	{
		if ( pget_mpf( level[ nest ], blk) == E_OK )
			return level[ nest ];
	} while( --nest >= 0 );

	return (-1);
}
#endif  /*_VALIABLE_MEM_BLK_USE_*/

/********************************************************/
/*	ubN̎擾								*/
/*	szKvȃubN擾					*/
/*	擾ł΃ubN̐擪AhXԂAo	*/
/*	ȂΏo܂ő҂B							*/
/********************************************************/
#if defined(_VALIABLE_MEM_BLK_USE_)
VP T_GetMemBlock( size_t sz, TMO tmout )
{
	int		index;
	VP		blk;
	ID		mid;
	ER		ercd;
	static const ID	level[] = { MPID_IO_LARGE, MPID_IO_MIDDLE, MPID_IO_SMALL, MPID_IO_VERY_SMALL };

	/*TCYʂ̃ubNID擾*/
	index = (sz > MIDDLE_BLOCK_SIZE) ? 0 : (sz > SMALL_BLOCK_SIZE) ? 1 : (sz > VERY_SMALL_BLOCK_SIZE) ? 2 : 3;

	/*|[OŎ擾ATCỸv[ȂȂȀ̃TCỸv[擾*/
	if( (mid = GetMemBlockSub( (ID *)level, index, &blk )) < 0 )
	{
		mid = level[ index ];
		ercd = tget_mpf( mid, &blk, tmout );
	}
	else ercd = E_OK;

	if( ercd == E_OK )	/*Llłꍇ*/
	{
		for( index = 0; index < 300; index++ )
		{
			if( GetMemoryBlockTableNumber( mcb, blk, mid ) == 0 ) return blk;
			dly_tsk( 100 );
		}
		return (VP)E_TMOUT;
	}
	else return (VP)ercd;	/*G[R[hԂ*/
}
#endif  /*_VALIABLE_MEM_BLK_USE_*/

VP GetMemBlock( size_t sz )
{
#if defined(_VALIABLE_MEM_BLK_USE_)
  return T_GetMemBlock( sz, TMO_FEVR );
#else  /*_VALIABLE_MEM_BLK_USE_*/
  VP  blk;
  ER  ercd;
  char buf[32];

  ercd = get_mpf( MPID_IO_LARGE, &blk );
  if( ercd != E_OK ) 
  {
	DebugPrintPara1( "get_mpf err code=\r\n", ercd );
  }

  return (ercd == E_OK) ? blk : 0;
#endif  /*_VALIABLE_MEM_BLK_USE_*/
}

/********************************************************/
/*	ETH0MpubN̎擾					*/
/*	szKvȃubN擾					*/
/*	擾ł΃ubN̐擪AhXԂAo	*/
/*	ȂΏo܂ő҂B							*/
/********************************************************/
#ifdef	TID_ETH0

VP ETH0RcvGetMemBlock( size_t sz )
{
#if defined(_VALIABLE_MEM_BLK_USE_)
  int		index;
  VP		blk;
  ID		mid;
  static const ID	level[] = { MPID_ETH0_RCV_LARGE, MPID_ETH0_RCV_MIDDLE, MPID_ETH0_RCV_SMALL, MPID_ETH0_RCV_VERY_SMALL };

  /*TCYʂ̃ubNID擾*/
  index = (sz > ETH0_MIDDLE_BLOCK_SIZE) ? 0 : (sz > ETH0_SMALL_BLOCK_SIZE) ? 1 : (sz > ETH0_VERY_SMALL_BLOCK_SIZE) ? 2 : 3;

  /*|[OŎ擾ATCỸv[ȂȂȀ̃TCỸv[擾*/
  if( (mid = GetMemBlockSub( (ID *)level, index, &blk )) < 0 )
  {
    mid = level[ index ];
    get_mpf( mid, &blk );
  }
  /*ubNǗ̈̋󂫃CfbNX擾*/
  while( GetMemoryBlockTableNumber( mcb, blk, mid ) == EOF ) dly_tsk( 10 );

  return blk;
#else  /*_VALIABLE_MEM_BLK_USE_*/
  VP  blk;
  ER  ercd;
  char buf[32];

  ercd = get_mpf( MPID_IO_LARGE, &blk );
  if( ercd != E_OK ) 
  {
	DebugPrintPara1( "get_mpf err code=\r\n", ercd );
  }

  return (ercd == E_OK) ? blk : 0;
#endif  /*_VALIABLE_MEM_BLK_USE_*/
}

#endif	/*TID_ETH0`Ă鎞L*/

/********************************************************************/
/*			PROCESSe[u̒`									*/
/********************************************************************/
typedef struct
{
	short		valid;		/*̃R[h̗L(1)A(0)A܂͒~w(-1)*/
	short		ground;		/*FORGROUND(1)ABACKGROUND(0)*/
	short		IsThisUserTask;	/*ꂪTRUE̎USER TASKƂAvZX̒~\*/
	ID			taskid;		/*TASKID*/
	SYSTIM		stime;		/*SYSTEM*/
} TASK_PROCESS;

#define	PROCESS_SIZE	TMAX_TSKID	/*(03/01/28 Lq̕ύX) kernel_id.hŁAő^XN̒`ǉꂽ̂ŁA𗘗p*/
static	TASK_PROCESS	ProcessTable[ PROCESS_SIZE ];		/*vZXԂۑ*/
/********************************************************************/
/*			PROCESSe[uւ̓o^									*/
/*	߂ĺAo^e[uɋ󂫂āA͂܂񂾂	*/
/*	-1ԂāAI0ԂB								*/
/********************************************************************/
int	RegistProcessTable( short ground, short user )
{
	TASK_PROCESS		*pt;

	pt = ProcessTable;
	while( pt < &ProcessTable[ PROCESS_SIZE ] )
	{
		if( pt->valid == 0 )				/*PROCESS TABLE̋󂫂*/
		{
			pt->valid = TRUE;				/*gpɕύX*/
			pt->IsThisUserTask = user;		/**/
			get_tid( &pt->taskid );			/*݂TASK ID擾*/
			get_tim( &pt->stime );			/*擾Ԃo^*/
			pt->ground = ground;			/*FORGROUNDBACKGROUNDo^*/
			return 0;
		}
		pt++;								/*̃AhX*/
	}
	return EOF;								/*󂫂Ȃ*/
}

/********************************************************************/
/*			PROCESSe[u̍폜								*/
/*	߂l͓o^e[uɊYTASK ID-1ԂāA		*/
/*	I0ԂB												*/
/********************************************************************/
int	RelocateProcessTable( void )
{
	TASK_PROCESS	*pt;
	ID				p_tskid;

	pt = ProcessTable;
	get_tid( &p_tskid );					/*݂TASK ID擾*/
	while( pt < &ProcessTable[ PROCESS_SIZE ] )
	{
		if( pt->taskid == p_tskid )			/*PROCESS TABLÉAR[h*/
		{
			pt->valid = FALSE;				/*gpɕύX*/
			return 0;
		}
		pt++;								/*̃AhX*/
	}
	return EOF;								/*YR[hȂ*/
}

/********************************************************************/
/*			PROCESSe[u玩̓ԂmF					*/
/*	߂l͓Ԃԍ										*/
/*	Ae[uɓo^-1(LĂ͂Ȃ񂾂ǂ)	*/
/********************************************************************/
short QueryRunningMode( void )
{
	TASK_PROCESS	*pt;
	ID				p_tskid;

	pt = ProcessTable;
	get_tid( &p_tskid );					/*݂TASK ID擾*/
	while( pt < &ProcessTable[ PROCESS_SIZE ] )
	{
		if( pt->taskid == p_tskid )			/*PROCESS TABLẼR[h*/
			return pt->valid;
		pt++;								/*̃AhX*/
	}
	return EOF;
}

/********************************************************************/
/*			PROCESS~w											*/
/*	ŗ^TASKɒ~w							*/
/*	߂l͓o^e[uɊYTASK ID-1ԂāA		*/
/*	I0ԂB												*/
/********************************************************************/
void kill( int argc, char *argv[], int handle )
{
	int				i;
	TASK_PROCESS	*pt;
	ID				taskid;
	char			linebuf[ 64 ];

	if( argc == 2 || argc == 3 )				/*p[^[`FbN*/
	{
		i = 1;
		if( *argv[ i ] == '-' )
		{
			if( strncmp("-HUP", argv[i], sizeof("-HUP") - 1) != 0 ) goto _kill_error;	/*HUNG UPR[hƂ̔r*/
			i++;
		}

		taskid = atoi( argv[ i ] );				/*ID̎擾*/
		if( taskid == 0 ) goto _kill_error;		/*ȂI*/
		pt = ProcessTable;
		while( pt < &ProcessTable[ PROCESS_SIZE ] )
		{
			if( pt->taskid == taskid )			/*PROCESS TABLÉAR[h*/
			{
				pt->valid = -1;					/*~w*/
				if( i == 2 ) rel_wai( taskid );	/*҂Ԃ̋*/
				return;
			}
			pt++;								/*̃AhX*/
		}
		sprintf( linebuf, "kill: (%d) - No such Task ID\r\n", taskid );
		SCI_Puts( handle, linebuf );
	}
	else
	{
_kill_error:
		SCI_Puts( handle, "PARAMETER ERROR : kill TASK ID\r\n" );
	}
}

/********************************************************************/
/*			PROCESS LIST\s									*/
/********************************************************************/
void ps( int argc, char *argv[], int handle )
{
	TASK_PROCESS	*pt;
	char			linebuf[ 80 ],timebuf[ 32 ];
	SYSTIM			NewTime;

	pt = ProcessTable;
	while( pt < &ProcessTable[ PROCESS_SIZE ] )
	{
		if( pt->valid == TRUE || pt->valid == -1 )	/*쒆폜TASK{*/
		{
			/*TASK ID̕\*/
			sprintf( linebuf, "TASK ID=%d", pt->taskid );
			/*ԕ\*/
			strcat( linebuf, ( pt->valid == TRUE ) ? ",RUNNING" : ",DELETING" );
			/*oߎ\*/
			get_tim( &NewTime );
			if( NewTime.ltime < pt->stime.ltime ) NewTime.utime--;
			NewTime.utime -= pt->stime.utime;
			NewTime.ltime -= pt->stime.ltime;
			strcat( linebuf, ",TIME=" );
			sprintf( timebuf, "%d:%ld", NewTime.utime, NewTime.ltime );
			strcat( linebuf, timebuf );
			/*OʂwʂH\*/
			strcat( linebuf, ( pt->ground == _BACK_GROUND_ ) ? ",B.G." : ",F.G." );
			/*[U[vZXVXevZXH\*/
			strcat( linebuf, ( pt->IsThisUserTask == TRUE ) ? ",USER\r\n" : ",SYSTEM\r\n" );
			/*\*/
			SCI_Puts( handle, linebuf );
		}
		pt++;								/*̃AhX*/
	}
}

/********************************************************/
/*	^XNԎQ										*/
/********************************************************/
void ReferenceTask( int argc, char *argv[], int handle )
{
	ID		taskid;
	T_RTST	pk_rtst;
	ER		ercd;

	if( argc != 2 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : reftsk TASK ID\r\n" );
		return;
	}
	taskid = atoi( argv[ 1 ] );				/*ID̎擾*/
	ercd = ref_tst( taskid, &pk_rtst );
	if( ercd != E_OK )
	{
		SCI_Puts( handle, "PARAMETER ERROR : reftsk TASK ID\r\n" );
		return;
	}

	switch (pk_rtst.tskstat)
	{
		case TTS_RUN :
			SCI_Puts( handle, "RUNNIG\r\n" );
			break;
		case TTS_RDY :
			SCI_Puts( handle, "READY\r\n" );
			break;
		case TTS_WAI :
			SCI_Puts( handle, "WAITING\r\n" );
			break;
		case TTS_SUS :
			SCI_Puts( handle, "SUSPENDED\r\n" );
			break;
		case TTS_WAS :
			SCI_Puts( handle, "WAIT SUSPENDED\r\n" );
			break;
		case TTS_DMT :
			SCI_Puts( handle, "DORMANT\r\n" );
			break;
		default:
			SCI_Puts( handle, "ERROR\r\n" );
			break;
	}
}

/********************************************************/
/*	҂Ԃ̉										*/
/*	Ώۃ^XN҂Ԃ̎Ȃ҂ԂB	*/
/********************************************************/
void RelocateTask( int argc, char *argv[], int handle )
{
	ID		taskid;

	if( argc != 2 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : relwai TASK ID\r\n" );
		return;
	}

	taskid = atoi( argv[ 1 ] );				/*ID̎擾*/
	rel_wai( taskid );
}

/********************************************************/
/*	҂Ԃ̉									*/
/********************************************************/
void ResumeTask( int argc, char *argv[], int handle )
{
	ID		taskid;
	ER		ercd;

	if( argc != 2 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : rsmtsk TASK ID\r\n" );
		return;
	}
	taskid = atoi( argv[ 1 ] );				/*ID̎擾*/
	ercd = rsm_tsk( taskid );
	if( ercd != E_OK )
	{
		SCI_Puts( handle, "PARAMETER ERROR : rsmtsk TASK ID\r\n" );
		return;
	}
}

/********************************************************/
/*	҂Ԃւ̈ڍs								*/
/********************************************************/
void SuspendTask( int argc, char *argv[], int handle )
{
	ID		taskid;
	ER		ercd;

	if( argc != 2 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : sustsk TASK ID\r\n" );
		return;
	}
	taskid = atoi( argv[ 1 ] );				/*ID̎擾*/
	ercd = sus_tsk( taskid );
	if( ercd != E_OK )
	{
		SCI_Puts( handle, "PARAMETER ERROR : sustsk TASK ID\r\n" );
		return;
	}
}

/********************************************************/
/*	^XN̐										*/
/*	acre_tskŃ^XN̐ŝAŒI	*/
/*	ȃp[^[L̂ŁAňꊇo^s		*/
/*	߂lacre_tsk̖߂lA܂A̒l̓^XNID	*/
/*	̒ĺAG[R[hƂȂB						*/
/********************************************************/
ID CreateTask( VP_INT handle, int stacksize, int priority, FP fn )
{
	T_CTSK	pk_ctsk;

	pk_ctsk.tskatr = TA_HLNG;	/*C^tF[X*/
	pk_ctsk.exinf = handle;		/*g*/
	pk_ctsk.task = fn;			/*o^^XÑAhX*/
	pk_ctsk.itskpri = priority;	/*D揇ʂ̐ݒ*/
	pk_ctsk.stksz = stacksize;	/*X^bNTCY*/
	pk_ctsk.stk = NULL;			/*X^bN̐擪Ԓn*/
	return acre_tsk( &pk_ctsk );	/*^XN̐*/
}

/********************************************************/
/*	nh[̐								*/
/*	acre_cycŃ^XN̐ŝAŒI	*/
/*	ȃp[^[L̂ŁAňꊇo^s		*/
/*	߂lacre_tsk̖߂lA܂A̒l̓^XNID	*/
/*	̒ĺAG[R[hƂȂB						*/
/********************************************************/
#ifdef	__SONNA_TEIGIHA_NAI__
ID CreateCyclicHandler( VP_INT handle, RELTIM rtime, FP fn )
{
	T_CCYC	pk_ccyc;

	pk_ccyc.cycatr = TA_HLNG;	/*C^tF[X*/
	pk_ccyc.exinf = handle;		/*g*/
	pk_ccyc.cychdr = fn;		/*Nnh̋NԒn*/
	pk_ccyc.cyctim = rtime;		/*N*/
	pk_ccyc.cyphs = 0;			/*ʑݒ*/
	return acre_cyc( &pk_ccyc );
}
#endif	/*__SONNA_TEIGIHA_NAI__*/

/********************************************************/
/*	ITRON4.0dlG[bZ[W\					*/
/********************************************************/
void ITRON4_Error_Msg( ER ercd )
{
	switch ( ercd )
	{
		case E_ID :
			SCI_Putc( SCI_1, 'I' );
			break;
		case E_NOID :
			SCI_Putc( SCI_1, 'N' );
			break;
		case E_NOMEM :
			SCI_Putc( SCI_1, 'M' );
			break;
		case E_RSATR :
			SCI_Putc( SCI_1, 'A' );
			break;
		case E_PAR :
			SCI_Putc( SCI_1, 'P' );
			break;
		case E_OBJ :
			SCI_Putc( SCI_1, 'O' );
			break;
		default :
			SCI_Putc( SCI_1, '?' );
			break;
	}
}
