/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"util.h"

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/********************************************************************/
/*	TCPpTv												*/
/*	TCP	CLOCK														*/
/*	ӁITCP̎́ASRĂ܂B						*/
/********************************************************************/
void TcpDayTime( int argc, char *argv[], int handle )
{
	char	buffer[ 32 ];
	long	length;
	TcpAddressAndPortInformation info;		/*TCPڑ*/

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc != 2 || IPAddSplit( info.dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : tcpclock IP ADDRESS\r\n" );
		return;
	}

	/*[U[ŎMobt@̈o^*/
	TCPRegistReceiveBufferArea( &info, buffer, sizeof(buffer) );
	/*]|[gԍ擾*/
	info.dport= DAYTIME;	/*AvP[VŎwFKv*/
	/*\Pbg̐*/
	TCPsocket( &info );
	/*ڑ*/
	if( TCPconnect( &info, handle ) == 0 )
	{
		/*f[^̓Ǎ*/
		while( 1 )
		{
			if( (length = TCPread( &info, buffer, sizeof(buffer) )) > 0 )
			{
				/*ʏo*/
				*(strchr( buffer, '\r')) = '\0';
				strcat( buffer, "\r\n" );
				SCI_Puts( handle, buffer );
			}
			else break;
		}
		/*߂l̊mF*/
		switch (length)
		{
			case 0 :	/*Mf[^*/
			case EOF :	/*FIN̎M*/
				break;
			case TCP_UNREACHABLE_PORT :		/*擞Bs\*/
			case TCP_TIME_OUT :				/*MԐ؂*/
			case TCP_UNKNOWN_IP_ADDRESS :	/*IPs*/
			case TCP_DISCONNECT :			/*RST̎M*/
			default :
				TCPForceCloseState( &info );	/*I*/
				return;
		}
		/*I*/
		TCPclose( &info, handle );
	}
	else
	{
		/*I*/
		TCPForceCloseState( &info );
	}
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
