/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"udp.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"util.h"

void LCD_Puts( char *str );

/********************************************************/
/*	IvVXCb`ɑΉo^\	*/
/********************************************************/
typedef	struct
{
	void	(* func)(int argc,char *argv[],int handle);
	char	*optionname;
} OPTION_LIST;

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/********************************************************************/
/*	UDPpTv												*/
/*	UDP	CLOCK														*/
/*	̊֐́AUDPDaytimẻp								*/
/*	IPAhX́ADayTimeT[o[A0.5buɎ	*/
/*	LCDɕ\܂B										*/
/*	śAobNOEh[hȂ̂ŁA~߂鎞̓vZXKI	*/
/*	LLKvłB													*/
/*																	*/
/*	֐UdpClockTaskAobNOEhŉғ^XN̎̂łB*/
/*	500ms̃^C}[荞݂ŁAwup_tskĂ܂B				*/
/*	̃^XN̏ꍇAUDP̃f[^̎M^C~ÓA[{b	*/
/*	NX擾Ă܂Bׁ̈A܂擪Ń[{bNX؂	*/
/*	oAR\[KILLolɁAvZXe[uɓo^	*/
/*	sAUDPMt[̏𐶐āA|[gԍ؂󂯂,	*/
/*	UDPt[𑗐M܂B										*/
/*	trcv_mbxŉtő҂܂B							*/
/*	ML΁AICMP̒ʐMłȂmFAf[^̈	*/
/*	AspɂȂ|[gԍԋpA擾 LCDɕ\	*/
/*	Ä̊JsĂ܂B							*/
/*																	*/
/*	֐UdpClocḱA^C}[荞ݎŁAL̃^XNN	*/
/*	lɂĂ܂B												*/
/********************************************************************/
void MBXUdpClockTask( VP_INT handle )
{
	struct DATE_TIME
	{
		char		week[ 4 ];
		char		month[ 4 ];
		int			day;
		int			hour;
		int			minute;
		int			second;
	};

	char			buf[ 32 ], check[ 32 ], linebuf[ 20 ];
	char			*str;
	int				i;
	long			rcvsz;
	struct DATE_TIME	date;
	UdpAddressAndPortInformation info;		/*UDPڑ*/
	ER_UINT			msgsz;

	/*vZXe[uɓo^s*/
	RegistProcessTable( _BACK_GROUND_, TRUE );
	check[0] = 0;

	/*bZ[Wobt@őAhX󂯂*/
	msgsz = rcv_mbf( MBF_UDP_LCD_DISPLAY, info.dip );
	sprintf( buf,"\r\nip=%u.%u.%u.%u\r\n", info.dip[0], info.dip[1], info.dip[2], info.dip[3] );
	SCI_Puts( SCI_1, buf );

	/*\Pbg̐*/
	if( UDPsocket( &info ) == EOF )
	{
		/*Nnh̃Xgbv*/
		stp_cyc( CYC_ID_MBX_UDP_CLOCK );
		/*vZXe[u甲*/
		RelocateProcessTable();
		/*TASK̏I*/
		ext_tsk();
	}

	/*BIND*/
	info.sport = 5000;
	UDPbind( &info, handle );

	while( 1 )
	{
IsNotGraphicalCode:
		/*U҂Ԃɓ*/
		slp_tsk();

		/*vZXKILLꂽf*/
		if( QueryRunningMode() == EOF ) {
			SCI_Puts( SCI_1, "mbxudpclock stopped.\r\n" );
			break;
		}

		/*f[^̑M*/
		info.dport	= DAYTIME;
		info.DataSz = 0;
		if( UDPsendto( &info, handle ) != 0 )
			continue;			/*Ms͍̎ă`W*/

		/*f[^̎M*/
		info.DataSz = sizeof(buf);
		info.data = buf;
		info.tmout = 100;	/*^CAEg*/
		rcvsz = UDPrecvfrom( &info, handle );
		/*(03/01/29 ǉAC) G[^Cvʂ̏ɕύX*/
		if( rcvsz == UDP_TIMEOUT )	continue;	/*Ms͍̎ă`W*/
		else if( rcvsz == UDP_UNREACHABLE_PORT )
		{
			SCI_Puts( handle, "UNREACHABLE PORT\r\n" );
			break;
		}
		else{}

		/*Mf[^TCYAobt@TCY傫A͍sȂ*/
		if( rcvsz > (long)sizeof(buf) ) continue;
		/*(03/01/28 ǉ) Mf[^ׂĕ\\ł鎖mF*/
		str = buf;
		rcvsz = ( buf[ rcvsz - 1 ] == '\0' ) ? rcvsz - 1 : rcvsz;	/*IWiDAYTIMET[o[p΍AoLڂȂ*/
		while( str < &buf[ rcvsz ] )
		{
			if( !(isgraph( *str )) && !(isspace( *str )) ) goto IsNotGraphicalCode;
			str++;
		}
		/*sR[hNULLɕϊB*/
#if 1
		buf[( rcvsz == (long)sizeof(buf) ) ? (long)sizeof(buf) - 1 : rcvsz ] = '\0';	/*̃~b^[*/
		for (i = 0; i < (rcvsz - 2) ; i++) {
			if (buf[i] == '\r') {
				buf[i+1] = '\n';
				buf[i+2] = '\0';
				break;
			}
		}
#else
		*(strchr( buf, '\r' )) = '\0';	/*AȀ̕@́AvZLeBz[*/
		*(strchr( buf, '\n' )) = '\0';	/*sR[hȂƁA\\L܂̂ŁA^ȂŉB܂łȈՓIɂĂ܂B*/
#endif
		/*擾̍č\z*/
		if( sscanf( buf, "%s %s %d %d:%d:%d", date.week, date.month, &date.day, &date.hour, &date.minute, &date.second ) == 6 )
		{
			/*擾łꍇ̂ݕ\*/
			if (check[0] == 0) {
				goto display;
			}
			if (strcmp(check, buf) != 0) {
display:
				strcpy(check, buf);
#ifdef	__NO_LCD__	/* mFp */
				sprintf( linebuf, "%s %2d %2d:%02d:%02d\r\n",
					date.month, date.day, date.hour, date.minute, date.second );
				SCI_Puts( handle, linebuf );
#else
				sprintf( linebuf, "%s %2d %2d:%02d:%02d", 
					date.month, date.day, date.hour, date.minute, date.second );
				/*LCD̕\ʒu̎wAX=0Ay=1̈ʒuƂȂ*/
				LCD_Puts( "\x1b[0;1H" );
				LCD_Puts( linebuf );
#endif
			}
		}
	}
	/*\Pbg̃N[Y*/
	UDPclose( &info );

	/*Nnh̃Xgbv*/
	stp_cyc( CYC_ID_MBX_UDP_CLOCK );
	/*vZXe[u甲*/
	RelocateProcessTable();
	/*TASK̏I*/
	ext_tsk();
}

/********************************************************************/
/*	tcov̏											*/
/********************************************************************/
void MBXUdpClock( int argc, char *argv[], int handle )
{
	unsigned char	UDPClockDip[ 4 ];

	/*p[^[`FbN*/
	if( argc != 2 || IPAddSplit( UDPClockDip, argv[ 1 ] ) != 0 )	/*]擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : udpclock IP ADDRESS\r\n" );
		return;
	}
	/*obNOEhœ삷nh̋N*/
	act_tsk( TID_UDPCLOCK );
	/*bZ[Wobt@gđAhX𑗐M*/
	snd_mbf( MBF_UDP_LCD_DISPLAY, (VP)UDPClockDip, sizeof(UDPClockDip) );
	/*Nnh̃X^[g*/
	sta_cyc( CYC_ID_MBX_UDP_CLOCK );
}

/********************************************************************/
/*	Nnh												*/
/********************************************************************/
void CycActTimerInt( VP_INT tid )
{
	T_RTST		pk_rtst;

	/*^XNԂQƂAWAITȂN*/
	ref_tst( tid, &pk_rtst );
	if( pk_rtst.tskstat & TTS_WAI ) wup_tsk( tid );
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
