/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"udp.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"util.h"

/********************************************************************/
/*	UDP\PbgpTv										*/
/*	udpclock IP Address												*/
/*	R}hCŏL̃R}h^CvƁADayTimeT[o[	*/
/*	(#13)ƌMA\B									*/
/********************************************************************/
void UdpDayTime( int argc, char *argv[], int handle )
{
	char			buf[128];
	long			rcvsz;
	UdpAddressAndPortInformation info;		/*UDPڑ*/

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc != 2 || IPAddSplit( info.dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : udpdaytime IP ADDRESS\r\n" );
		return;
	}
	/*]|[gԍ擾*/
	info.dport = DAYTIME;	/*AvP[VŎwFKv*/

	/*\Pbg̐*/
	if( UDPsocket( &info ) == EOF ) return;

	/*bind*/
	UDPbind( &info, handle );

	/*f[^̑M*/
	info.DataSz = 0;
	if( UDPsendto( &info, handle ) == EOF )	/*(03/01/28 ǉ) G[*/
	{
		SCI_Puts( handle, "Unknown IP Address\r\n" );
		/*\Pbg̃N[Y*/
		UDPclose( &info );
		return;
	}

	/*f[^̎M*/
	info.DataSz = sizeof(buf);
	info.data = buf;
	info.tmout = 1000;	/*^CAEg*/
	rcvsz = UDPrecvfrom( &info, handle );
	if( rcvsz > 0 )
	{
		int i;

		buf[rcvsz] = '\0';
		for (i=0; i < (rcvsz - 2) ; i++) {
			if (buf[i] == '\r') {
				buf[i+1] = '\n';
				buf[i+2] = '\0';
				break;
			}
		}
		SCI_Puts( handle, buf );
	}
	/*\Pbg̃N[Y*/
	UDPclose( &info );
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
