/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"udp.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"util.h"

/********************************************************/
/*	IvVXCb`ɑΉo^\	*/
/********************************************************/
typedef	struct
{
	void	(* func)(int argc,char *argv[],int handle);
	char	*optionname;
} OPTION_LIST;

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/********************************************************************/
/*	UDPpTv												*/
/*	UDP	ECHONCAg											*/
/*	̗́AUNIXlbg[NvO~OQ Vol.1	*/
/*	210łɌfڂĂUDP ECHONCAgAWłB	*/
/********************************************************************/
static void dg_cli( UdpAddressAndPortInformation *info, int handle );

void UdpEchoClient( int argc, char *argv[], int handle )
{
	UdpAddressAndPortInformation info;		/*UDPڑ*/

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc != 2 || IPAddSplit( info.dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : dgechocli IP ADDRESS\r\n" );
		return;
	}

	/*\Pbg̐*/
	if( UDPsocket( &info ) == EOF ) return;
	/*bind*/
	UDPbind( &info, handle );
	/*|[gԍ*/
	info.dport = ECHO;
	/*NCAg{*/
	dg_cli( &info, handle );
	/*\Pbg̃N[Y*/
	UDPclose( &info );
}

static void dg_cli( UdpAddressAndPortInformation *info, int handle )
{
	char	buffer[ 80 ];
	long	rcvsz;

	while( 1 )
	{
		/*s荞݂sA[U[u[Ñ`FbNs*/
		if( GetLine( buffer, handle, sizeof(buffer) ) == (char *)NADR ) break;
		info->DataSz = strlen(buffer);	/*Mf[^*/
		info->data = buffer;			/*Mobt@̈*/
		UDPsendto( info, handle );		/*M*/
		/*MɕKvȏZbg*/
		info->tmout = 1000;
		info->DataSz = sizeof(buffer);	/*Mobt@TCY*/
		info->data = buffer;			/*Mobt@̈*/
		rcvsz = UDPrecvfrom( info, handle );	/*M*/
		if( rcvsz <= 0 ) return;		/*G[*/
		buffer[ rcvsz ] = '\0';
		strcat( buffer, "\r\n" );
		SCI_Puts( handle, buffer );
	}
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
