/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  TvvO                           */
/*   OSp^C}                                                             */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include	<stdio.h>
#include	<string.h>

#include	"h83068f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"ostimer.h"
#include	"itu.h"

/*GRAXVpϐ*/
unsigned short NewGRAValue;

/********************************************************************/
/*	VXe^C}[												*/
/********************************************************************/
/* OSp^C} */
void ostim_init(VP_INT TimeFactor)
{
	ITU.TSTR.BIT.STR0 = 0;			/*ITU0~*/
	ITU.TSNC.BIT.SYNC0 = 0;			/*ch0͓Ɨ*/
	ITU.TMDR.BIT.PWM0 = 0;			/*ch0͒ʏ퓮*/
	ITU0.TCR.BYTE = 0xa3;			/*1010 0011:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU0.GRA = TimeFactor;			/*RyA}b`A̒l*/
	ITU0.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU.TISRA.BIT.IMIEA0 = 1;		/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR0 = 1;			/*ITU0X^[g*/
}

/* 荞݃nhTv */
void ostim_hdr(VP_INT exinf)		/* OS^C}pnh */
{
	ITU.TISRA.BIT.IMFA0 = 0;		/*ݏ̃NA*/
	isig_tim();						/* ^CeBbN̋ */
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                        */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInit( void )
{
	ITU.TSTR.BIT.STR2 = 0;			/*ITU2~*/
	ITU.TSNC.BIT.SYNC2 = 0;			/*ch4͓Ɨ*/
	ITU.TMDR.BIT.PWM2 = 0;			/*ch4͒ʏ퓮*/
	ITU2.TCR.BYTE = 0xa3;			/*1010 0001:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU2.GRA = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*RyA}b`A̒l*/
	NewGRAValue = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*GRȀ*/
	ITU2.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU.TISRA.BIT.IMIEA2 = 1;		/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR2 = 1;			/*ITU2X^[g*/
}

void SNTPSyncIndependentPart( void );

/********************************************************************/
/*	SNTPT[o[^C}[JE^[荞݃nh              */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInt( void )
{
	ITU.TISRA.BIT.IMFA2 = 0;		/*ݏ̃NA*/
	ITU2.GRA = NewGRAValue;			/*RyA}b`A̒lXV*/
	SNTPSyncIndependentPart();		/*ˑƗ̌ĂяoB*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterSet( unsigned short value )
{
/*	ITU.TSTR.BIT.STR2 = 0;*/	/*^C}[~*/
	ITU2.TCNT = value;
/*	ITU.TSTR.BIT.STR2 = 1;*/	/*^C}[ĊJ*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[ǂݏo                      */
/*	ˑ                                                    */
/********************************************************************/
volatile unsigned short SNTPSyncTimerCounterGet( void )
{
	return ITU2.TCNT;
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/*	0̎Ƀ^C}[~A1ōĊJB                      */
/********************************************************************/
void SNTPSyncTimerStartStop( int StartStop )
{
	ITU.TSTR.BIT.STR2 = StartStop;	/*ITU2~/ĊJ*/
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
