/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  TvvO                           */
/*   OSp^C}                                                             */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

/*#include	<machine.h>*/							/* Compiler Header File */
#include	<sh2/7040s.h>						/* SH7040 Header File   */

#include	"kernel.h"
#include	"kernel_id.h"
#include	"ostimer.h"

#if 0   /*PRIORITY_1*/
#define		SYS_TIMER_PRI		14
#else   /*PRIORITY_1*/
#define		SYS_TIMER_PRI		1
#endif   /*PRIORITY_1*/

#ifdef	__SNTP_USE__

#if 0   /*PRIORITY_1*/
#define		SNTP_SYNC_TIMER_PRI	13
#else   /*PRIORITY_1*/
#define		SNTP_SYNC_TIMER_PRI	1
#endif   /*PRIORITY_1*/

#endif	/*__SNTP_USE__*/

#ifdef	__SNTP_USE__
/*GRAXVpϐ*/
unsigned short NewGRAValue;
#endif	/*__SNTP_USE__*/

/********************************************************************/
/*	VXe^C}[												*/
/********************************************************************/
/* OSp^C} */
void ostim_init(VP_INT exinf)
{
	/* ^C} */
	CMT0.CMCSR.WORD = 0x0040;
	CMT0.CMCOR = (UH)(INT)exinf;
	CMT.CMSTR.WORD  = 0x0001;
#if 0
	INTC.IPRG.BIT._CMT0 = SYS_TIMER_PRI;
#else  /*__INT_LEVEL_1__*/
	INTC.IPRG.BIT._CMT0 = 1;
#endif
}

/* 荞݃nhTv */
void ostim_hdr(VP_INT exinf)	/* OS^C}pnh */
{
	CMT0.CMCSR.BIT.CMF = 0;
	
	isig_tim();		/* ^CeBbN̋ */
}

#ifdef	__SNTP_USE__
/********************************************************************/
/*	NTPT[o[^C}[                                         */
/********************************************************************/
void SNTPSyncTimerCounterInit( void )
{
	/* ^C} */
	CMT1.CMCSR.BIT.CKS = 0;		/*8*/
/*	CMT1.CMCNT = 0;*/			/*JE^NA*/
	CMT1.CMCOR = 24000 - 1;		/*128Hz*/
	CMT.CMSTR.BIT.STR1  = 1;	/*^C}X^[g*/
	CMT1.CMCSR.BIT.CMIE = 1;	/*荞݋*/
	INTC.IPRG.BIT._CMT1 = SNTP_SYNC_TIMER_PRI;
}

/********************************************************************/
/*	SNTPT[o[^C}[荞ݏB                          */
/*	ˑ̂݋LqB                                            */
/********************************************************************/
void SNTPSyncIndependentPart( void );

void SNTPSyncTimerCounterInt( void )
/*void SNTPSyncTimerInt( VP_INT exinf )*/
{
	CMT1.CMCSR.BIT.CMF = 0;		/*荞ݏ̃NA*/

	/*ˑȂ̌Ăяo*/
	SNTPSyncIndependentPart();
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterSet( unsigned short value )
{
	CMT1.CMCNT = value;
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[ǂݏo                      */
/*	ˑ                                                    */
/********************************************************************/
volatile unsigned short SNTPSyncTimerCounterGet( void )
{
	return CMT1.CMCNT;
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerStartStop( int StartStop )
{
	CMT1.CMCSR.BIT.CMIE = StartStop;
	CMT.CMSTR.BIT.STR1 = StartStop;
}

#endif	/*__SNTP_USE__*/

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
