/********************************************************************/
/*	HOS-V4 for SH2/H8300H (ITRON version4.0)						*/
/*	SCI`															*/
/*							Copyright (C) 1998-2002 by hamayan		*/
/********************************************************************/

#define	CR		0x0d
#define	LF		0x0a
#define	XON		0x11
#define	XOFF	0x13

/* SCIʐMx` */
#define CPU_CLK   	(__CPU_CLOCK__ / 100)
#define SCI_2400   	(CPU_CLK / (64 * 24 / 2) -1)
#define SCI_4800   	(CPU_CLK / (64 * 48 / 2) -1)
#define SCI_9600    (CPU_CLK / (64 * 96 / 2) -1)
#define SCI_19200   (CPU_CLK / (64 * 192 / 2) -1)
#define SCI_38400   (CPU_CLK / (64 * 384 / 2) -1)
#define SCI_57600   (CPU_CLK / (64 * 576 / 2) -1)

/* foCXnh */
#define SCI_0		0
#define SCI_1		1
#define SCI_2		2

/*ʐMp\*/
#define	SERIAL_BUFFER_SIZE	64
/*SCIM^XNŎgp郁[{bNX̃ubNTCY*/
#define	SCI_BLOCK_SIZE		64
/********************************************************************/
/*	VȂMŎgpobt@̃TCÝAKQׂ̂	*/
/*	w肵ĉ												*/
/********************************************************************/
struct SERIALBUFFER
{
	char	buf[ SERIAL_BUFFER_SIZE ];
	int		wptr;
	int		rptr;
};

#ifdef __HAMAYAN_ORIGINAL_DEVICE_HEADER__
struct TSerialHandle
{
	struct SERIALBUFFER	ss;			/*Mobt@*/
	struct SERIALBUFFER	sr;			/*Mobt@*/
	volatile struct __SCI0_REG__	*sci;		/*IWiwb_[t@C̍\*/
};
#else
struct TSerialHandle
{
	struct SERIALBUFFER	ss;			/*Mobt@*/
	struct SERIALBUFFER	sr;			/*Mobt@*/
	volatile struct st_sci	*sci;		/*wb_[t@C̍\*/
};
#endif

/********************************************************************/
/*	MɎgp\											*/
/********************************************************************/
#define		SCI_MSG_SIZE	(SCI_BLOCK_SIZE - sizeof(T_MSG) - sizeof(int))
typedef struct
{
	T_MSG	msgque;				/*bZ[Wwb_[̈A{IɃVXeǗ*/
	int		sz;
	char	buf[ SCI_MSG_SIZE ];
} SCI_MSG_BLOCK;

/********************************************************************/
/*	SCIo͊֐													*/
/********************************************************************/
void	SCI_Init( int handle, unsigned char rate );
int		RecByteSize( int handle );
int		SCI_Puts( int handle, const char *str );
void	SCI_Putc( int handle, char c );
int		SCI_Getc( int handle );
void	SCI_Purge( int handle );
