/********************************************************************/
/*	HOS-V4 for SH2/H8300H (ITRON version4.0)						*/
/*	LCD`															*/
/*							Copyright (C) 1998-2002 by hamayan		*/
/********************************************************************/

#define	DATA_MODE		0		/*f[^݃[h*/
#define	CMD_MODE		1		/*R}h݃[h*/
#define	FUNCTIONSET		LcdWrite(CMD_MODE,0x28)		/*t@NVZbg4bit[hI*/
#define	DISPLAYOFF		LcdWrite(CMD_MODE,0x08)		/*\OFF*/
#define	DISPLAYON		LcdWrite(CMD_MODE,0x0c)		/*\ON*/
#define	DISPLAYCLEAR	LcdWrite(CMD_MODE,0x01)		/*\NA*/
#define	ENTRYMODESET	LcdWrite(CMD_MODE,0x06)		/*CNgA\VtgȂ*/
#define	CURSORHOME		LcdWrite(CMD_MODE,0x02)		/*J[\z[*/
#define	LINE1			LcdWrite(CMD_MODE,0x80+0x00)	/*s*/
#define	LINE2			LcdWrite(CMD_MODE,0x80+0x40)	/*s*/
#define	LINE3			LcdWrite(CMD_MODE,0x80+0x14)	/*Os*/
#define	LINE4			LcdWrite(CMD_MODE,0x80+0x54)	/*ls*/

#ifdef	__LCD_SIZE_IS_20_4__
#define ROWSIZE			20
#define COLSIZE			4
#else
#define ROWSIZE			16
#define COLSIZE			2
#endif

#define LCDBUFFERSIZE	(ROWSIZE * COLSIZE)

/********************************************************************/
/*	LCD֐															*/
/********************************************************************/
void 	LCDInit( void );
void	LCD_Locate(int x,int y);
void	LCD_Refresh( void );
int		LCD_Addstr( char *s );
void	LCD_Cls( void );
void	RunningLedOnOff( int OnOff );
int		RunningLedStatus( void );
