/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  SNTP֘A̒`                                                          */
/*                                  Copyright (C) 2003-2004 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#define		SNTP_SCAN_PERIOD	120		/*Pʂ͕b*/

#define		TZ				9
#define		ONE_HOUR_SEC	3600UL
#define		ONE_DAY_SEC		(24 * ONE_HOUR_SEC)
#define		ONE_YEAR_SEC	(365 * ONE_DAY_SEC)
#define		LEAP_YEAR_SEC	(366 * ONE_DAY_SEC)

#define		JAN_SEC			(31 * ONE_DAY_SEC)	/*P*/
#define		FEB_SEC			((28 * ONE_DAY_SEC) + JAN_SEC)	/*Q*/
#define		FEB_LEAP_SEC	((29 * ONE_DAY_SEC) + JAN_SEC)	/*Q*/
#define		MAR_SEC			((31 * ONE_DAY_SEC) + FEB_SEC)	/*R*/
#define		MAR_LEAP_SEC	((31 * ONE_DAY_SEC) + FEB_LEAP_SEC)	/*R*/
#define		APR_SEC			((30 * ONE_DAY_SEC) + MAR_SEC)	/*S*/
#define		APR_LEAP_SEC	((30 * ONE_DAY_SEC) + MAR_LEAP_SEC)	/*S*/
#define		MAY_SEC			((31 * ONE_DAY_SEC) + APR_SEC)	/*T*/
#define		MAY_LEAP_SEC	((31 * ONE_DAY_SEC) + APR_LEAP_SEC)	/*T*/
#define		JUN_SEC			((30 * ONE_DAY_SEC) + MAY_SEC)	/*U*/
#define		JUN_LEAP_SEC	((30 * ONE_DAY_SEC) + MAY_LEAP_SEC)	/*U*/
#define		JLY_SEC			((31 * ONE_DAY_SEC) + JUN_SEC)	/*V*/
#define		JLY_LEAP_SEC	((31 * ONE_DAY_SEC) + JUN_LEAP_SEC)	/*V*/
#define		AUG_SEC			((31 * ONE_DAY_SEC) + JLY_SEC)	/*W*/
#define		AUG_LEAP_SEC	((31 * ONE_DAY_SEC) + JLY_LEAP_SEC)	/*W*/
#define		SEP_SEC			((30 * ONE_DAY_SEC) + AUG_SEC)	/*X*/
#define		SEP_LEAP_SEC	((30 * ONE_DAY_SEC) + AUG_LEAP_SEC)	/*X*/
#define		OCT_SEC			((31 * ONE_DAY_SEC) + SEP_SEC)	/*PO*/
#define		OCT_LEAP_SEC	((31 * ONE_DAY_SEC) + SEP_LEAP_SEC)	/*PO*/
#define		NOV_SEC			((30 * ONE_DAY_SEC) + OCT_SEC)	/*PP*/
#define		NOV_LEAP_SEC	((30 * ONE_DAY_SEC) + OCT_LEAP_SEC)	/*PP*/
#define		DEC_SEC			((31 * ONE_DAY_SEC) + NOV_SEC)	/*PQ*/
#define		DEC_LEAP_SEC	((31 * ONE_DAY_SEC) + NOV_LEAP_SEC)	/*PQ*/

/* ----------------------------------------------------------- */
/*  NTP^CX^vtH[}bg                              */
/* ----------------------------------------------------------- */
typedef struct
{
	unsigned long	integer;	/*FLONGȂ̂intƂ͂@ɁH*/
	unsigned long	small_number;	/**/
} NTP_TIME_STAMP_FORMAT;

/*
́A1900N11ߑO뎞00b̒ʎZbB
2003NȂ̂2003N11ߑO뎞00b̎Ԃ́A
(2003N - 1900N) * 365 * 24 * 3600b + ((2003N - 1900N) / 4N * 24 * 3600) - ((2003N - 1900N) / 100N * 24 * 3600)
[łAǂɉ[bLCB
*/

/* ----------------------------------------------------------- */
/*  NTPbZ[WtH[}bg                                  */
/* ----------------------------------------------------------- */
typedef struct
{
	struct
	{
		unsigned char	LI:2;	/*[bwq*/
		unsigned char	VN:3;	/*o[Wԍ*/
		unsigned char	Mode:3;	/*[h*/
	} B;
	unsigned char	Layer;		/*Kw*/
	unsigned char	PollingPeriod;	/*|[OԊu*/
	unsigned char	Precision;	/*x*/
	unsigned long	Delay;		/*[gx*/
	unsigned long	Spread;		/*[ggU*/
	unsigned long	RefID;		/*QƎʎq*/
	NTP_TIME_STAMP_FORMAT	RefTimeStamp;	/*Qƃ^CX^v*/
	NTP_TIME_STAMP_FORMAT	StaTimeStamp;	/*Jn^CX^v*/
	NTP_TIME_STAMP_FORMAT	RcvTimeStamp;	/*M^CX^v*/
	NTP_TIME_STAMP_FORMAT	SndTimeStamp;	/*M^CX^v*/
#if 0
	unsigned long	KeyID;		/*ʎq*/
	char	Msg[32];			/*bZ[W_CWFXgFCӃtB[h*/
#endif
} NTP_MESSAGE_FORMAT;

/* ------------------------------------------------------------------------ */
/* ֐̃vg^Cv錾                                                   */
/* ------------------------------------------------------------------------ */
unsigned long SecsFrom1900( void );
char *Str2DateTime( unsigned long timer, char *dest );
unsigned long SNTPClient( unsigned char dip[], int handle );

/* ------------------------------------------------------------------------ */
/* ϐ̎Q                                                               */
/* ------------------------------------------------------------------------ */
#ifdef	__THIS_IS_A_NTP_C_FILE__
#else
extern char	DateTimeStrings[];
extern char	DateTimeStringsFor7SegLed[];
#endif

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 2003-2004 by hamayan		*/
/* ------------------------------------------------------------------------ */
