/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  UDP֘A̒`                                                           */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
/*T[rX`*/
#define	ECHO				7		/*echo:UDP,TCP*/
#define	DAYTIME				13		/*daytime:UDP,TCP*/
#define	FTP					21		/*ftp:TCP*/
#define	TELNET				23		/*telnet:TCP*/
#define	TIME				37		/*time:UDP,TCP*/
#define	TFTP				69		/*tftp:UDP*/
#define	RTELNET				107		/*rtelnet:UDP,TCP*/
#define	NTP					123		/*ntp:UDP*/
#define	SYSLOG				514		/*syslog:UDP*/

#if 1
#define	PORTCONTROL			4126	/*PortControl:UDP H8/3052F,3048F,3068F,3069F̃|[gAvP[Vp*/
#else
#define	PORTCONTROL			123		/*PortControl:UDP H8/3052F,3048F,3068F,3069F̃|[gAvP[Vp*/
#endif

/********************************************************/
/*	UDPp IPAhXAPORTԍ̍\					*/
/********************************************************/
typedef struct
{
	unsigned char		dip[4];		/*IPAhX̃AhX*/
	unsigned char		sip[4];		/*MIPAhX̃AhX*/
	unsigned short		DataSz;		/*f[^TCY*/
	unsigned short		dport;		/*|[gԍ*/
	unsigned short		sport;		/*M|[gԍ*/
	char				rsv1[2];
	ID					mid;		/*[{bNXID*/
	ID					callback_id;	/*R[obNpID*/
	BOOL				server;		/*T[o[^NCAg*/
	TMO					tmout;		/*^CAEgԁFTMO_FEVRw肳Ɖiv҂*/
	void				*data;		/*f[^̈̃AhX*/
	void (* callback)( ID callback_id );	/*R[obN֐̐擪AhX*/
} UdpAddressAndPortInformation;

/********************************************************/
/*	UDP`												*/
/********************************************************/
#define	UDP_UNREACHABLE_PORT		(-2)	/*|[gBs\*/
#define	UDP_TIMEOUT					(-3)	/*Ԑ؂*/
#define	UDP_UNKNOWN_IP_ADDRESS		(-4)	/*IPAhXs*/
#define	UDP_RELOCATE_WAIT			(-5)	/*҂Ԓɋ󂯂*/
#define	UDP_SYSTEM_ERROR			(-6)	/*݌vxA܂̓J[lẍُ̌o*/



/********************************************************************/
/*	UDP֐															*/
/********************************************************************/
int		UDPsocket( UdpAddressAndPortInformation *info );
int		UDPclose( UdpAddressAndPortInformation *info );
int		UDPbind( UdpAddressAndPortInformation *info );
int		UDPsendto( UdpAddressAndPortInformation *info );
long	UDPrecvfrom( UdpAddressAndPortInformation *info );

#define	__UDP_DEFINE__
