/* ------------------------------------------------------------------------ */
/*  HOS-V4  kernel configuration                                            */
/*    kernel object ID definition                                           */
/*                                                                          */
/* ------------------------------------------------------------------------ */


#ifndef __HOS_V4__kernel_cfg_h__
#define __HOS_V4__kernel_cfg_h__



/* time tic */
#define TIC_NUME		1
#define TIC_DENO		1


/* task ID definetion */
#define TID_CUI_1		1
#define TID_SCI_SND1		2
#define TID_IDLE		3
#define TID_ETH0		4
#define TID_LINK		5
#define TID_ETH0_SND		6
#define TID_ETH0_EMERS		7
#define TID_HTTPD		8
#define TID_HTTPD2		9
#define TID_HTTPD3		10
#define TID_HTTPD4		11

#define TMAX_TSKID		11


/* semaphore ID definetion */
#define SEMID_MBX		1
#define SEMID_BBS		2
#define SEMID_WEB_CAMERA		3

#define TMAX_SEMID		3


/* event flag ID definetion */
#define FID_RTLINT		1
#define FID_RTLINTSND		2
#define FID_RTLINTOVW		3

#define TMAX_FLGID		16


/* mail box ID definetion */
#define MID_SCI		1
#define MID_VARIABLE_START		2
#define MID_VARIABLE_2		3
#define MID_VARIABLE_3		4
#define MID_VARIABLE_4		5
#define MID_VARIABLE_5		6
#define MID_VARIABLE_6		7
#define MID_VARIABLE_7		8
#define MID_VARIABLE_8		9
#define MID_VARIABLE_9		10
#define MID_VARIABLE_10		11
#define MID_VARIABLE_11		12
#define MID_VARIABLE_END		13
#define MID_ETH0RCV		14
#define MID_ETH0SND		15
#define MID_PINGRCV		16

#define TMAX_MBXID		16


/* message buffer ID definetion */
#define MBF_UDP_LCD_DISPLAY		1

#define TMAX_MBFID		1


/* fixed size memory-pool ID definetion */
#define MPID_IO_LARGE		1
#define MPID_IO_MIDDLE		2
#define MPID_IO_SMALL		3
#define MPID_IO_VERY_SMALL		4
#define MPID_SCI		5
#define MPID_ETH0_RCV_VERY_SMALL		6
#define MPID_ETH0_RCV_SMALL		7
#define MPID_ETH0_RCV_MIDDLE		8
#define MPID_ETH0_RCV_LARGE		9
#define MPID_TUTORIAL2		10

#define TMAX_MPFID		10


/* cyclic handler ID definetion */
#define CYC_ID_RTL8019		1

#define TMAX_CYCID		1



#endif	/* __HOS_V4__kernel_cfg_h__ */


/* ------------------------------------------------------------------------ */
/*  End of file                                                             */
/* ------------------------------------------------------------------------ */
