/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  ITRON4.0dl Real-Time OS                  */
/*    RtBM[Vt@C                                        */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#ifndef    __SYSTEM_CFG__
#define    __SYSTEM_CFG__
#include   "nava_cfg.h"
#endif

/* lbg[Nݒ */
#define ETH0_START_ADDRESS (0x00200000UL)



/* HOS Ǝ̐ݒ */
HOS_IDL_STK(256,NULL);    /*IDEL̃X^bN̈*/
HOS_INT_SP(0xFFFF20);      /*ݎ̃X^bN̏l*/
HOS_MAX_TPRI(8);        /* őDx(ȗ 16) */
/*HOS_KERNEL_HEAP(4096);*/    /* J[lq[v̐ݒ(ȗ 0)FIɂȂ񂩂𐶐鎞ÃIvVL */
HOS_TIM_TIC(1,1);        /* ^CeBbN̐ݒ(ȗ 1/1 ) */
HOS_MIN_INTNO(0);        /* 荞ݔԍ̍ŏl(ȗ 0) */
HOS_MAX_INTNO(63);        /* 荞ݔԍ̍ől(ȗ 0) */
/*HOS_MAX_TSKID(16);*/      /* ő^XNIDԍ(ȗÓIɕKvȂ) */
HOS_MAX_MBXID(16);        /* [{bNX̍ől(ȗ 0)FÓIɐƁAIɐ镪 */
HOS_MAX_FLGID(16);
/*HOS_MAX_CYCID(4);*/        /*nh̍ől*/
/*HOS_MAX_MBFID(4);*/        /*bZ[Wobt@̍ő吔Aȗ͕KvȂ*/

/* CN[ht@C̎w */
INCLUDE("\"netclock3.h\"");
INCLUDE("\"ostimer.h\"");
INCLUDE("\"system.h\"");
INCLUDE("\"itu.h\"");
INCLUDE("\"comm.h\"");

/* OS ^C} */
ATT_INI({TA_HLNG, TIM_1m, ostim_init});

/* ^XNX^bN */
#define    INTERRUPT_MAX_STACK_SZ  32
#define    TERMINAL_STK_SZ    (((((676 + 958 + 256 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)
#define    SCI_SND_STK_SZ    (((((134 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)
#define    IDLE_STK_SZ      (((((684 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)

CRE_TSK(TID_CUI_1,      {TA_HLNG, 1, Terminal, 6, TERMINAL_STK_SZ * 2, NULL});  /*1046*/
/*CRE_TSK(TID_SCI_SND0, {TA_HLNG, 0, SCI_Snd, 8, SCI_SND_STK_SZ * 2, NULL});*/
CRE_TSK(TID_SCI_SND1,   {TA_HLNG, 1, SCI_Snd, 8, SCI_SND_STK_SZ * 2, NULL});  /*80*/
/*CRE_TSK(TID_SCI_SND2, {TA_HLNG, 2, SCI_Snd, 8, SCI_SND_STK_SZ * 2, NULL});*/
CRE_TSK(TID_IDLE,       {TA_HLNG, 0, Idle, 8, IDLE_STK_SZ * 2, NULL});  /*IDLE^XN:986*/

/* Z}tH */
CRE_SEM(SEMID_MBX, {TA_TFIFO, MBX_NUMBER, MBX_NUMBER});    /*[{bNX݂o̊ǗZ}gčs*/

/* [`̒ǉ */
ATT_INI({TA_HLNG, 0, SampleInitialize});

/* 荞݃nh */
ATT_ISR({TA_HLNG, 0, 24, ostim_hdr});    /*stack size = 76*/
/*ATT_ISR({TA_HLNG, 0, 52, SCI_Err});*/    /*stack size = 4*/
/*ATT_ISR({TA_HLNG, 0, 53, Int_SCI_Recv});*/  /*stack size = 24*/
ATT_ISR({TA_HLNG, 1, 56, SCI_Err});      /*stack size = 4*/
ATT_ISR({TA_HLNG, 1, 57, Int_SCI_Recv});  /*stack size = 24*/
/*ATT_ISR({TA_HLNG, 2, 60, SCI_Err});*/    /*stack size = 4*/
/*ATT_ISR({TA_HLNG, 2, 61, Int_SCI_Recv});*/  /*stack size = 24*/



/* Œ蒷v[ */
CRE_MPF(MPID_IO_LARGE,      {TA_TFIFO, LARGE_BLOCKS,      LARGE_BLOCK_SIZE,      NULL});
CRE_MPF(MPID_IO_MIDDLE,     {TA_TFIFO, MIDDLE_BLOCKS,     MIDDLE_BLOCK_SIZE,     NULL});
CRE_MPF(MPID_IO_SMALL,      {TA_TFIFO, SMALL_BLOCKS,      SMALL_BLOCK_SIZE,      NULL});
CRE_MPF(MPID_IO_VERY_SMALL, {TA_TFIFO, VERY_SMALL_BLOCKS, VERY_SMALL_BLOCK_SIZE, NULL});

CRE_MPF(MPID_SCI, {TA_TFIFO, SCI_BLOCK_SIZE, SERIAL_BUFFER_SIZE, NULL});

/* ϒv[ */
/*CRE_MPL(MPLID_SCI, {TA_TFIFO, 256, NULL});*/

/* CxgtO */

/* [{bNX */
CRE_MBX(MID_SCI, {TA_MFIFO, 1, NULL});  
#if 1
CRE_MBX(MID_VARIABLE_START, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_2, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_3, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_4, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_5, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_6, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_7, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_8, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_9, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_10, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_11, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
CRE_MBX(MID_VARIABLE_END, {TA_MFIFO, 1, NULL});  /*݂op̃[{bNXÓIɐꍇ*/
#endif

/* nh̓o^ */

/* bZ[Wobt@ */
CRE_MBF(MBF_UDP_LCD_DISPLAY, {TA_TFIFO,4,32,NULL});



/*lbg[N֌W̐ݒ*/
#define    ETH0_STK_SZ      (((((184 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)
#define    LINK_STK_SZ      (((((444 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)
#define    ETH0_SND_STK_SZ    (((((190 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)
#define    ETH0_EMERS_STK_SZ  (((((190 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)

/*obNOEh^XN(~ł܂)*/
CRE_TSK(TID_ETH0,       {TA_HLNG, ETH0_START_ADDRESS, RtlRecIvent, 3, ETH0_STK_SZ * 2, NULL});
CRE_TSK(TID_LINK,       {TA_HLNG, 0, LinkLayerRecieve, 4, LINK_STK_SZ * 2, NULL});
CRE_TSK(TID_ETH0_SND,   {TA_HLNG, ETH0_START_ADDRESS, RtlSendIvent, 3, ETH0_SND_STK_SZ * 2, NULL});
CRE_TSK(TID_ETH0_EMERS, {TA_HLNG, ETH0_START_ADDRESS, RtlOverWrite, 2, ETH0_EMERS_STK_SZ * 2, NULL});

/*httpdŎgp郊\[X*/
#define    HTTPD_STK_SZ    (((((662 + 1536 + 256 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)

/*CGIdump:CGIdump*/
/*cgi_treva:470*/
/*CGIdns:992*/
/*CGIbbs:1396*/

CRE_TSK(TID_HTTPD,     {TA_HLNG, 1, httpd, 7, HTTPD_STK_SZ * 2, NULL});  /*1220(httpd) + 1548(CGIbbs) + 80(ostim_hdr)*/
CRE_TSK(TID_HTTPD2,    {TA_HLNG, 1, httpd, 7, HTTPD_STK_SZ * 2, NULL});  /*1220(httpd) + 1548(CGIbbs) + 80(ostim_hdr)*/
CRE_TSK(TID_HTTPD3,    {TA_HLNG, 1, httpd, 7, HTTPD_STK_SZ * 2, NULL});  /*1220(httpd) + 1548(CGIbbs) + 80(ostim_hdr)*/
CRE_TSK(TID_HTTPD4,    {TA_HLNG, 1, httpd, 7, HTTPD_STK_SZ * 2, NULL});  /*1220(httpd) + 1548(CGIbbs) + 80(ostim_hdr)*/


/*pPbgMp̌Œ蒷v[̊m*/
CRE_MPF(MPID_ETH0_RCV_VERY_SMALL, {TA_TFIFO, ETH0_VERY_SMALL_BLOCKS, ETH0_VERY_SMALL_BLOCK_SIZE, NULL});
CRE_MPF(MPID_ETH0_RCV_SMALL, {TA_TFIFO, ETH0_SMALL_BLOCKS, ETH0_SMALL_BLOCK_SIZE, NULL});
CRE_MPF(MPID_ETH0_RCV_MIDDLE, {TA_TFIFO, ETH0_MIDDLE_BLOCKS, ETH0_MIDDLE_BLOCK_SIZE, NULL});
CRE_MPF(MPID_ETH0_RCV_LARGE, {TA_TFIFO, ETH0_LARGE_BLOCKS, ETH0_LARGE_BLOCK_SIZE, NULL});



/*荞݃nh*/
/*ATT_ISR({TA_HLNG, ETH0_START_ADDRESS, 17, ETH0Trap});*/
CRE_CYC(CYC_ID_RTL8019, {TA_HLNG, ETH0_START_ADDRESS, ETH0Trap, 4, NULL});  /*stack size=70*/

/*vgRKwԒʐMp[{bNX*/
CRE_MBX(MID_ETH0RCV, {TA_MFIFO, 1, NULL});
CRE_MBX(MID_ETH0SND, {TA_MFIFO, 1, NULL});
CRE_MBX(MID_PINGRCV, {TA_MFIFO, 1, NULL});

/*ETH0CxgtO*/
CRE_FLG(FID_RTLINT, {TA_TFIFO | TA_WSGL , 0});
CRE_FLG(FID_RTLINTSND, {TA_TFIFO | TA_WSGL , 0});
CRE_FLG(FID_RTLINTOVW, {TA_TFIFO | TA_WSGL , 0});

/*fAvP[VŎgpZ}tH*/
CRE_SEM(SEMID_BBS, {TA_TFIFO, 1, 1});

/*`[gAQŎgpŒ蒷v[*/
CRE_MPF(MPID_TUTORIAL2, {TA_TFIFO, 1, 2048, NULL});

/*`[gARŎgpIuWFNg̐*/
#define    TUTORIAL3_STK_SZ  (((((2048 + INTERRUPT_MAX_STACK_SZ) - 1) / 256) + 1) * 256)

/*ATT_INI({TA_HLNG, 0, SNTPSyncTimerCounterInit});*/  /* NTPp^C}[̏ */
/*ATT_ISR({TA_HLNG, 0, 32, SNTPSyncTimerCounterInt});*/  /*stack size = 64*/
/*CRE_FLG(FID_TUTORIAL3, {TA_TFIFO | TA_WSGL | TA_CLR, 0});*/
/*CRE_TSK(TID_TUTORIAL3, {TA_HLNG, 1, tuto_3, 8, TUTORIAL3_STK_SZ * 2, NULL});*/

/*LEDvŎgp^C}[荞݃nh̓o^*/
/*ATT_INI({TA_HLNG, TIM_2m, DynamicScanLEDUpdateInit});*/  /* I_vp^C}[̏ */
/*ATT_ISR({TA_HLNG, 0, 28, DynamicScanLEDUpdate});*/  /*stack size = 4*/

/*WEB CAMERAŎgpZ}tH̓o^*/
CRE_SEM(SEMID_WEB_CAMERA, {TA_TFIFO, 1, 1});

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
