/* ----------------------------------------------------------------------- */
/*  HOS-V4    Navajo network configuration Header file.                    */
/*                                  Copyright (C) 2003- by hamayan         */
/* ----------------------------------------------------------------------- */

#ifdef	__SYSTEM_CFG__
#define	ETH0_VERY_SMALL_BLOCK_SIZE	128
#define	ETH0_VERY_SMALL_BLOCKS	16
#define	ETH0_SMALL_BLOCK_SIZE	256
#define	ETH0_SMALL_BLOCKS	8
#define	ETH0_MIDDLE_BLOCK_SIZE	640
#define	ETH0_MIDDLE_BLOCKS	4
#define	ETH0_LARGE_BLOCK_SIZE	1536
#define	ETH0_LARGE_BLOCKS	8

#define	ETH0_RCV_VERY_SMALL_SZ	2048
#define	ETH0_RCV_SMALL_SZ	2048
#define	ETH0_RCV_MIDDLE_SZ	2560
#define	ETH0_RCV_LARGE_SZ	12288
#endif

#ifndef	__SYSTEM_CFG__
extern unsigned char ThisIs[];
extern unsigned char SubNetMask[];
extern unsigned char NetWorkAddress[];
extern unsigned char LocalHost[];
extern unsigned char GateWay[];
extern unsigned char DomainNameServer[];
extern unsigned char BroadCast[];
extern unsigned char SubNetBroadCast[];
extern unsigned char NTPServer[];
extern unsigned char SMTPServer[];
extern unsigned char POP3Server[];
extern unsigned char SYSLOGServer[];
#endif

#define ETH0_START_ADDRESS (0x00200000UL)



/* ----------------------------------------------------------------------- */
/*  End of file                                                            */
/*                                  Copyright (C) 2003- by hamayan         */
/* ----------------------------------------------------------------------- */
