/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  TvvO                           */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */


#ifndef __sample_h__
#define __sample_h__


#ifdef __cplusplus
extern "C" {
#endif

void SampleInitialize(VP_INT exinf);	/* ATT_INI o^̊֐ */
void Idle( VP_INT exinf );				/*IDLE^XN*/
void SCI_Snd(VP_INT handle);			/*Mp^XN*/
void LinkLayerRecieve( VP_INT exinf );	/*LINKw̃^XN*/
#if 0
void RtlRecIvent( volatile union RTL8019AS *eth );
void RtlOverWrite( volatile union RTL8019AS *eth );
void RtlSendIvent( volatile union RTL8019AS *eth );
void ETH0Trap( volatile union RTL8019AS *eth );
#else
void RtlRecIvent( VP_INT eth );
void RtlOverWrite( VP_INT eth );
void RtlSendIvent( VP_INT eth );
void ETH0Trap( VP_INT eth );
#endif
void Terminal( VP_INT handle );			/*[U[C^tF[X^XN*/
void MBXUdpClockTask( VP_INT handle );	/*[{bNXgUDPAvP[V^XN*/
void UdpEchoServerTask( VP_INT handle );	/*UDP ECHOT[o[*/
void Int_SCI_Recv(VP_INT handle);		/*SCIM荞*/
void CycActTimerInt( VP_INT exinf );	/*荞*/
void SCI_Err( VP_INT exinf );			/*SCIG[荞*/
void httpd( VP_INT handle );

void SNTPSyncTimerCounterInit( void );
void SNTPSyncTimerCounterInt( VP_INT exinf );
void tuto_3( VP_INT exinf );

void DynamicScanLEDUpdateInit(VP_INT TimeFactor);
void DynamicScanLEDUpdate(VP_INT exinf);

#ifdef __cplusplus
}
#endif

#endif	/* __sample_h__ */


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
