/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*	[U[C^tF[X̎											*/
/*                                  Copyright (C) 2003-2004 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#define  __THIS_IS_CUI_C__
#include	"derivative.h"
#undef  __THIS_IS_CUI_C__

#define	BACKSPACE	0x08
#define	USER_BREAK	0x03

/********************************************************************/
/*	^[~iT[o[												*/
/*	[U[C^tF[XłB									*/
/********************************************************************/
void Terminal( VP_INT handle )
{
	RegistProcessTable( _FOR_GROUND_, FALSE );		/*PROCESSo^*/

	SCI_Puts( handle, "User Interface Start. Type Enter Key." );

	while( 1 )
	{
		/*vZXKILLꂽf*/
		if( QueryRunningMode() == EOF ) break;
		/*LN^[C^tF[X*/
		cui( handle );
		dly_tsk( 100 );
	}
	RelocateProcessTable();
	ext_tsk();						/*TASK̏I*/
}

/********************************************************************/
/*	wC^tF[Xs荞ݏ							*/
/*	buf͊i[Ahandle̓nhABufSz̓obt@̃TCY			*/
/*	߂lɊi[AhXԂA[U[A{[g̎NADR	*/
/*	ԂB															*/
/********************************************************************/
char *GetLine( char *buf, int handle, int BufSz )
{
	char		c,*str;

	str = buf;
	while( 1 )
	{
		while( RecByteSize( handle ) <= 0 ) dly_tsk( 100 );	/*擾҂*/
		c = SCI_Getc( handle );
		if( c == USER_BREAK ) return (char *)NADR;	/*[U[u[N̎͏I*/
		SCI_Putc( handle, c );					/*GR[obN*/
		if( c == '\r' ) break;					/*s̂Ŏ̏*/
		if( str == &buf[ BufSz ] )				/*obt@tɂȂĂ܂̂łȏ̎荞݂~߂*/
		{
			SCI_Purge( handle );				/*͂FLASHďI*/
			*(--str) = '\0';					/*Iɕɕϊ*/
			return buf;
		}
		if( c == BACKSPACE )					/*ȒPBACK SPACEւ̑Ή*/
		{
			if( str != buf ) str--;
			continue;
		}
		*str++ = c;
	}
	SCI_Putc( handle , '\n' );
	*str = '\0';								/*sPʂɕɕϊ*/

	return buf;
}

/********************************************************************/
/*			LN^[U[C^tF[X						*/
/*	sobt@̃TCÝA[U[AvP[VɈˑ̂ŁA	*/
/*	KX傫邩ALgpKvL܂B			*/
/********************************************************************/
static void cui( int handle )
{
	char	linebuf[ LINE_BUFFER_SIZE ];

	if( RecByteSize( handle ) <= 0 ) return;	/*Mf[^TCY𒲂ׂ*/
	/*s荞*/
	GetLine( linebuf, handle, sizeof(linebuf) );
	/*R}h*/
	command( linebuf, handle );
	/*vvg̕\*/
	SCI_Puts( handle, "Navajo:>" );
}

/********************************************************************/
/*			helps												*/
/********************************************************************/
static void help( int argc, char *argv[], int handle )
{
	int i;
	i = 0;
	while (help_msg[i]) {
		/* SCI_Puts 200𒴂o͂͂łȂ */
		SCI_Puts( handle, help_msg[i] );
		i++;
	}
}

/********************************************************************/
/*		[gfBNgXg									*/
/********************************************************************/
static const COMMAND_LIST RootList[] =
{
	{RootDir,	"/"},
	{ChainDir,	"/bin"},
};

/********************************************************************/
/*			[gXg											*/
/********************************************************************/
static void RootDir( int argc, char *argv[], int handle )
{
	char			buf[ 32 ];
	const COMMAND_LIST	*list = &RootList[1];

	while( list < &RootList[ sizeof(RootList) / sizeof(COMMAND_LIST) ] )
	{
		sprintf( buf, "%25s\r\n", list->funcname );
		SCI_Puts( handle, buf );
		list++;
	}
}

/********************************************************************/
/*			fBNgs										*/
/********************************************************************/
static void ChainDir( int argc, char *argv[], int handle )
{
	dir( argc - 1, &argv[ 1 ], handle );
}

/********************************************************************/
/*			fBNgs										*/
/********************************************************************/
static void dir( int argc, char *argv[], int handle )
{
	char		buf[ 32 ];
	const COMMAND_LIST *fn;

	if( argc == 1 )
	{
		fn = CommandList;
		while( fn < &CommandList[ sizeof(CommandList)/sizeof(COMMAND_LIST) ] )
		{
			sprintf( buf, "%25s\r\n", fn->funcname );
			SCI_Puts( handle, buf );
			fn++;
		}
	}
	else
	{
		fn = RootList;
		while( fn < &RootList[ sizeof(RootList)/sizeof(COMMAND_LIST) ] )
		{
			if( strcmp( fn->funcname, argv[ 1 ] ) == 0 )
			{
				(*fn->func)( argc, argv, handle );
			}
			fn++;
		}
	}
}

/********************************************************************/
/*			o^R}hs										*/
/********************************************************************/
int	command( char *cmd, int handle )
{
	int		argc;
	char	*argv[ 10 ],buf[ 128 ];
	COMMAND_LIST *fn;

	if( *cmd == '\0' ) return 0;	/*ȂNULL͉ŝݓ͂ꂽꍇɔ*/
	/*R}hs𕡐̕ɕ*/
	argc = split( cmd , argv, sizeof(argv)/sizeof(char*) );
	/*o^֐ŊY֐R[*/
	fn = (COMMAND_LIST *)CommandList;
	while( fn < &CommandList[ sizeof(CommandList)/sizeof(COMMAND_LIST) ] )
	{
		if( strcmp( fn->funcname, argv[ 0 ] ) == 0 )
		{
			(*fn->func)( argc, argv, handle );
			return 0;
		}
		fn++;
	}
	if( strlen( argv[ 0 ] ) > LINE_BUFFER_SIZE )		/*~b^[*/
	{
		SCI_Puts( handle, "Parameter Error\r\n" );
		return EOF;
	}

	sprintf( buf, "%s: command not found\r\n", argv[0] );
	SCI_Puts( handle, buf );
	return EOF;
}

/********************************************************************/
/*			񕪊[eBeB								*/
/*	str͕ΏەAstore̓|C^̕ۑAsz͍őۑ*/
/*	߂l͕ۑԂ											*/
/********************************************************************/
int	split( char *str , char *argv[], int sz )
{
	int		argc = 0;

	while( *str != '\0' && argc < sz )
	{
		if( isgraph( *str ) != 0 )
		{
			argv[ argc++ ] = str;
			while( *str != '\0' && isgraph( *str ) != 0 ) str++;
		}
		else *str++ = '\0';
	}

	return argc;
}

/********************************************************************/
/*	V䂳Anslookup(^.^)										*/
/********************************************************************/
static void nslookup( int argc, char *argv[], int handle )
{
  int		ret;
  unsigned char addr[4];
  char 		addr_str[(3+1)*4 + 4];
  char	 	*errs[] = {
    "too long domainname.\r\n",
    "bad id of respond packet.\r\n",
    "bad answer.\r\n",
    "UDP packet send failure.\r\n",
    "fail to make UDP socket.\r\n",
  };
 
//  if ( ( ret = getaddrbydns( argv[1], addr, handle)) < 0) {
  if ( ( ret = getaddrbydns( argv[1], (char *)addr )) < 0)
  {
    /* ڂ͗LAR[hLbVĂȂΎs */
//    if ( ( ret = getaddrbydns( argv[1], addr, handle)) < 0) {
    if ( ( ret = getaddrbydns( argv[1], (char *)addr )) < 0 )
    {
      SCI_Puts( handle, errs[-1-ret] );
      SCI_Puts( handle, "lookup failure.\r\n" );
      return;
    }
  }

  sprintf( addr_str, "%u.%u.%u.%u\r\n", addr[0],addr[1],addr[2],addr[3]);
  SCI_Puts( handle, addr_str );
}

/********************************************************************/
/*	BUILD\													*/
/********************************************************************/
extern char	BuildNumber[];
static void BuildVersion( int argc, char *argv[], int handle )
{
	SCI_Puts( handle, BuildNumber );
	SCI_Puts( handle, "\r\n" );
}

/********************************************************************/
/*	IPAhX̕												*/
/*	̊֐strtokgĂ̂ŃGggł͖Ǝv	*/
/*	܂Bp̂͏[ӂĉB							*/
/*	iṕÅi[Aparam͕							*/
/********************************************************************/
int IPAddSplit( unsigned char ip[], char *param )
{
	int		i,fdqn = 0;	/*FDQNŗvĂ鎞͂PƂ*/
	char	*str = param;

	/*̏I܂Ń[vAAt@xbggĂ鎞́AFDQNƂ݂ȂB*/
	while( *str != '\0' )
	{
		if( isalpha( *str++ ) )
		{
			fdqn = 1;
			break;
		}
	}
	str = param;

#ifdef  __DNS_USE__
	if( fdqn == 0 )
	{
		/*IPAhX̕*/
		ip[ 0 ] = atoi( strtok( str, "." ) );
		for( i = 1; i < 4; i++ ) ip[ i ] = atoi( strtok( NULL, "." ) );
	}
	else
	{
		if ( getaddrbydns( str, ip, SCI_1 ) < 0 )
		{
			/* ڂ͗LAR[hLbVĂȂΎs */
			if( getaddrbydns( param, ip, SCI_1 ) < 0 ) return EOF;
		}
	}
#else	/*DNS QuerySgȂꍇ*/
	/*IPAhX̕*/
	ip[ 0 ] = atoi( strtok( str, "." ) );
	for( i = 1; i < 4; i++ ) ip[ i ] = atoi( strtok( NULL, "." ) );
#endif	/*__DNS_USE__*/

	return 0;
}


/********************************************************************/
/*	^XÑX^[gsB										*/
/********************************************************************/
static void TaskStart( int argc, char *argv[], int handle )
{
	int		tid;

	/*p[^[̃`FbN*/
	if( argc != 2 )
	{
		SCI_Puts( handle, "PARAMETER ERROR\r\n" );
		return;
	}
	/*p[^[^XNID擾B*/
	sscanf( argv[1], "%d", &tid );
	/*^XN̋N*/
	act_tsk( (ID)tid );				/*^XN̋N*/
}

/********************************************************************/
/*	CUIs:Memory Dump												*/
/*	̊֐̓Gggł͖B								*/
/********************************************************************/
static void CUIdump( int argc, char *argv[], int handle )
{
	char	*ptr,buf[16];
	int		i,j;
	static VP	adr = (VP)0;	/*l*/
	VP		blk;

	/*p[^[̐AAAhXw肩𔻒fB*/
	if( argc == 1 ){}
	else if( argc == 2 )
	{
		adr = (VP)0;
		/*p[^[擾*/
		ptr = argv[1];
		/*ASCIIAhXϊsB*/
		for( i = 0; i < 32; i += 4 )
		{
			if( isdigit( *ptr ) || (*ptr >= 'A' && *ptr <= 'F') || (*ptr >= 'a' && *ptr <= 'f') )
			{
				adr = (VP)(((unsigned long)adr) << 4);
				adr = ( isdigit(*ptr) ) ? (VP)((char *)adr + (*ptr - '0')) : (VP)((char *)adr + ((*ptr | 0x20) - 'a' + 10));
			}
			else break;
			ptr++;
		}
	}
	else return;

	/*L̎؂o*/
	blk = GetMemBlock( 128 );
	/*DUMP̕\*/
	for( i = 0; i < 256; i += 16 )
	{
		sprintf( buf, "%08lX:", (unsigned long)adr );
		strcpy( (char *)blk, buf );
		for( j = 0; j < 16; j++ )
		{
			if( j == 8 ) strcat( blk, " " );
			sprintf( buf, "%02X,", *((unsigned char *)adr + j) );
			strcat( (char *)blk, buf );
		}
		strcat( blk, " " );
		for( j = 0; j < 16; j++ )
		{
			if( j == 8 ) strcat( blk, " " );
			sprintf( buf, "%c", ( isprint(*((char *)adr + j)) ) ? *((char *)adr + j) : '.' );
			strcat( (char *)blk, buf );
		}
		strcat( (char *)blk, "\r\n" );
		SCI_Puts( handle, (const char *)blk );
		adr = (VP)((char *)adr + 16);
	}

	/*L̕ԋp*/
	RelMemBlock( blk );
}

/********************************************************************/
/*  eT[rXsT[o[IPAhXw                      */
/*  RtBM[^Őݒ肳NTPT[o[AhX̕ύXsB */
/*  R}hCC^tF[XĂ΂B                      */
/********************************************************************/
void servicecfg( int argc, char *argv[], int handle )
{
	char	buf[80];
	unsigned char dip[4];

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc == 1 )
	{
		if( strncmp( "ntpcfg", argv[0], sizeof("ntpcfg") - 1 ) == 0 )
			sprintf( buf, "    %u.%u.%u.%u\r\n", NTPServer[0], NTPServer[1], NTPServer[2], NTPServer[3] );
		else if( strncmp( "smtpcfg", argv[0], sizeof("smtpcfg") - 1 ) == 0 )
			sprintf( buf, "    %u.%u.%u.%u\r\n", SMTPServer[0], SMTPServer[1], SMTPServer[2], SMTPServer[3] );
		else if( strncmp( "pop3cfg", argv[0], sizeof("pop3cfg") - 1 ) == 0 )
			sprintf( buf, "    %u.%u.%u.%u\r\n", POP3Server[0], POP3Server[1], POP3Server[2], POP3Server[3] );
		else if( strncmp( "syslogcfg", argv[0], sizeof("syslogcfg") - 1 ) == 0 )
			sprintf( buf, "    %u.%u.%u.%u\r\n", SYSLOGServer[0], SYSLOGServer[1], SYSLOGServer[2], SYSLOGServer[3] );
		else sprintf( buf, "%s 192.168.100.16 or %s fdqn\r\n", argv[0], argv[0] );

		SCI_Puts( handle, buf );
	}
	else if( argc != 2 || IPAddSplit( dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		sprintf( buf, "%s 192.168.100.16 or %s fdqn\r\n", argv[0], argv[0] );
		SCI_Puts( handle, buf );
	}
	else
	{
		if( strncmp( "ntpcfg", argv[0], sizeof("ntpcfg") - 1 ) == 0 ) memcpy( NTPServer, dip, LENGTHIPV4 );
		else if( strncmp( "smtpcfg", argv[0], sizeof("smtpcfg") - 1 ) == 0 ) memcpy( SMTPServer, dip, LENGTHIPV4 );
		else if( strncmp( "pop3cfg", argv[0], sizeof("pop3cfg") - 1 ) == 0 ) memcpy( POP3Server, dip, LENGTHIPV4 );
		else if( strncmp( "syslogcfg", argv[0], sizeof("syslogcfg") - 1 ) == 0 ) memcpy( SYSLOGServer, dip, LENGTHIPV4 );
		else {}
	}
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 2003-2004 by hamayan                                      */
/* ------------------------------------------------------------------------ */
