/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*  ʏAWEBT[o[Ȃ畽sT[o[ŃNGXg󂯕t܂A		*/
/*  vÓAT[o[ŎsĂ܂BTCPZbVɁAʂ	*/
/*  NGXg󂯂ꍇ̏Ă܂̂ŁAxɂPNGXg	*/
/*  œĉB													*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"

#if 0
#undef	WWW
#define	WWW		8080
#endif

/********************************************************/
/*	O֐Q										*/
/********************************************************/
/*񏈗֐*/
int		split( char *str , char *store[], int sz );

static	int		RequestURLCheck( char *argv[] );
static	int		RequestMethodCheck( char *argv[] );
static	int		HttpdGetLine( char *dest, const char *source, char **next, int dest_limit , int source_limit );
static	int		cgi_method( TcpAddressAndPortInformation *info, char *argv[], int argc );

static int NavajoInfo( TcpAddressAndPortInformation *info, int argc, char *argv[] );

extern char	BuildNumber[];

/********************************************************************/
/*	TCPpTv												*/
/********************************************************************/
static const char HtmlHead[] =
{
	"HTTP/1.0 200 OK\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: text/html; charset=Shift_JIS\r\n\r\n"
};

static const char HtmlRes404[] =
{
	"HTTP/1.0 404 Not Found\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: text/html; charset=Shift_JIS\r\n\r\n"
	"<html lang=\"ja\"><head><title>404 Not Found</title></head>\r\n"
	"<h1>Not Found</h1>\r\n"
	"</body></html>\r\n\r\n"
};

static const char HtmlRes400[] =
{
	"HTTP/1.0 400 Bad Request\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: text/html; charset=Shift_JIS\r\n\r\n"
	"<html lang=\"ja\"><head><title>400 Bad Request</title></head>\r\n"
	"<h1>Bad Request</h1>\r\n"
	"</body></html>\r\n\r\n"
};

static const char HtmlHeadBMP[] =
{
	"HTTP/1.0 200 OK\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: image/bmp\r\n\r\n"
};

static const char HtmlHeadJPEG[] =
{
	"HTTP/1.0 200 OK\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: image/JPEG\r\n\r\n"
};

static const char HtmlHeadGIF[] =
{
	"HTTP/1.0 200 OK\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: image/GIF\r\n\r\n"
};

static const char HtmlHeadPNG[] =
{
	"HTTP/1.0 200 OK\r\n"
	"Server: Navajo/" NAVAJO_VERSION "\r\n"
	"Content-Type: image/PNG\r\n\r\n"
};

#define	LINE_BUFFER_SIZE	640

static int	access_count = 0;

void httpd( VP_INT handle )
{
typedef struct
{
	int			number;		/*s*/
	int			limit;		/*Ɨpobt@̎c*/
	int			argc;		/**/
	char		*buffer;	/*Ɨpobt@AhX*/
	char		*ptr;		/*obt@̍ƈʒu*/
	char		*next;		/*̃|C^*/
	char		*argv[ 4 ];	/*𕪉̃|C^ۑp*/
} ANALYSING_LINE;

	char	*ptr,*buffer;
	int		find_count,res_type;
	long	length;
	ANALYSING_LINE	al;
	TcpAddressAndPortInformation info;		/*TCPڑ*/

	/*Ɨp̊l*/
	buffer = (char *)GetMemBlock( LINE_BUFFER_SIZE );
	/*vZXe[uɓo^s*/
	RegistProcessTable( _BACK_GROUND_, TRUE );
	/*^XN*/
	while( 1 )
	{
		/*\Pbg̐*/
		if( TCPsocket( &info ) != 0 )
		{
			dly_tsk( 100 );
			continue;
		}
		/*|[gԍ擾*/
		info.sport = WWW;				/*AvP[VŎwFKv*/
		/*bind*/
		TCPbind( &info );
		/*listen*/
		if( TCPlisten( &info ) == EOF )
		{
			TCPForceCloseState( &info );	/*ICLOSEDɑJڂB*/
			continue;	/*\PbgyAGgւ̓o^ɎsƁAEOFԂėB*/
		}

		/*[U[ŎMobt@̈o^*/
		TCPRegistReceiveBufferArea( &info, buffer, LINE_BUFFER_SIZE );
		/*accept*/
		if( TCPaccept( &info ) == 0 )
		{
			find_count = 0;
			/*s͗pp[^[ݒ*/
			al.ptr = al.buffer = (char *)GetMemBlock( LINE_BUFFER_SIZE );	/*Ɨp̊l*/
			al.number = 0;
			al.limit = LINE_BUFFER_SIZE;
			/*read*/
			while( 1 )
			{
				info.tmout = 60000;	/*^CAEgԂ1ԂƂB*/
				length = TCPread(&info, buffer, LINE_BUFFER_SIZE);
				if( (length > 0) && (info.STATES == TCP_STATE_ESTABLISHED) )	/*Mf[^LAESTABLISHED̎ɎMwb_[̉͂ɐiށB*/
				{
					ptr = buffer;
					/*擪s̎擾*/
					if( al.number == 0 )
					{
						res_type = HttpdGetLine( al.ptr, buffer, &al.next, al.limit, length );	/*s荞ށB*/
						if( res_type == 0 )	/*Ɏ荞񂾎*/
						{
							al.number++;	/*s荞݂ɐꍇ̏*/
							*al.next = '\0';	/*Iɕɕϊ*/
							ptr = ptr + (unsigned long)(al.next - al.buffer) + 1;	/*݈̏ʒuɈړ*/
						}
						else if( res_type == -1 )	/*s荞ݗ̈gꍇ*/
						{
							al.buffer[ LINE_BUFFER_SIZE - 1 ] = '\0';
							al.number++;	/*͕s\*/
						}
						else	/*SĂ̎Mf[^ǂݏôɁAsoȂ*/
						{
							al.ptr = al.next;	/*݈̏ʒuɈړ*/
							al.limit = LINE_BUFFER_SIZE - (unsigned long)(al.next - al.buffer);	/*߂̍ČvZ*/
						}
					}
					if( al.number )
					{
						/*NGXgwb_[̏IoB*/
						while( ptr < &buffer[ length ] )
						{
							if( *ptr == '\r' || *ptr == '\n' )	/*šo*/
							{
								if( ++find_count == 4 ) break;	/*蔲oB4Ast鎖ɂȂBԂ͖*/
							}
							else find_count = 0;
							ptr++;
						}
						if( find_count == 4 || info.STATES == TCP_STATE_CLOSE_WAIT )	/*ołAFINMꍇ*/
						{
							TCPRegistReceiveBufferArea( &info, buffer, LINE_BUFFER_SIZE );
							TCPAnnounceReceiveBufferSize( &info );
							break;
						}
					}
					/*obt@󂢂LBȂƉėȂ\LB*/
					TCPRegistReceiveBufferArea( &info, buffer, LINE_BUFFER_SIZE );
					TCPAnnounceReceiveBufferSize( &info );
				}
				else break;
			}

			/*write*/
			if( (length >= 0) && (info.STATES == TCP_STATE_ESTABLISHED) )	/*ƂāAɎM̂݁AMɈڂB*/
			{
				/*CGI:͊Jn*/
				al.argc = split( al.buffer, al.argv, sizeof(al.argv)/sizeof(char*) );
				res_type = RequestURLCheck( al.argv );	/*NGXgURL̃`FbN*/
				res_type = (res_type == 200) ? RequestMethodCheck( al.argv ) : res_type;	/*Method̃`FbN*/

				switch (res_type)
				{
					case 200 :
						/*access_count̔rsB*/
						dis_dsp();
						access_count++;
						ena_dsp();
						/*CGI:͊Jn*/
/*						al.argc = split( al.buffer, al.argv, sizeof(al.argv)/sizeof(char*) );*/
						/*\bh̎s*/
						cgi_method( &info, al.argv, al.argc );
						TCPclose( &info );
						break;

					case 404 :
						if( TCPwrite( &info, (void *)HtmlRes404, sizeof(HtmlRes404) - 1 ) >= EOF ) TCPclose( &info );
						else TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/
						break;

					case 400 :
						if( TCPwrite( &info, (void *)HtmlRes400, sizeof(HtmlRes400) - 1 ) >= EOF ) TCPclose( &info );
						else TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/
						break;
					default :
						break;
				}
			}
			else if( info.STATES == TCP_STATE_CLOSE_WAIT )	/*FINMꍇ*/
				TCPclose( &info );
			else	/*^CAEgُȈ*/
				TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/
			/*̊J*/
			RelMemBlock( (VP)al.buffer );
		}
		else
			TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/

		/*vZXKILLꂽf*/
		if( QueryRunningMode() == -1 ) break;
	}
	/*̊J*/
	RelMemBlock( (VP)buffer );

	/*vZXe[u甲*/
	RelocateProcessTable();
	/*TASK̏I*/
	ext_tsk();
}

/********************************************************************/
/*	s荞ݏ												*/
/*	buffer͕ۑAlimit́AAnextdest݈̎̏ʒu */
/*	߂l															*/
/*	destɐɃRs[łAA䕶AO		*/
/*	destɐɃRs[łA䕶ȂAP		*/
/*	destɐɃRs[łȂA|P							*/
/********************************************************************/
static int HttpdGetLine( char *dest, const char *source, char **next, int dest_limit , int source_limit )
{
	const char	*source_ptr;

	*next = dest;
	source_ptr = source;
	while( *next < &dest[dest_limit] && source_ptr < &source[source_limit] )
	{
		/*䕶̌*/
		if( *source_ptr == '\r' ||  *source_ptr == '\n' )
		{
			return 0;
		}
		/*\\̂݃Rs[*/
		if( isprint( *source_ptr ) )
		{
			**next = *source_ptr;
			*next += 1;
		}

		source_ptr++;
	}
	if( *next == &dest[dest_limit] ) return -1;
	return 1;
}

/********************************************************************/
/*	CGIs															*/
/********************************************************************/
typedef	struct
{
	int		(* fn)(TcpAddressAndPortInformation *info,int argc,char *argv[]);
	char	*name;
} METHOD_LIST;

typedef	struct
{
	const FILE_PROPERTIES *file;
	char	*name;
	int		type;
} URL_LIST;

extern const FILE_PROPERTIES index_html;	/*ÓIRecƂāAʃt@Cɍ쐬*/
extern const FILE_PROPERTIES navajo_png;	/*S*/
extern const FILE_PROPERTIES memdump_html;
extern const FILE_PROPERTIES memdump_cgi;	/*h8300h:646*/
extern const FILE_PROPERTIES webcam_html;
extern const FILE_PROPERTIES treva_bmp;		/*h8300h:484*/
extern const FILE_PROPERTIES dns_html;
extern const FILE_PROPERTIES dns_cgi;		/*h8300h:1442*/
extern const FILE_PROPERTIES bbs_html;
extern const FILE_PROPERTIES bbs_cgi;		/*h8300h:1410*/
extern const FILE_PROPERTIES TimeCompensation_bmp;	/*h8300h:640*/
extern const FILE_PROPERTIES ifconfig_cgi;

extern const FILE_PROPERTIES lcd_cgi;
extern const FILE_PROPERTIES lcdtop_html;

static const FILE_PROPERTIES info_html;		/*h8300h:898*/

/********************************************************************/
/*	T|[gURL													*/
/*	ӁI̓sAя́Ȃ傫ɕׂĉB	*/
/*																	*/
/*	[U[CGIǉ鎞́A܂Ɋ֐AhXƃGCAX	*/
/*	o^܂B													*/
/********************************************************************/
static const URL_LIST urlList[] =
{
#ifdef	__NETCLOCK3_3069_20__
	{&TimeCompensation_bmp,	"/image/TimeCompensation.bmp",	AddType_IMAGE},
	{&navajo_png,	"/image/navajo.png",	AddType_IMAGE},
	{&memdump_html,	"/memdump.html",	AddType_TXT},	/*h8300h:668*/
	{&memdump_cgi,	"/memdump.cgi",		AddType_TXT},	/*h8300h:1118*/

	{&index_html,	"/index.html",		AddType_TXT},	/*h8300h:720*/
	{&index_html,	"/index.htm",		AddType_TXT},	/*h8300h:720*/

	{&info_html,	"/info.html",		AddType_TXT},
	{&dns_html,		"/dns.html",		AddType_TXT},	/*h8300h:644*/
	{&dns_cgi,		"/dns.cgi",			AddType_TXT},	/*h8300h:1114*/
	{&bbs_cgi,		"/bbs.cgi",			AddType_TXT},	/*h8300h:1098*/

	{&index_html,	"/",				AddType_TXT},
#endif	/*__NETCLOCK3_3069_20__*/
};

/********************************************************************/
/*	CGIs:NGXgꂽURL̃`FbN							*/
/*	YURL݂200ԂBȂ404				*/
/*	LURLXg猟sAƎ蔲ŕ̑傫	*/
/*	ɕׂȂƐłȂB							*/
/********************************************************************/
static int RequestURLCheck( char *argv[] )
{
	const URL_LIST *url = urlList;
	char	*str;

	while( url < &urlList[sizeof(urlList)/sizeof(URL_LIST)] )
	{
		/*NGXgURĽ*/
		if( strncmp( url->name, argv[RQUEST_URL], strlen(url->name) ) == 0 )
		{
			if( strcmp( url->name, "/" ) == 0 )	/*[g܂ŒBB*/
			{
				str = argv[RQUEST_URL];
				if( str[1] != '\0' ) return 404;	/*URL1łȂ́AsvƔf*/
			}
			return 200;
		}
		url++;
	}
	return 404;
}

static	int		HttpdGet( TcpAddressAndPortInformation *info, int argc, char *argv[] );

/********************************************************************/
/*	T|[gMETHOD												*/
/********************************************************************/
static const METHOD_LIST method[] =
{
	{HttpdGet,		"GET"},
#if 0
	{HttpdPost,		"POST"},
	{HttpdHead,		"HEAD"},	/*HEADɗ̂ŃT|[gȂ*/
	{Httpdput,		"PUT"},
	{HttpdOption,	"OPTION"},
	{HttpdConnect,	"CONNECT"},
	{HttpdDelete,	"DELETE"},
	{HttpdTrace,	"TRACE"},
#endif
};

/********************************************************************/
/*	CGIs:NGXgꂽMETHOD̃`FbN						*/
/*	YMETHOD݂200ԂBȂ400			*/
/********************************************************************/
static int RequestMethodCheck( char *argv[] )
{
	const METHOD_LIST *meth = method;

	while( meth < &method[sizeof(method)/sizeof(METHOD_LIST)] )
	{
		/*\bȟ*/
		if( strcmp( meth->name, argv[METHOD] ) == 0 ) return 200;
		meth++;
	}
	return 400;
}

/********************************************************************/
/*	CGIs:METHOD													*/
/********************************************************************/
static int cgi_method( TcpAddressAndPortInformation *info, char *argv[], int argc )
{
	const METHOD_LIST *meth = method;

	while( meth < &method[sizeof(method)/sizeof(METHOD_LIST)] )
	{
		/*\bȟ*/
		if( strcmp( meth->name, argv[METHOD] ) == 0 ) return meth->fn( info, argc, argv );
		meth++;
	}
	return -1;		/*{Aɂ͗Ȃ*/
}

/********************************************************************/
/*	CGIs:GET														*/
/********************************************************************/
static int HttpdGet( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	char	*ext,*head;
	const URL_LIST *url = urlList;

	while( url < &urlList[sizeof(urlList)/sizeof(URL_LIST)] )
	{
		/*CGǏ*/
		if( strncmp( url->name, argv[RQUEST_URL], strlen(url->name) ) == 0 )
		{
			/*httpdwb_[̏o*/
			switch ( url->type )
			{
				case AddType_IMAGE :	/*C[W^Cṽwb_[̏ꍇAXɊgqŔfKvB*/
					ext = strchr( argv[RQUEST_URL], '.' ) + 1;
					if( strncmp( "bmp", ext, sizeof("bmp") - 1) == 0 ) head = (char *)HtmlHeadBMP;
					else if( strncmp( "jpg", ext, sizeof("jpg") - 1) == 0 ) head = (char *)HtmlHeadJPEG;
					else if( strncmp( "jpeg", ext, sizeof("jpeg") - 1) == 0 ) head = (char *)HtmlHeadJPEG;
					else if( strncmp( "gif", ext, sizeof("gif") - 1) == 0 ) head = (char *)HtmlHeadGIF;
					else if( strncmp( "png", ext, sizeof("png") - 1) == 0 ) head = (char *)HtmlHeadPNG;
					else return EOF;					
					if( TCPwrite( info, (void *)head, strlen(head) ) < EOF ) return EOF;
					break;
				case AddType_TXT :	/*eLXg^Cv*/
				default :
					if( TCPwrite( info, (void *)HtmlHead, sizeof(HtmlHead) - 1 ) < EOF ) return EOF;
					break;
			}

			/*RecAÓIRecIRecfB*/
			if( (url->file)->fn == NULL )	/*sAhX݂Ȃ́AÓIRecƔfB*/
			{
				TCPwrite( info, (void *)((url->file)->file), (url->file)->size );
				return 0;
			}
			else	/*͓IRec*/
				return (url->file)->fn(info, argc, argv);
		}
		url++;
	}
	return EOF;		/*{Aɂ͗Ȃ*/
}

/********************************************************************/
/*	fR[hȂoCi[ɕϊ܂B				*/
/*	dest͊i[Asource̓fR[hÖ̗Alimit̓obt@	*/
/*																*/
/*	߂ĺAۑ̃AhXB									*/
/********************************************************************/
char *WebDecode2Binary( char *dest, const char *source, int limit )
{
	char	c,*end,*str = dest;

	end = &dest[ limit - 1 ];
	while( str < end )	/*limitɂȂ܂Ń[vB*/
	{
		if( *source == '\0' )
		{
			*str = *source;
			break;
		}
		if( isalnum( *source )	) *str = *source;	/*p̎*/
		else if( isprint( *source ) )
		{
			if( *source == '+' ) *str = ' ';	/*Xy[X*/
			else if( *source == '%' )	/*HEXR[h̏*/
			{
				if( isalnum( *++source ) == 0 ) break;		/*pȊO͑ʖ*/
				c = *source | 0x20;
				*str = (c >= 'a' && c <= 'f') ? c - 'a' + 10 : (isdigit( c )) ? c - '0' : 2;
				*str <<= 4;
				if( isalnum( *++source ) == 0 ) break;		/*pȊO͑ʖ*/
				c = *source | 0x20;
				*str |= (c >= 'a' && c <= 'f') ? c - 'a' + 10 : (isdigit( c )) ? c - '0' : 0;
			}
			else *str = *source;	/*ȊO̕\\̏*/
		}
		else{}
		if( *str == '<' || *str == '>' ) *str = ' ';	/*HTML^O΍*/
		source++;
		str++;
	}
	*str = '\0';	/**/

	return dest;
}

/********************************************************************/
/*	NavajoPostForm:													*/
/*	^̕\													*/
/*	access_countBuildNumbeŕAшϐQƂĂB			*/
/*	G[EOFԂB										*/
/********************************************************************/
static int NavajoInfo( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	int		ercd;
	char	*html_msg,*str;
	static const char	html_top[] =
	{
		"<html lang=\"ja\"><head>\r\n"
		"<meta HTTP-EQUIV=\"Content-type\" CONTENT=\"text/html; charset=Shift_JIS\">\r\n"
		"<title>The Embedded Protocol Engine Navajo</title></head>\r\n"
		"<body bgcolor=\"#ccffcc\">\r\n"
		"<img src=\"http://hamayan.ddo.jp/~hamayan/so-net/image/access112.img\" width=\"1\" height=\"1\">\r\n"
		"<center><h3>The Embedded Protocol Engine</h3>\r\n"
		"<h1><font color=\"#00cc00\">Navajo</font><font size=\"1\">ver." NAVAJO_VERSION "</font></h1></center>\r\n"
	};

	static const char HtmlFoot[] =
	{
		"Project HOS URL:<a href=\"https://sourceforge.jp/projects/hos/\">https://sourceforge.jp/projects/hos/</a><br>\r\n"
		"NAVAJO URL:<a href=\"http://www003.upp.so-net.ne.jp/hamayan/\">http://www003.upp.so-net.ne.jp/hamayan/</a><br>\r\n"
		"<center><a href=\"./index.html\"><font size=\"+1\">Back</font></a></center><br>\r\n"
		"<font size=\"-1\">designed by hamayan</font><br>\r\n"
		"</body></html>\r\n\r\n"
	};

	/*L烁ubN؂oB*/
	html_msg = (char *)GetMemBlock( 1500 );

	/*bZ[W̐*/
	strcpy( html_msg, html_top );
	str = strchr( html_msg, '\0' );
	/*ANZXJEgbZ[W̐*/
	sprintf( str, "ACCESS COUNT = <font color=\"#0000cc\">%05d</font><br>\r\n", access_count );
	str = strchr( html_msg, '\0' );
	/*Build NumberbZ[W̐*/
	sprintf( str, "<font>BUILD %s</font><br>\r\n", BuildNumber );
	/*Footer̐*/
	strcat( html_msg, HtmlFoot );
	/*CɑM*/
	ercd = TCPwrite( info, html_msg, strlen(html_msg) );

	/*؂ĂubN̕ԋp*/
	RelMemBlock( (VP)html_msg );

	return ercd;
}

/********************************************************************/
/*	Reco^p̃vpeB									*/
/*	httpdQƂB											*/
/********************************************************************/
static const FILE_PROPERTIES info_html =
{
	"/info.html",
	"2004/ 7/ 5 23:16:00",
	NavajoInfo,
	(void *)0,
	"designed by hamayan.",
	(void *)0,
	0,
};

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
