/* ------------------------------------------------------------------------ */
/*  Xg[f[^p FIFOobt@                                         */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include "kernel.h"
#include "stmfifo.h"

/* RXgN^ */
void stmfifo_cre_fifo(
		T_STMFIFO *this,	/* FIFOobt@NX̃|C^ */
		UB        *buf,		/* 蓖Ăobt@̃AhX */
		INT       bufsz)	/* 蓖Ăobt@̃TCY */
{
	this->buf   = buf;
	this->bufsz = bufsz;
	this->head  = 0;
	this->tail  = 0;
}


/* fXgN^ */
void stmfifo_del_fifo(
		T_STMFIFO *this)	/* FIFOobt@NX̃|C^ */
{
	/* ɏ͖ */
}



/* PLN^ */
ER stmfifo_snd_chr(
		T_STMFIFO *this,	/* FIFOobt@NX̃|C^ */
		UB        chr)		/* ރLN^ */
{
	INT next_tail;
	
	/* ̖ʒuvZ */
	if ( this->tail + 1 < this->bufsz )
	{
		next_tail = this->tail + 1;
	}
	else
	{
		next_tail = 0;		/* Oobt@Ȃ܂Ԃ */
	}
	
	/* obt@t̃`FbN */
	if ( next_tail == this->head )
	{
		return E_TMOUT;
	}
	
	/* f[^̒ǉ */
	this->buf[this->tail] = chr;
	this->tail = next_tail;
	
	return E_OK;
}


/* PLN^ǂݍ */
ER stmfifo_rcv_chr(
		T_STMFIFO *this,	/* FIFOobt@NX̃|C^ */
		UB        *p_chr)	/* PLN^ǂݍރ|C^ */
{
	/* obt@GveB[̃`FbN */
	if ( this->head == this->tail )
	{
		return E_TMOUT;
	}
	
	/* f[^̓ǂݏo */
	*p_chr = this->buf[this->head];
	
	/* ̐擪ʒu̐ݒ */
	if ( this->head + 1 < this->bufsz )
	{
		this->head = this->head + 1;
	}
	else
	{
		this->head = 0;
	}
	
	return E_OK;
}


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
