/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"udp.h"
#include	"ip.h"
#include	"nava_cfg.h"

/********************************************************/
/*	IvVXCb`ɑΉo^\	*/
/********************************************************/
typedef	struct
{
	void	(* func)(int argc,char *argv[],int handle);
	char	*optionname;
} OPTION_LIST;

/********************************************************/
/*	O֐Q										*/
/********************************************************/
/*v~eBuTCP/IP֐*/
extern	int		UDPSend( UdpAddressAndPortInformation *info );

/********************************************************************/
/*	UDPpTv												*/
/*	UDP	ECHOT[o[												*/
/*	̗́AUNIXlbg[NvO~OQ Vol.1	*/
/*	208łɌfڂĂUDP ECHOT[o[AWłB		*/
/*	T[o[Ȃ̂ŃobNOEhœ삵AOKILL	*/
/*	܂œ삵܂B											*/
/********************************************************************/
static void dg_echo( UdpAddressAndPortInformation *info, int handle );

void UdpEchoServerTask( VP_INT handle )
{
	UdpAddressAndPortInformation info;		/*UDPڑ*/

	/*^XN̓o^*/
	RegistProcessTable( _BACK_GROUND_, TRUE );
	/*\Pbg̐*/
	if( UDPsocket( &info ) != EOF )
	{
		/*bind*/
		info.sport = ECHO;			/*|[g̐ݒ*/
		UDPbind( &info, handle );
		/*T[rX{*/
		dg_echo( &info, handle );
		/*\Pbg̃N[Y*/
		UDPclose( &info );
	}
	/*^XN̍폜*/
	RelocateProcessTable();
	exd_tsk();					/*TASK̏Iƍ폜*/
}

static void dg_echo( UdpAddressAndPortInformation *info, int handle )
{
	char	mesg[ 128 ];
	long	rcvsz;

	info->tmout = 100;	/*100msuɃvZXKILLĂ邩`FbN*/
	while( 1 )
	{
		/*MɕKvȏZbg*/
		info->DataSz = sizeof(mesg);	/*Mobt@TCY*/
		info->data = mesg;				/*Mobt@̈*/
		rcvsz = UDPrecvfrom( info, handle );	/*M*/
		if( rcvsz < 0 )
		{
			/*IɃvZXKILLꂽf*/
			if( QueryRunningMode() == EOF ) break;
		}
		else
		{
			/*MɕKvȏZbg*/
			info->DataSz = rcvsz;			/*Mf[^*/
			UDPsendto( info, handle );		/*M*/
		}
	}
}

void UdpEchoServerStart( int argc, char *argv[], int handle )
{
	ID		tid;

	/*p[^[̃`FbN*/
	if( argc != 1 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : dgechoserve\r\n" );
		return;
	}
	/*^XN̐*/
#define		UDPECHOSERVERTASK_STK_SZ		(((((430 + 80) - 1) / 16) + 1) * 16)	/*ӁI܂ZoĂȂ̂ŁA̒l H8300H̏ꍇ*/
	tid = CreateTask( handle, UDPECHOSERVERTASK_STK_SZ, 7, (FP)UdpEchoServerTask );
	if( tid <= 0 )
	{
		SCI_Puts( handle, "acre_tsk error\r\n" );
		return;
	}
	/*^XN̋N*/
	act_tsk( tid );				/*^XN̋N*/
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
