/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  TvvO                           */
/*   OSp^C}                                                             */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include	<stdio.h>
#include	<string.h>

#include	"h83052f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"ostimer.h"
#include	"itu.h"

/*GRAXVpϐ*/
unsigned short NewGRAValue;

/********************************************************************/
/*	VXe^C}[												*/
/********************************************************************/
/* OSp^C} */
void ostim_init(VP_INT TimeFactor)
{
	ITU.TSTR.BIT.STR0 = 0;			/*ITU0~*/
	ITU.TSNC.BIT.SYNC0 = 0;			/*ch0͓Ɨ*/
	ITU.TMDR.BIT.PWM0 = 0;			/*ch0͒ʏ퓮*/
	ITU0.TCR.BYTE = 0xa3;			/*1010 0001:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU0.GRA = TimeFactor;			/*RyA}b`A̒l*/
	ITU0.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU0.TSR.BYTE &= 0xf8;			/*Xe[^X̃NA*/
	ITU0.TIER.BYTE = 0xf9;			/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR0 = 1;			/*ITU0X^[g*/
}

/* 荞݃nhTv */
void ostim_hdr(VP_INT exinf)		/* OS^C}pnh */
{
	ITU0.TSR.BYTE &= 0xfe;			/*ݏ̃NA*/
	isig_tim();						/* ^CeBbN̋ */
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                        */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInit( void )
{
	ITU.TSTR.BIT.STR1 = 0;			/*ITU1~*/
	ITU.TSNC.BIT.SYNC1 = 0;			/*ch1͓Ɨ*/
	ITU.TMDR.BIT.PWM1 = 0;			/*ch1͒ʏ퓮*/
	ITU1.TCR.BYTE = 0xa3;			/*1010 0001:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU1.GRA = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*RyA}b`A̒l*/
/*	ITU1.GRA = 15625;*/	/*RyA}b`A̒l*/
	NewGRAValue = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*XVpf[^̏*/
	ITU1.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU1.TSR.BYTE &= 0xf8;			/*Xe[^X̃NA*/
	ITU1.TIER.BYTE = 0xf9;			/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR1 = 1;			/*ITU4X^[g*/
}

void SNTPSyncIndependentPart( void );

/********************************************************************/
/*	SNTPT[o[^C}[JE^[荞݃nh              */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInt(VP_INT exinf)
{
	ITU1.TSR.BYTE &= 0xfe;			/*ݏ̃NA*/
	ITU1.GRA = NewGRAValue;			/*GRA̍XV*/
	SNTPSyncIndependentPart();		/*ˑƗ̌ĂяoB*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterSet( unsigned short value )
{
/*	ITU.TSTR.BIT.STR1 = 0;*/	/*^C}[~*/
	ITU1.TCNT = value;
/*	ITU.TSTR.BIT.STR1 = 1;*/	/*^C}[ĊJ*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[ǂݏo                      */
/*	ˑ                                                    */
/********************************************************************/
volatile unsigned short SNTPSyncTimerCounterGet( void )
{
	return ITU1.TCNT;
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/*	0̎Ƀ^C}[~A1ōĊJB                      */
/********************************************************************/
void SNTPSyncTimerStartStop( int StartStop )
{
	ITU.TSTR.BIT.STR1 = StartStop;
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
