/********************************************************************/
/*	RTL8019AS ŗL̒`sB									*/
/*                          Copyright (C) 1998-2002 by Project HOS  */
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/

#define		__RTL8019AS_USE__

#include	<stdio.h>
#include	<string.h>

#include	"h83068f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"system.h"
#include	"comm.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"rtl8019.h"			/*RTL8019ASŗL̒`*/

/********************************************************/
/*	֐yѕϐ`									*/
/********************************************************/
int RtlRead( volatile union RTL8019AS *eth, RD *rd );
static	int		rtlInit( volatile union RTL8019AS *eth );

/********************************************************************/
/*															*/
/********************************************************************/
int RTL8019ASInit( void )
{
/*	BSC.WCR.BIT.W1 = 0;	*/			/*RTL̑x͈ӊOƑ3STATEANO WAITōsBs܂łB*/
	BSC.WCR.BIT.W1 = 2;				/*̎O{[hł́AWAIT(IOCHRDY)̓͂łȂ̂ŁAWAIT̑}*/
	BSC.BCR.BIT.WAITE = 1;			/*WAIT[qL*/
	P6DDR = 0xfe;					/*1111 1110 WAITL*/
#if 0	/*x荞݂g*/
	INTC.ISCR.BIT.IRQ5SC = 1;		/*IRQ5݂̗GbWŊݔ*/
#endif
	/*RTL8019AŜ̏*/
	if( rtlInit( (volatile union RTL8019AS *)ETH0_START_ADDRESS) != 0 ) return -1;
#ifndef CYC_ID_RTL8019
	INTC.IER.BIT.IRQ5E = 1;			/*IRQ5ݗL*/
#endif
	return 0;
}

/********************************************************************/
/*			RTL8019AS̏										*/
/*	{DP83902̃}jAǂތ肱̏Ƀ[uobN	*/
/*	@\gpĎȐffsĂBȂ̂Ŗ{	*/
/*	sׂȂ̂낤ʓ|Ȃ̂ōsĂȂA@Ɏ鎞	*/
/*	K[vobNffsB									*/
/********************************************************************/
static int rtlInit( volatile union RTL8019AS *eth )
{
	struct
	{
		unsigned short	add;
		short		size;
		char		bufb[ 16 ];
	} mac;

	int		i;
	char	macbuf[ 16 ],*ptr,*ptr2;
	volatile char	c;
	RD		rd;
	char	VenderCode[] = VENDER_CODE;	/*93C46ĂȂ̎؂̃R[h*/

	dly_tsk( 3000 );		/*唻U镑łRbAxČ܂B*/

	/*\tgEGARESET*/
#if 0
	eth->page0.write.resetPort[ 0 ] = 0;
	dly_tsk( 2 );					/*1.6msȏ̑҂*/
#else	/*_pb`B*/
	c = eth->page0.read.resetPort[ 0 ];
	eth->page0.write.resetPort[ 0 ] = c;		/*reset port̓ǂݖ߂RTLZbg*/

	/*PAGE0ɐݒ*/
	eth->page3.write.cr = PAGE0 | FORCEREMOTEstop | RTLstop;
	eth->page0.write.isr = 0xff;	/*UISȒSrbgNA*/
	for( i = 50; i > 0; i-- )
	{
		dly_tsk( 10 );
		if( eth->page0.read.isr & 0x80) break;	/*RESETXe[gɓmFB*/
	}
	if( i <= 0 ) return -1;	/*[vĔẮAn[hEGAG[ƌȂB*/
#endif

	/*PAGE0ɐݒ*/
	eth->page3.write.cr = PAGE0 | FORCEREMOTEstop | RTLstop;
	/*qsk݂̂邩AmF*/
	if( eth->page0.read.id08019 != 'P' || eth->page0.read.id18019 != 'p' ) return -1;
	/*DCȐ:{̓[vobN[hōs炵*/
	eth->page0.write.dcr = 0x80 | FT8byte | ARoff | LPBKon | LAS16 | BIGendian | WTS8;
	eth->page0.write.tcr = 0xe0 | OFSToff | ATDoff | LBInternal | CRCon;
	/*[gDMA oCgJE^NA*/
	eth->page0.write.rbcr0 = 0x00;
	eth->page0.write.rbcr1 = 0x00;
	/*RCȐ*/
	eth->page0.write.rcr = 0xc0 | MONoff | PROoff | AMoff | ABon | ARANToff | SEPoff;
	/*MOobt@EAhX̐ݒ*/
	eth->page0.write.bnry = RECSTARTPAGE;
	/*MOobt@JnAhX̐ݒ*/
	eth->page0.write.pstart = RECSTARTPAGE;
	/*MOobt@IAhX̐ݒ*/
	eth->page0.write.pstop = RECENDPAGE;
	/*MOobt@JnAhX̐ݒ*/
	eth->page0.write.tpsr = SNDSTARTPAGE;
	/*荞݃Xe[^XWX^̃NA*/
	eth->page0.write.isr = 0xff;
/*	eth->page0.write.imr = 0x5f;*/	/*MAMG[AMG[A
									MADMAAOVER WRITExL*/
/*	eth->page0.write.imr = 0x11;*/	/*MAMG[̂ݗL*/
/*	eth->page0.write.imr = 0x1b;*/	/*MAMG[AMG[AML*/
	eth->page0.write.imr = 0x5b;	/*MAMG[AMADMAL*/
/*	eth->page0.write.imr = 0x51;*/	/*MADMAL*/
	/*MAC ADDRESSWX^̐ݒ*/
	/********************************************************************/
	/*	93C46ĂȂARTL8019AS擾 MACAhX	*/
	/*	ALL"0"ƂȂĂB											*/
	/*	𗘗p93C46̎A𔻒肷B					*/
	/********************************************************************/
	rd.add = E2PROMTOP;				/*AhXݒ*/
	rd.size = sizeof( mac.bufb );	/*Mf[^ݒ*/
	rd.buf = macbuf;				/*MACAhXۑ̈w*/
	RtlRead( eth, &rd );			/*DMA]v*/
	/*A̔*/
	ptr = macbuf;
	c = 0;
	while( ptr < &macbuf[sizeof(macbuf)] ) c |= *ptr++;	/*[vIA c 0̎93C46*/

	/*Page 1 ̐ݒ*/
	eth->page0.write.cr = PAGE1 | FORCEREMOTEstop | RTLstop;
	/*obt@ɓǂݏoE2PROM̓ePARWX^ɓ]*/
	if( c ) ptr = macbuf;		/* c 0ȊO̎EEPROM݂*/
	else ptr = VenderCode;
	ptr2 = (char *)&eth->page1.write.par0;
	for( i = 0; i < LENGTHMAC; i++ )
	{
		*ptr2++ = *ptr++;
		ptr++;
	}

	/*PARWX^̓eO[ö̎MACAhXɓ]*/
	memcpy( (char *)GetRtlMac(), (char *)&eth->page1.write.par0, LENGTHMAC );
	/*}`LXgWX^̐ݒ*/
	memset( (char *)&eth->page1.write.mar0, 0, 8 );
	/*Jg|C^̏*/
	eth->page1.write.curr = RECSTARTPAGE;		/*Jgy[WWX^̓X^[gy[WWX^̒lɂ*/

	/*AKI-H8-LANp*/
	if( !c )
	{
		/*PAGE3ɐݒ*/
		eth->page0.write.cr = PAGE3 | FORCEREMOTEstop | RTLstop;
		eth->page3.write.config1 = 0x80;		/*IRQ5Lɂ*/
	}

	/*Page 0 ɖ߂ăX^[g[hɂ*/
	eth->page1.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;
	/*MRtBO[VWX^̏A[vobN[h̉*/
	eth->page0.write.dcr = 0x80 | FT8byte | ARoff | LPBKoff | LAS16 | BIGendian | WTS8;
	eth->page0.write.tcr = 0xe0 | OFSToff | ATDoff | LBNormal | CRCon;

	return 0;
}

/************************************************************************/
/*					ETHERNET荞݃nh							*/
/************************************************************************/
void ETH0Trap( volatile union RTL8019AS *eth )
{
#if 0	/*xgKŊ݂*/
	INTC.ISR.BIT.IRQ5F = 0;			/*GbWȍꍇAŊ݃tONA*/
#endif
	/*荞ݏ{*/
	ETH0InterruptOperation( eth );
}
