/********************************************************************/
/*	HOS-H8 (ITRON version3)											*/
/*	RTL8019AS̒`t@C											*/
/*							Copyright (C) 1998-2002 by Project HOS  */
/********************************************************************/

/*#define	eth0	(*(volatile union RTL8019AS *)0x200000)*/	/*ETHERNET Address*/
#define MTU_SIZE			1514	/*MTUl*/

/********************************************************/
/*	Mobt@̊Ǘf[^tH[}bg				*/
/********************************************************/
typedef struct
{
	unsigned char		ReceiveStatus;	/*MXe[^X*/
	unsigned char		NextPacket;		/*̃pPbg̊Jny[Wԍ*/
	union {
		unsigned char	b[ 2 ];
		unsigned short	sz;				/*pPbg*/
	} PacketSize;
} KANRI;

/********************************************************/
/*	Mf[^FRAME\									*/
/********************************************************/
typedef struct
{
	unsigned short		add;			/*obt@̃AhX*/
	unsigned short		size;			/*]*/
	char				*buf;			/*Mf[^{*/
} RD;

/********************************************************/
/*	Mobt@pPbg\							*/
/********************************************************/
typedef struct
{
	unsigned short		size;			/*SIZE*/
	ETHERNETFRAME*		ef;				/*EtherNett[*/
} WD;

/*RTL8019AS֘A*/
union RTL8019AS {
	char	c[ 32 ];				/*RTL9019AS̃ANZẌ͑S32byte*/
	union {
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	clda0;	/*CLDA0*/
			unsigned char	clda1;	/*CLDA1*/
			unsigned char	bnry;	/*BNRY*/
			unsigned char	tsr;	/*TSR*/
			unsigned char	ncr;	/*NCR*/
			unsigned char	fifo;	/*FIFO*/
			unsigned char	isr;	/*ISR*/
			unsigned char	crda0;	/*CRDA0*/
			unsigned char	crda1;	/*CRDA1*/
			unsigned char	id08019;	/*8019ID0*/
			unsigned char	id18019;	/*8019ID1*/
			unsigned char	rsr;	/*RSR*/
			unsigned char	cntr0;	/*CNTR0*/
			unsigned char	cntr1;	/*CNTR1*/
			unsigned char	cntr2;	/*CNTR2*/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} read;
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	pstart;	/*PSTART*/
			unsigned char	pstop;	/*PSTOP*/
			unsigned char	bnry;	/*BNRY*/
			unsigned char	tpsr;	/*TPSR*/
			unsigned char	tbcr0;	/*TBCR0*/
			unsigned char	tbcr1;	/*TBCR1*/
			unsigned char	isr;	/*ISR*/
			unsigned char	rsar0;	/*RSAR0*/
			unsigned char	rsar1;	/*rsar1*/
			unsigned char	rbcr0;	/*RBCR0*/
			unsigned char	rbcr1;	/*RBCR1*/
			unsigned char	rcr;	/*RCR*/
			unsigned char	tcr;	/*TCR*/
			unsigned char	dcr;	/*DCR*/
			unsigned char	imr;	/*IMR*/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} write;
	} page0;
	union {
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	par0;	/*PAR0*/
			unsigned char	par1;	/*PAR1*/
			unsigned char	par2;	/*PAR2*/
			unsigned char	par3;	/*PAR3*/
			unsigned char	par4;	/*PAR4*/
			unsigned char	par5;	/*PAR5*/
			unsigned char	curr;	/*CURR*/
			unsigned char	mar0;	/*MAR0*/
			unsigned char	mar1;	/*MAR1*/
			unsigned char	mar2;	/*MAR2*/
			unsigned char	mar3;	/*MAR3*/
			unsigned char	mar4;	/*MAR4*/
			unsigned char	mar5;	/*MAR5*/
			unsigned char	mar6;	/*MAR6*/
			unsigned char	mar7;	/*MAR7*/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} read;
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	par0;	/*PAR0*/
			unsigned char	par1;	/*PAR1*/
			unsigned char	par2;	/*PAR2*/
			unsigned char	par3;	/*PAR3*/
			unsigned char	par4;	/*PAR4*/
			unsigned char	par5;	/*PAR5*/
			unsigned char	curr;	/*CURR*/
			unsigned char	mar0;	/*MAR0*/
			unsigned char	mar1;	/*MAR1*/
			unsigned char	mar2;	/*MAR2*/
			unsigned char	mar3;	/*MAR3*/
			unsigned char	mar4;	/*MAR4*/
			unsigned char	mar5;	/*MAR5*/
			unsigned char	mar6;	/*MAR6*/
			unsigned char	mar7;	/*MAR7*/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} write;
	} page1;
	union {
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	pstart;	/*PSTART*/
			unsigned char	pstop;	/*PSTOP*/
			unsigned char	rsv1;	/**/
			unsigned char	tpsr;	/*TPSR*/
			unsigned char	rsv2[ 7 ];	/**/
			unsigned char	rcr;	/*RCR*/
			unsigned char	tcr;	/*TCR*/
			unsigned char	dcr;	/*DCR*/
			unsigned char	imr;	/*IMR*/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} read;
	} page2;
	union {
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	cr9346;	/*9346CR*/
			unsigned char	bpage;	/*BPAGE*/
			unsigned char	config0;	/*CONFIG0*/
			unsigned char	config1;	/*CONFIG1*/
			unsigned char	config2;	/*CONFIG2*/
			unsigned char	config3;	/*CONFIG3*/
			unsigned char	rsv1;	/**/
			unsigned char	csnsav;	/*CSNSAV*/
			unsigned char	rsv2[ 2 ];	/**/
			unsigned char	intr;	/*INTR*/
			unsigned char	rsv3;	/**/
			unsigned char	config4;	/*CONFIG4*/
			unsigned char	rsv4[ 2 ];	/**/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} read;
		struct {
			unsigned char	cr;		/*CR WX^*/
			unsigned char	cr9346;	/*9346CR*/
			unsigned char	bpage;	/*BPAGE*/
			unsigned char	rsv1;	/**/
			unsigned char	config1;	/*CONFIG1*/
			unsigned char	config2;	/*CONFIG2*/
			unsigned char	config3;	/*CONFIG3*/
			unsigned char	test;	/*TEST*/
			unsigned char	rsv2;	/**/
			unsigned char	hltclk;	/*HLTCLK*/
			unsigned char	rsv3[ 2 ];	/**/
			unsigned char	fmwp;	/*FMWP*/
			unsigned char	rsv4[ 3 ];	/**/
			unsigned char	remoteDMAport[ 8 ];	/*[gDMA|[g*/
			unsigned char	resetPort[ 8 ];	/*Zbg|[g*/
		} write;
	} page3;
};

/*CR register Parameter*/
#define PAGE3           0xc0
#define PAGE2           0x80
#define PAGE1           0x40
#define PAGE0           0x00
#define FORCEREMOTEstop	0x20
#define PACKETsend		0x18
#define REMOTEwrite		0x10
#define REMOTEread		0x08
#define TXPstart		0x04
#define RTLstart		0x02
#define RTLstop			0x01

/*DCR register Parameter*/
#define FT12byte		0x60
#define FT8byte			0x40
#define FT4byte			0x20
#define FT2byte			0x00
#define ARon			0x10
#define ARoff			0x00
#define LPBKoff			0x08
#define LPBKon			0x00
#define LAS32			0x04
#define LAS16			0x00
#define BIGendian		0x02
#define LITTLEendian	0x00
#define WTS16			0x01
#define WTS8			0x00

/*RCR register Parameter*/
#define MONon			0x20
#define MONoff			0x00
#define PROon			0x10
#define PROoff			0x00
#define AMon			0x08
#define AMoff			0x00
#define ABon			0x04
#define ABoff			0x00
#define ARANTon			0x02
#define ARANToff		0x00
#define SEPon			0x01
#define SEPoff			0x00

/*TCR register Parameter*/
#define OFSTon			0x10
#define OFSToff			0x00
#define ATDon			0x08
#define ATDoff			0x00
#define LBExternal		0x06
#define LBEndec			0x04
#define LBInternal		0x02
#define LBNormal		0x00
#define CRCon			0x00
#define CRCoff			0x01

/*݃Xe[^XWX^(ISR)bit`*/
#define PRX				0x01
#define PTX				0x02
#define RXE				0x04
#define TXE				0x08
#define OVW				0x10
#define CNT				0x20
#define RDC				0x40
#define RST				0x80

/*CxgFLAGbit`*/
#define	RTL_ISR_PRX		0x0001			/*pPbgɎMłbit*/
#define	RTL_ISR_PTX		0x0002			/*pPbgɑMłbit*/
#define	RTL_ISR_RXE		0x0004			/*MG[bit*/
#define	RTL_ISR_TXE		0x0008			/*MG[bit*/
#define	RTL_ISR_OVW		0x0010			/*OVER WRITExbit*/
#define	RTL_ISR_CNT		0x0020			/*COUNTER OVER FLOWbit*/
#define	RTL_ISR_RDC		0x0040			/*[gDMAbit*/
#define	RTL_ISR_RST		0x0080			/*RTLRESETԂɂ鎖bit*/

#define PACKETSIZE			1536
#define RTLRAMSIZE			16384
#define E2PROMTOP			0x0000
#define SNDSTARTPAGE		0x40
#define SNDBUFFERTOP		0x4000
#define RECSTARTPAGE		0x46
#define RECBUFFERTOP		0x4600
/*
#define RECENDPAGE			0x80
#define RECBUFFEREND		0x8000
*/
#define RECENDPAGE			0x60
#define RECBUFFEREND		0x6000
#define INT_NEST_LIMIT		(RECENDPAGE - RECSTARTPAGE)	/*MNEST̐*/

/*x_[R[h`*/
#define VENDER_CODE {'h','h','a','a','m','m',0x00,0x00,0x00,0x00,0x02,0x02}

/********************************************************************/
/*	RTL8018ASŗL̊֐`											*/
/********************************************************************/

unsigned char	*GetRtlMac( void );
int		RTL8019ASInit( void );
void	ETH0InterruptOperation( volatile union RTL8019AS *eth );

/********************************************************************/
/*							Copyright (C) 1998-2002 by hamayan		*/
/********************************************************************/
