/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  CGI֘A̒`                                                           */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#define	METHOD			0
#define	RQUEST_URL		1
#define	HTTP_VERSION	2
#define	NAVAJO_VERSION	"1.1.3"

#define	AddHandler		0	/*nh*/
#define	AddType_TXT		1	/*eLXg*/
#define	AddType_IMAGE	2	/*C[W*/
#define	AddType_APPLI	3	/*AvP[V*/
#define	AddType_AUDIO	4	/*audio*/
#define	AddType_VIDEO	5	/*video*/

/********************************************************************/
/*	HTTPbZ[Wzp`										*/
/*	̃bZ[WzɂāA[vŏsB				*/
/********************************************************************/
typedef struct
{
	char	*msg;	/*bZ[W̃AhX*/
	int		size;	/*bZ[W̃TCY*/
} MESSAGE_LIST;

/*NCAgREQUEST METHODi[\*/
typedef struct
{
	char		meth_name[ 16 ];
	char		uri_addr[ 80 ];
	char		http_ver[ 24 ];
} METH_REQ;

enum HTTP_ENV
{
	DATE_LOCAL = 1,		/*Monday, 25-Aug-2003 17:00:48 JST*/
	DOCUMENT_NAME,		/*variable.html*/
	LAST_MODIFIED,		/*Wednesday, 21-Mar-2001 13:10:29 JST*/
	AUTH_TYPE,			/*(none)*/
	CONTENT_LENGTH,		/*(none)*/
	CONTENT_TYPE,		/*(none)*/
	DOCUMENT_ROOT,		/*/opt/httpd/htdocs*/
	GATEWAY_INTERFACE,	/*CGI/1.1*/
	HTTP_ACCEPT,		/**/
	HTTP_REFERER,		/*http://www.google.co.jp/search?q=http+%E7%92%B0%E5%A2%83%E5%A4%89%E6%95%B0&ie=UTF-8&oe=UTF-8&hl=ja&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=*/
	HTTP_USER_AGENT,	/*Mozilla/5.0 (Windows; U; Win95; ja-JP; rv:1.3) Gecko/20030423*/
	PATH_INFO,			/*(none)*/
	PATH_TRANSLATED,	/*(none)*/
	QUERY_STRING,		/**/
	REMOTE_ADDR,		/*210.166.89.158*/
	REMOTE_HOST,		/*kgj414.airnet.ne.jp*/
	REMOTE_IDENT,		/*(none)*/
	REMOTE_USER,		/*(none)*/
	REQUEST_METHOD,		/*GET*/
	SCRIPT_NAME,		/*/~oable/okui/variable.html*/
	SERVER_NAME,		/*www02.so-net.ne.jp*/
	SERVER_PORT,		/*80*/
	SERVER_PROTOCOL,	/*HTTP/1.1*/
	SERVER_SOFTWARE,	/*Apache/1.3.26 (Unix)*/
	SERVER_BLOCKSIZE,	/*(none)*/
	TZ					/*(none)*/
};

#if	defined(__TETHYS_3062_20__) || defined(__JANUS_3062_20__)
typedef struct
{
	char	*filename;	/*t@C*/
	char	*timestamp;	/*^CX^v*/
	void	(* fn)(METH_REQ *, unsigned char);	/*s̏ꍇAɊJnAhXLBÓIt@CłNULLL*/
	void	*file;		/*t@C̊JnAhX*/
	char	*author;	/**/
	void	*certification;	/*Fؗp*/
	long	size;		/*t@Ĉ̃TCY*/
} FILE_PROPERTIES;
#else
typedef struct
{
	char	*filename;	/*t@C*/
	char	*timestamp;	/*^CX^v*/
	int		(* fn)(TcpAddressAndPortInformation *,int,char **);	/*s̏ꍇAɊJnAhXLBÓIt@CłNULLL*/
	void	*file;		/*t@C̊JnAhX*/
	char	*author;	/**/
	void	*certification;	/*Fؗp*/
	long	size;		/*t@Ĉ̃TCY*/
} FILE_PROPERTIES;
#endif	/*defined(__TETHYS_3062_20__) || defined(__JANUS_3062_20__)*/

/********************************************************/
/*	OϐQ										*/
/********************************************************/
#ifndef	__TETHYS_3062_20__
extern const char URLRoot[];
#else
#endif	/*__TETHYS_3062_20__*/

/********************************************************/
/*	֐vg^Cv錾								*/
/********************************************************/
#if	defined(__TETHYS_3062_20__) || defined(__JANUS_3062_20__)
#else
int		UrlLed( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlLcd( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlEeprom( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIled( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIlcd( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIeeprom( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlMemDump( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIdump( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlDNS( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIdns( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlBBS( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		CGIbbs( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		NavajoPreForm( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		NavajoPostForm( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		NavajoPageTopLink( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlImage( TcpAddressAndPortInformation *info, int argc, char *argv[] );
int		UrlWebCamera( TcpAddressAndPortInformation *info, int argc, char *argv[] );

char	*WebDecode2Binary( char *dest, const char *source, int limit );
#endif	/*defined(__TETHYS_3062_20__) || defined(__JANUS_3062_20__)*/
