/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  IP SERVICE֘A̒`                                                    */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
/*T[rX`*/
#define	DHCP_CLIENT			68		/*dhcp client:UDP*/
#define	DHCP_SERVER			67		/*dhcp server:UDP*/

/*Ƀf[^*/
#define	MAGIC_CODE			{99,130,83,99}

/*DHCPIvV^O*/
#define	DHCP_SUBNETMASK		1
#define	DHCP_GATEWAY		3
#define	DHCP_DOMAIN_SERVER	6
#define	DHCP_HOST_NAME		12
#define	DHCP_DOMAIN_NAME	15
#define	DHCP_ROUTER_FINDED	31
#define	DHCP_SOLID_ROUTE	33
#define	DHCP_VENDER_DEFINE	43
#define	DHCP_ADDRESS_LEASE	51
#define	DHCP_MESSAGE_TYPE	53
#define	DHCP_SERVER_ID		54
#define	DHCP_PARAMETER_LIST	55
#define	DHCP_UPDATE_TIME	58
#define	DHCP_REBIND_TIME	59
#define	DHCP_CLASS_ID		60
#define	DHCP_CLIENT_ID		61
#define	DHCP_PAD			81

/*DHCPbZ[W^Cv*/
#define	DHCP_DISCOVER		1
#define	DHCP_OFFER			2
#define	DHCP_REQUEST		3
#define	DHCP_DECLINE		4
#define	DHCP_PACK			5
#define	DHCP_NACK			6
#define	DHCP_RELEASE		7
#define	DHCP_INFRM			8

/********************************************************/
/*	DHCPpPbg\									*/
/********************************************************/
typedef struct
{
	unsigned char	op_code;		/*IyR[h*/
	unsigned char	hard_type;		/*n[hEGA^Cv*/
	unsigned char	hard_add_length;	/*n[hEGAAhX*/
	unsigned char	hop_count;		/*zbvJEg*/

	unsigned long	transaction_id;	/*gUNVhc*/

	unsigned short	second;			/*b*/
	unsigned short	rsv1;			/**/

	unsigned long	client_ip;		/*NCAgIPAhX*/
	unsigned long	user_ip;		/*[U[IPAhX*/
	unsigned long	server_ip;		/*T[o[IPAhX*/
	unsigned long	gateway_ip;		/*Q[gEGCIPAhX*/

	unsigned char	client_hard_add[16];	/*NCAgn[hEGAAhX*/
	unsigned char	server_host_name[64];	/*T[o[zXg*/
	unsigned char	boot_file_name[128];	/*Nt@C*/
	unsigned char	vender_info[64];	/*x_[dl*/
} DHCP_PACKET;

