/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  TCP֘A̒`                                                           */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
/*T[rX`*/
#define	ECHO				7		/*echo:UDP,TCP*/
#define	DISCARD				9		/*discard:UDP,TCP*/
#define	DAYTIME				13		/*daytime:UDP,TCP*/
#define	FTP					21		/*ftp:TCP*/
#define	TELNET				23		/*telnet:TCP*/
#define	SMTP				25		/*smtp:TCP*/
#define	TIME				37		/*time:UDP,TCP*/
#define	WWW					80		/*www:TCP*/
#define	RTELNET				107		/*rtelnet:UDP,TCP*/
#define	TCP2SERI			23		/*TCP/SERIALϊp*/

#if 0
#define MSS_SIZE			536		/*MSSlftHgl*/
#else
#define MSS_SIZE			1460	/*MSSlő*/
#endif

/********************************************************/
/*	MpPbg̈ꎟۑ̊Ǘp\̒`			*/
/********************************************************/
typedef struct
{
	unsigned short	size;	/*Mf[^TCY*/
	unsigned short	state;	/*MXe[g*/
	unsigned short	WindowSz;	/*EChETCY*/
	unsigned short	dummy;	/*ACgׁ̈A_~[f[^*/
	unsigned long	sequ;		/*pPbg̃V[PXԍ*/
	unsigned long	AnsNum;	/*mFԍ*/
} RcvPacketRecord;

#define	RcvPacketRecord_SIZE	(128 / sizeof(RcvPacketRecord))

typedef struct
{
	unsigned char	state;	/*MpPbg̃tO*/
	unsigned char	dummy;	/*ACg̒p*/
	unsigned short	pktSz;	/*MpPbg̃f[^TCY*/
	unsigned short	WindowSz;	/*EChETCY*/
	unsigned long	rcvSz;	/*Mobt@̃obt@TCY*/
	unsigned long	original_seq;	/*JnV[PXԍ*/
	unsigned long	pktSeq;	/*MpPbg̃V[PXԍ*/
	unsigned long	AnsNum;	/*mFԍ*/
	void 			*rcvBuf;	/*Mobt@̐擪AhX*/
	void 			*pktBuf;	/*MpPbg̃f[^̈̐擪AhX*/
	RcvPacketRecord *record;
} COPY_FROM_PACKET_TO_RCVBUFFER_INFO;

/********************************************************/
/*	MpPbgǗp\̒`						*/
/********************************************************/
typedef struct
{
	short			AnswerNoNum;	/*mFM*/
	unsigned short	size;			/*MTCY*/
	unsigned long	sequNo;			/*M̃V[PXԍ*/
	void			*ptr;			/*obt@̑Mʒu*/
} TRANSMIT_SCENARIO;

/********************************************************/
/*	RSTpPbgM\̒`						*/
/********************************************************/
typedef struct
{
	unsigned char dip[LENGTHIPV4];	/*IPAhX*/
	unsigned char sip[LENGTHIPV4];	/*IPAhX*/
	unsigned short dport;	/*|[gԍ*/
	unsigned short sport;	/*|[gԍ*/
	unsigned long seq;	/*V[PXԍ*/
	unsigned long ack;	/*mFԍ*/
} RST_INFORMATION;

/********************************************************/
/*	TCPp IPAhXAPORTԍ̍\					*/
/********************************************************/
typedef struct
{
	unsigned char		dip[4];			/*IPAhX̃AhXF[U[w*/
	unsigned char		sip[4];			/*MIPAhX̃AhXFNCAgɂ͂nrŊǗAT[o[ɂ̓[U[Ǘ*/
	signed char			result;			/*̃UgBIȂ0ȏ̐BُȂ畉̐*/
	unsigned char		state;			/*TCP STATEFnrǗ*/
	unsigned short		SndDataSz;		/*Mf[^TCYF[U[w*/
	unsigned short		RcvDataSz;		/*Mf[^TCYF[U[w	vȂmȂB*/
	unsigned short		OptionSz;		/*IvVTCYFnrǗ*/
	unsigned short		dport;			/*|[gԍF[U[w*/
	unsigned short		sport;			/*M|[gԍFNCAg̎͂nrǗ*/
	unsigned short		WindowSz;		/*EChETCYFf[^ۑp̃obt@̈Fnrm*/
	unsigned short		DestWindowSz;	/*EChETCY*/
	unsigned short		DestMssSz;		/* MSSTCYFnrŊǗ*/
	unsigned short		UrgencyPtr;		/*ً}|C^FH*/
	short				STATES;			/*Jڏ*/
	ID					mid;			/*[{bNXID*/
	ID					callback_id;	/*R[obNpID*/
	BOOL				server;			/*T[o[^NCAg*/
	TMO					tmout;			/*^CAEgԁFTMO_FEVRw肳Ɖiv҂*/
	void				*TCPSBuffer;	/*Mf[^̈̃AhXF[U[m*/
	void				*TCPRBuffer;	/*f[^ۑp̃obt@̈F[U[m*/
	void				*OptionArea;	/*IvVtB[hp*/
	RcvPacketRecord		*RcvRecord;		/*MpPbgǗp*/
	unsigned long		sequNo;			/*V[PXԍFnrŊǗ*/
	unsigned long		answerNo;		/*mFԍFnrŊǗ*/
/*	unsigned long		RcvBufferSz;*/	/*Mobt@̃TCY*/
/*	unsigned long		DestsequNo;*/	/*V[PXԍFnrŊǗ*/
/*	unsigned long		DestanswerNo;*/	/*mFԍFnrŊǗ*/
	void (* callback)( IP *ip, TCP *tcp, ID id ); /*R[obN֐̐擪AhX*/
#if 0
	void				*RcvRingBuffer;	/*Oobt@̐擪AhX*/
	unsigned short		RcvRingBufferSize;	/*Oobt@̃TCY*/
	unsigned short		RcvRingBufferWptr;	/*Oobt@̏݃CfbNX*/
	unsigned short		RcvRingBufferRptr;	/*Oobt@̓ǂݍ݃CfbNX*/
#endif
} TcpAddressAndPortInformation;

/********************************************************/
/*	TCP`												*/
/********************************************************/
#define	TCP_STATE_CLOSED			0	/*CLOSED*/
#define	TCP_STATE_LISTEN			1	/*LISTEN*/
#define	TCP_STATE_SYN_RCVD			2	/*SYN_RCVD*/
#define	TCP_STATE_SYN_SENT			3	/*SYN_SENT*/
#define	TCP_STATE_ESTABLISHED		4	/*ESTABLISHED*/
#define	TCP_STATE_CLOSE_WAIT		5	/*CLOSE_WAIT*/
#define	TCP_STATE_LAST_ACK			6	/*LAST_ACK*/
#define	TCP_STATE_FIN_WAIT_1		7	/*FIN_WAIT_1*/
#define	TCP_STATE_FIN_WAIT_2		8	/*FIN_WAIT_2*/
#define	TCP_STATE_CLOSING			9	/*CLOSING*/
#define	TCP_STATE_TIME_WAIT			10	/*TIME_WAIT*/
#define	TCP_STATE_RESET				11	/*RESET|*/
#define	TCP_STATE_OPENED			12	/*OPENED*/

#define	TCP_FIN						0x01	/*FIN*/
#define	TCP_SYN						0x02	/*SYN*/
#define	TCP_RST						0x04	/*RST*/
#define	TCP_PSH						0x08	/*PSH*/
#define	TCP_ACK						0x10	/*ACK*/
#define	TCP_URG						0x20	/*URG*/

#define	TCP_CONTROL_LENGTH_SIFT_SZ  12  /**/
#define	TCP_CONTROL_STATE_MASK      0x003f  /**/

#define	END_OF_OPTION_LIST			0x00	/*IvVLIST̏I*/
#define	NO_OPERATION				0x01	/*m[EIy[VBYTEE𒲐ׂɎgp*/
#define	THE_MSS_SIZE				0x02	/*őZOgTCYFkindAlenAsizêSbyte*/
#define	THE_WINDOW_SCALE_PARAMETER	0x03	/*EChEEXP[̌WFǂ*/
#define	THE_TIME_STAMP				0x04	/*^CX^vFǂ*/

#define	TWO_MSL_TIME				30000	/*2MSL^CAĖ{͂ǂʂH*/
#define	TCP_SYN_WAIT_TIME			6000	/*REGCnhVF[N̑҂Ԃ̍ŏlAȏ̓AvP[VőΏ鎖*/

#define	TCP_UNKNOWN_IP_ADDRESS		(-2)	/*IPAhXs*/
#define	TCP_UNREACHABLE_PORT		(-3)	/*|[gBs\*/
#define	TCP_DISCONNECT				(-4)	/*ؒf*/
#define	TCP_TIME_OUT				(-5)	/*ڑ^CAEg*/
#define	TCP_ILLEGAL_ANSWER_NUM		(-6)	/*MmFԍقȂ鎞*/
#define	TCP_IS_NOT_ESTABLISHED		(-7)	/*ESTABLISHEDł͂Ȃ*/
#define	TCP_RELOCATE_WAIT			(-8)	/*҂Ԓɋ󂯂*/
#define	TCP_LINK_DOWN				(-9)	/*̃LAꂽB\AƌӖEEEB*/
#define	TCP_FIN_RECIEVED			(-10)	/*TCP̑MFINMB*/
#define	TCP_SYSTEM_ERROR			(-11)	/*݌vxA܂̓J[lẍُ̌o*/
#define	TCP_SEND_RST				(-12)	/*V[PXԍ킸ARST𑗐M*/
#define	TCP_IGNOER_RST				(-13)	/*sRSTM*/
#define	TCP_RETRY_SYN				(-14)	/*RlNVSYN̍ē*/



/********************************************************************/
/*	TCP֐															*/
/********************************************************************/
int		TCPSend( TcpAddressAndPortInformation *info );
void	TCPRcv( IP_RECORD *ipr );
int		TCPsocket( TcpAddressAndPortInformation *info );
int		TCPclose( TcpAddressAndPortInformation *info );
int		TCPbind( TcpAddressAndPortInformation *info );
int		TCPlisten( TcpAddressAndPortInformation *info );
int		TCPaccept( TcpAddressAndPortInformation *info );
int		TCPconnect( TcpAddressAndPortInformation *info );
long	TCPread( TcpAddressAndPortInformation *info, void *buffer, unsigned short len );
long	TCPwrite( TcpAddressAndPortInformation *info, void *buffer, unsigned short len );
void	TCPRegistReceiveBufferArea( TcpAddressAndPortInformation *info, void *buffer, int size );
int		TCPAnnounceReceiveBufferSize( TcpAddressAndPortInformation *info );
void	TCPForceCloseState( TcpAddressAndPortInformation *info );
void	TCPForceCloseStateWithoutRST( TcpAddressAndPortInformation *info );
int		RSTTransmit( const RST_INFORMATION *rst_info, unsigned char state );
