/********************************************************************/
/*	HOS-V4 for SH2/H8300H (ITRON version4.0)						*/
/*	LCD`															*/
/*							Copyright (C) 1998-2002 by hamayan		*/
/********************************************************************/

/*LCD PIN`*/
#define		LCD_D4			PBDR.BIT.B0
#define		LCD_D5			PBDR.BIT.B1
#define		LCD_D6			PBDR.BIT.B2
#define		LCD_D7			PBDR.BIT.B3
#define		LCD_RS			PBDR.BIT.B5
#define		LCD_WR			PBDR.BIT.B6
#define		LCD_E			PBDR.BIT.B7

typedef	struct
{
		unsigned char	E		:1;			/*Eɐڑ*/
		unsigned char	WR		:1;			/*WRɐڑ*/
		unsigned char	RS		:1;			/*RSɐڑ*/
		unsigned char	aki		:1;			/*bit*/
		unsigned char	DATA	:4;			/*D4D7܂ł̐ɐڑ*/
} LCD;

#define	DATA_MODE		0		/*f[^݃[h*/
#define	CMD_MODE		1		/*R}h݃[h*/

#define	FUNCTIONSET		LcdWrite(CMD_MODE,0x28)		/*t@NVZbg4bit[hI*/
#define	DISPLAYOFF		LcdWrite(CMD_MODE,0x08)		/*\OFF*/
#define	DISPLAYON		LcdWrite(CMD_MODE,0x0c | 0x00 | 0x01)	/*\ONAJ[\OFFAuNON*/
#define	BLINKON			LcdWrite(CMD_MODE,0x0c | 0x00 | 0x01)	/*\ONAJ[\OFFAuNON*/
#define	BLINKOFF		LcdWrite(CMD_MODE,0x0c)		/*\ON*/
#define	CURSORON		LcdWrite(CMD_MODE,0x0c | 0x02 | 0x01)	/*\ONAJ[\ONAuNON*/
#define	CURSOROFF		LcdWrite(CMD_MODE,0x0c | 0x00 | 0x01)	/*\ONAJ[\OFFAuNON*/
#if 1
#define	ENTRYMODESET	LcdWrite(CMD_MODE,0x04 | 0x02 | 0x00)	/*CNgAJ[\VtgȂ*/
#else
#define	ENTRYMODESET	LcdWrite(CMD_MODE,0x04 | 0x02 | 0x01)	/*CNgAJ[\VtgB*/
#endif
#define	CURSORHOME		LcdWrite(CMD_MODE,0x02)		/*J[\z[*/
#define	CURSORMOVE		LcdWrite(CMD_MODE,0x10 | 0x00 | 0x04)		/*J[\ړ*/
#define	DISPLAYMOVE		LcdWrite(CMD_MODE,0x10 | 0x08 | 0x04)		/*J[\ړI*/
#define	CLEARDISPLAY	LcdWrite(CMD_MODE,0x01)			/*ʃNA*/

#define	LINE1			LcdWrite(CMD_MODE,0x80+0x00)	/*s*/
#define	LINE2			LcdWrite(CMD_MODE,0x80+0x40)	/*s*/
#define	LINE3			LcdWrite(CMD_MODE,0x80+0x14)	/*Os*/
#define	LINE4			LcdWrite(CMD_MODE,0x80+0x54)	/*ls*/

#define ROWSIZE			16
#define COLSIZE			2

#define LCDBUFFERSIZE	(ROWSIZE * COLSIZE)

/********************************************************************/
/*	LCD֐															*/
/********************************************************************/
