/********************************************************************/
/*	LCDyKEY I/F												*/
/*									2002/03/07 by hamachan			*/
/********************************************************************/

#include	<stdio.h>
#include	<string.h>
#include	"h83068f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"lcd.h"

void LcdWrite( int mode, char c );
static void LcdWrite4( char c );
static LCD	*lcd;

/********************************************************************/
/*	WAIT														*/
/*	1LOOP24VXeNbNB40 * (__CPU_CLOCK__ / 24 / 1000000)	*/
/*	AA\́A[v𑝂₷AŃ^C~O	*/
/*	̒sĉB											*/
/********************************************************************/
static void wait( int tim )
{
	volatile int i;

	i++;
}

/********************************************************************/
/*															*/
/*	LCD4bitoX[hɐݒ肷									*/
/********************************************************************/
void LCDInit( void )
{
	lcd = (LCD *)&PBDR.BYTE;		/*LCD𐧌䂷\̂̎̂*/
	/*\tgEGARESET*/
	lcd->RS = lcd->WR = lcd->E = 0;	/*RS=WR=E=0*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 5 );					/*4.1msȏ҂*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 1 );					/*1msȏ҂*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 1 );					/*1msȏ҂*/
	LcdWrite4( 0x02 );				/*2炵*/
	/*ݒ*/
	FUNCTIONSET;
	FUNCTIONSET;
	DISPLAYOFF;
	ENTRYMODESET;
	CLEARDISPLAY;
	dly_tsk( 1 );					/*҂*/
	CURSORHOME;
	dly_tsk( 1 );					/*҂*/
	DISPLAYON;
	dly_tsk( 10 );					/*҂*/
}

/********************************************************************/
/*	4bitPʂłLCDݏ										*/
/*	cLCDɃR}hނf[^AA4bit̂ݗL		*/
/********************************************************************/
static void LcdWrite4( char c )
{
	lcd->E = 1;						/*Ebit𗧂Ă*/
	lcd->E = 1;						/*Ebit𗧂Ă*/
	lcd->DATA = c;					/*f[^*/
	lcd->DATA = c;					/*f[^*/
	lcd->E = 0;						/*EbitƏ܂*/
}

/********************************************************************/
/*	LCDݏ													*/
/*	modeLCDɃR}hނf[^ނI			*/
/*	modeLCDɃR}hނf[^ނI			*/
/********************************************************************/
void LcdWrite( int mode, char c )
{
	lcd->RS = ( mode == DATA_MODE ) ? 1 : 0;
	LcdWrite4( c >> 4 );						/*4bit*/
	LcdWrite4( c );								/*4bit*/
	dly_tsk( 2 );
}
