/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  ITRON4.0dl Real-Time OS                  */
/*    ITRONJ[l nh                                            */
/*                                                                          */
/*                                  Copyright (C) 1998-2004 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */


#include "knl_cyc.h"



/* nh̃^C}nh */
void kernel_cyc_hdr(
		T_KERNEL_TIM *timobj,	/* ^C}IuWFNg */
		RELTIM       tic)		/* ^CeBbN */
{
	const T_CCYC *ccyc;
	T_KERNEL_CYCCB_RAM *cyccb_ram;
	
	/* upper cast */
	cyccb_ram = (T_KERNEL_CYCCB_RAM *)timobj;
	
	/* ^XN̎s */
	if ( cyccb_ram->lefttim <= tic )
	{
		ccyc = (T_CCYC *)cyccb_ram->cyccb_rom;
				
		/* ̒lݒ */
		cyccb_ram->lefttim += ccyc->cyctim - tic;

		/* nhĂяo */
		mknl_unl_sys();							/* VXẽbN */		
		ccyc->cychdr(ccyc->exinf);	/* nhĂяo */
		mknl_loc_sys();							/* VXẽbN */
	}
	else
	{
		cyccb_ram->lefttim -= tic;
	}
}


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2004 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
