/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  ITRON4.0dl Real-Time OS                  */
/*    ʃJ[l ^XN                                                 */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */


#include "mknl.h"
#include "knl_tsk.h"



/* fB[L[擪̃^XNT */
T_MKNL_TCB* mknl_srh_top(void)
{
	T_MKNL_TCB *mtcb;
	T_MKNL_TCB *mtcb_head,*mtcb_next;
	INT i;
	T_KERNEL_TCB_RAM *tcb_ram;
	const T_KERNEL_TCB_ROM *tcb_rom;

	/* o^\^XNSăfBL[ɐڑ */
	if ( ( mtcb_head = mknl_rdq_tbl[mknl_rdq_cnt].head ) != NULL )
	{
		mtcb      = mtcb_head;
	  	do {
			mtcb_next = mtcb->next;
			/* ^XNReLXg͈Smknl_sta_tskłȂ */
			if ( mtcb != mknl_get_run_tsk() ) {
				tcb_ram = KERNEL_STATIC_CAST(T_KERNEL_TCB_RAM, mtcb, mtcb);
				tcb_rom = tcb_ram->tcb_rom;
				mknl_rmv_que(mtcb);
				mknl_sta_tsk(
					mtcb,
					tcb_rom->exinf,
					(FP)kernel_task_entry,
					tcb_rom->itskpri,
					tcb_rom->stksz,
					tcb_rom->stk
				);
			}
			mtcb = mtcb_next;
		} while ( mtcb != mtcb_head);
	}

	/* ōDx̎s\^XNT */
	for ( i = 0; i < mknl_rdq_cnt; i++ )	/* Dx̍L[珇Ɍ */
	{
		if ( mknl_rdq_tbl[i].head != NULL )	/* fBL[ɂ͎s\^XNȂ */
		{
			return mknl_rdq_tbl[i].head;
		}
	}

	return NULL;	/* s\^XN */
}


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
